;---Acronyms Script by mr.man (c) 2005 (Part of NeXtGenIRC)

;---VARIOUS ALIASES---

alias acronyms {
  dialog -m acronyms acronyms
}

alias -l inifile {
  return $+(",$scriptdir,settings\acronyms.ini,")
}

alias -l makedefsettings {
  var %t = acronyms
  hadd %t active 1
  hadd %t texts lol,rofl
  hadd %t lol Laugh Out Loud
  hadd %t rofl Rolling on the Floor Laughing
  savesettings
}

alias -l savesettings {
  if (!%restart) {
    var %t = acronyms
    hsave -i %t $inifile Settings
  }
}

alias -l loadsettings {
  var %t = acronyms
  if ($hget(%t)) { hfree %t }
  hmake %t 40
  if ($exists($inifile)) {
    hload -i %t $inifile Settings
  }
}

;---DIALOG STUFF---

dialog acronyms {
  title "Acronyms"
  size -1 -1 363 292
  option pixels
  tab "Settings", 1, 3 73 356 186
  list 4, 24 120 313 111, tab 1 size
  box "Acronym Definitions", 9, 13 99 335 146, tab 1
  tab "Options", 12
  box "Disable for these Channels", 13, 187 99 161 146, tab 12
  list 14, 24 120 143 111, tab 12 size
  box "No Colours for these Channels", 18, 13 99 166 146, tab 12
  list 19, 199 120 138 111, tab 12 size
  button "OK", 8, 285 264 75 22, ok
  check "Activate Acronyms", 11, 4 265 150 20
  icon 2, -3 -1 368 64, $scriptdir $+ libraries\icons\acroheader.png, noborder
}

on *:dialog:acronyms:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 4 listview single rowselect showsel alignleft report > $views
  did -i $dname 4 1 headerdims 80:1 210:2
  did -i $dname 4 1 headertext 0 Acronym $+ $chr(9) $+ 0 Text
  mdx SetControlMDX 14 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 14 1 headerdims 120:1
  did -i $dname 14 1 headertext 0 Channels
  mdx SetControlMDX 19 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 19 1 headerdims 115:1
  did -i $dname 19 1 headertext 0 Channels
  loadsettings
  if ($hget(acronyms,active) == 1) {
    did -c acronyms 11
  }
  else {
    did -u acronyms 11
  }
  fillacros
  var %l = 1, %chans = $sorttok($hget(acronyms,mono),32)
  while (%l <= $numtok(%chans,32)) {
    var %chan = $gettok(%chans,%l,32) 
    did -a $dname 14 + 0 0 0 %chan
    inc %l
  }
  var %l = 1, %chans = $sorttok($hget(acronyms,disable),32)
  while (%l <= $numtok(%chans,32)) {
    var %chan = $gettok(%chans,%l,32) 
    did -a $dname 19 + 0 0 0 %chan
    inc %l
  }
}

on *:dialog:acronyms:sclick:4:{
  if ($gettok($did($dname,4,1),1,32) == rclick) {
    acropop $did(4).sel $gettok($gettok($did(4).seltext,6,32),1,9)
  }
}

on *:dialog:acronyms:sclick:14:{
  if ($gettok($did($dname,14,1),1,32) == rclick) {
    monopop $did(14).sel $gettok($gettok($did(14).seltext,6,32),1,9)
  }
}

on *:dialog:acronyms:sclick:19:{
  if ($gettok($did($dname,19,1),1,32) == rclick) {
    exclpop $did(19).sel $gettok($gettok($did(19).seltext,6,32),1,9)
  }
}

on *:dialog:acronyms:sclick:11:{
  hadd acronyms active $did($dname,11).state
  savesettings
}

;---POPUPS---

alias acropop {
  popups New acro 16 16
  popups SetMetrics acro iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem acro end + Add $cr addacro
  popups AddItem acro end + Delete $cr delacro $1 $2
  popups AddItem acro end
  popups AddItem acro end + Edit $cr editacro $1 $2
  popup acro $mouse.dx $mouse.dy
}

alias monopop {
  popups New mono 16 16
  popups SetMetrics mono iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem mono end + Add $cr addmono
  popups AddItem mono end + Delete $cr delmono $1 $2
  popup mono $mouse.dx $mouse.dy
}

alias exclpop {
  popups New excl 16 16
  popups SetMetrics excl iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem excl end + Add $cr addexcl
  popups AddItem excl end + Delete $cr delexcl $1 $2
  popup excl $mouse.dx $mouse.dy
}

;---MORE STUFF---

alias addmono {
  var %mono = $input(Please enter a Channel Name.,equ,Query...,$null)
  hadd acronyms mono $addtok($hget(acronyms,mono),%mono,32)
  savesettings
  did -a acronyms 14 + 0 0 0 %mono
}

alias delmono {
  did -d acronyms 14 $1
  hadd acronyms mono $remtok($hget(acronyms,mono),$2,32)
  savesettings
}

alias addexcl {
  var %excl = $input(Please enter a Channel Name.,equ,Query...,$null)
  hadd acronyms disable $addtok($hget(acronyms,disable),%excl,32)
  savesettings
  did -a acronyms 19 + 0 0 0 %excl
}

alias delexcl {
  did -d acronyms 19 $1
  hadd acronyms disable $remtok($hget(acronyms,disable),$2,32)
  savesettings
}

alias fillacros {
  var %l = 1, %acros = $sorttok($hget(acronyms,texts),44)
  while (%l <= $numtok(%acros,44)) {
    var %acro = $gettok(%acros,%l,44), %text = $readini($inifile,settings,%acro) 
    did -a acronyms 4 + 0 0 0 %acro $+ $chr(9) $+ + 0 0 0 %text
    inc %l
  }
}

dialog newacro {
  title "Acronyms"
  size -1 -1 250 226
  option pixels
  tab "Add...", 1, 4 72 240 120
  box "Enter New Acronym", 6, 11 97 226 82, tab 1
  text "Acronym:", 3, 45 122 50 16, tab 1
  text "Replaced Text:", 2, 19 148 74 16, tab 1
  edit "", 5, 95 118 133 23, tab 1 autohs
  edit "", 4, 95 143 133 23, tab 1 autohs
  button "OK", 7, 170 198 75 22, ok
  icon 8, -2 0 253 64, $scriptdir $+ libraries\icons\newacroheader.png, noborder
}

on *:dialog:newacro:init:0:{
  did -b $dname 7
  did -f $dname 5
}

on *:dialog:newacro:edit:4:{
  if ($did($dname,4) && $did($dname,5)) {
    did -e $dname 7
  }
  else {
    did -b $dname 7
  }
}

on *:dialog:newacro:edit:5:{
  if ($did($dname,4) && $did($dname,5)) {
    did -e $dname 7
  }
  else {
    did -b $dname 7
  }
}

on *:dialog:newacro:sclick:7:{
  if ($did($dname,4) && $did($dname,5)) {
    if (!$istok($hget(acronyms,texts),$did($dname,5),44)) {
      hadd acronyms $did($dname,5) $did($dname,4)
      hadd acronyms texts $addtok($hget(acronyms,texts),$did($dname,5),44)
      savesettings
    }
  }
  did -r acronyms 4
  fillacros
}

dialog editacro {
  title "Acronyms"
  size -1 -1 251 227
  option pixels
  tab "Edit...", 1, 4 73 240 120
  box "Edit Acronym", 6, 11 98 226 82, tab 1
  text "Acronym:", 3, 45 123 50 16, tab 1
  text "Replaced Text:", 2, 19 149 74 16, tab 1
  edit "", 5, 95 119 133 23, tab 1 read autohs
  edit "", 4, 95 144 133 23, tab 1 autohs
  button "OK", 7, 188 199 57 22, ok
  button "Cancel", 8, 126 199 59 22, cancel
  icon 9, -2 0 254 64, $scriptdir $+ libraries\icons\editacroheader.png, noborder
}

on *:dialog:editacro:init:0:{
  did -b $dname 7
  did -f $dname 4
}

on *:dialog:editacro:edit:4:{
  if ($did($dname,4) && $did($dname,5)) {
    did -e $dname 7
  }
  else {
    did -b $dname 7
  }
}

on *:dialog:editacro:sclick:7:{
  if ($did($dname,4) && $did($dname,5)) {
    if ($istok($hget(acronyms,texts),$did($dname,5),44)) {
      hadd acronyms $did($dname,5) $did($dname,4)
      savesettings
    }
  }
  did -r acronyms 4
  fillacros
}

alias addacro {
  dialog -m newacro newacro
}

alias delacro {
  did -d acronyms 4 $1
  hadd acronyms texts $remtok($hget(acronyms,texts),$2,44)
  hdel acronyms $2
  savesettings
}

alias editacro {
  dialog -m editacro editacro
  did -ar editacro 5 $2
}

;---EVENTS STUFF---

on *:start:{
  loadsettings
}

on *:exit:{
  savesettings
}

;---MAIN DECORATION ALIAS---

alias acronym {
  var %pri = $hget(various,PriCol)
  var %sec = $hget(various,SecCol)
  var %f = $1-
  var %n = $numtok(%f,32)
  tokenize 32 %f
  var %i = 1
  var %t = $null
  while (%i <= %n) {
    var %w = $ $+ %i
    %t = %t  $+ %pri $+ $upper($left( [ %w ] ,1)) $+  $+ %sec $+ $right( [ %w ] ,-1)
    inc %i
  }
  if ($istok($hget(acronyms,mono),$active,32) || (c isin $chan($active).mode)) {
    return $strip(%t $+ )
  }
  else {
    return %t $+ 
  }
}

alias acro {
  say $acronym($1-)
}

alias trans {
  var %t = $1-
  if ($istok($hget(acronyms,disable),$active,32)) {
    return %t
  }
  var %n = $numtok(%t,32)
  tokenize 32 %t
  var %l = 1
  while (%l <= %n) {
    var %w = $ $+ %l
    if ($istok($hget(acronyms,texts),$(%w,2),44)) {
      var %text = %text $acronym($hget(acronyms,$(%w,2)))
    }
    else {
      var %text = %text $(%w,2)
    }
    inc %l
  }
  return %text
}
