;---Blowfish Encryption/Decryption Script by mr.man (C) 2005---

;---VARIOUS ALIASES---

alias blowfish {
  dialog -m blowfish blowfish
}

alias decrypt {
  return $dll($scriptdir $+ libraries\blowfish.dll,Decrypt,$1 $2-)
}

alias encrypt {
  return $dll($scriptdir $+ libraries\blowfish.dll,Encrypt,$1 $2-)
}

alias -l keyring {
  return $+(",$scriptdir,settings\keyring.dat,")
}

alias -l loadsettings {
  var %h = blowfish
  if ($hget(%h)) { hfree %h }
  hmake %h 10
  hload -i %h $keyring Keyring
}

;---EVENTS STUFF---

on *:start: {
  loadsettings
}

;---DIALOG STUFF---

dialog blowfish {
  title "Blowfish Decryption/Encryption"
  size -1 -1 356 310
  option pixels
  tab "Settings", 1, 6 75 344 202
  box "Keyring", 3, 15 100 326 164, tab 1
  list 4, 25 117 304 135, tab 1 size
  button "OK", 2, 276 282 75 22, ok
  icon 5, -2 1 362 64, $scriptdir $+ libraries\icons\fishheader.png, noborder
}

on *:dialog:blowfish:init:0: {
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 4 listview single rowselect showsel alignleft report > $views
  did -i $dname 4 1 headerdims 100:1 180:2
  did -i $dname 4 1 headertext 0 Channel $+ $chr(9) $+ 0 Key
  fillkeys
}

on *:dialog:blowfish:sclick:2:{
  dialog -v cpanel
}

on *:dialog:blowfish:sclick:4:{
  if ($gettok($did($dname,4,1),1,32) == rclick) {
    blowpop $did(4).sel $gettok($gettok($did(4).seltext,6,32),1,9)
  }
}

;---MORE ALIASES & DIALOGS---

alias fillkeys {
  var %l = 1, %keys = $sorttok($hget(blowfish,keys),44)
  while (%l <= $numtok(%keys,44)) {
    var %chan = $gettok(%keys,%l,44), %key = $readini($keyring,n,Keyring,%chan)
    did -a blowfish 4 + 0 0 0 %chan $+ $chr(9) $+ + 0 0 0 %key
    inc %l
  }
}

dialog addkey {
  title "Blowfish Key"
  size -1 -1 249 155
  option pixels
  tab "Add...", 1, 4 4 240 120
  box "Enter New Key", 6, 11 29 226 82, tab 1
  text "Channel:", 3, 15 54 50 16, tab 1 right
  text "Key:", 2, 18 80 47 16, tab 1 right
  edit "", 5, 67 50 160 23, tab 1 autohs
  edit "", 4, 67 75 160 23, tab 1 autohs
  button "OK", 7, 170 126 75 25, Ok
}

on *:dialog:addkey:init:0:{
  did -b $dname 7
  did -f $dname 5
}

on *:dialog:addkey:edit:4:{
  if ($did($dname,4) && $did($dname,5)) {
    did -e $dname 7
  }
  else {
    did -b $dname 7
  }
}

on *:dialog:addkey:edit:5:{
  if ($did($dname,4) && $did($dname,5)) {
    did -e $dname 7
  }
  else {
    did -b $dname 7
  }
}

on *:dialog:addkey:sclick:7:{
  if ($did($dname,4) && $did($dname,5)) {
    if (!$istok($hget(blowfish,keys),$did($dname,5),44)) {
      hadd blowfish keys $addtok($hget(blowfish,keys),$did($dname,5),44)
      hadd blowfish $did($dname,5) $did($dname,4)
      writeini $keyring Keyring keys $hget(blowfish,keys)
      writeini $keyring Keyring $did($dname,5) $did($dname,4)
    }
  }
  did -r blowfish 4
  fillkeys
}

alias addkey {
  dialog -m addkey addkey
}

alias delkey {
  did -d blowfish 4 $1
  hadd blowfish keys $remtok($hget(blowfish,keys),$2,44)
  hdel blowfish $2
  writeini $keyring Keyring keys $hget(blowfish,keys)
  remini $keyring Keyring $2
}

alias editkey {
  dialog -m editkey editkey
  did -ar editkey 5 $2
}

dialog editkey {
  title "Blowfish Key Edit"
  size -1 -1 249 155
  option pixels
  tab "Edit...", 1, 4 4 240 120
  box "Edit Key", 6, 11 29 226 82, tab 1
  text "Channel:", 3, 25 54 45 16, tab 1
  text "Key:", 2, 45 80 24 16, tab 1
  edit "", 5, 70 50 155 23, tab 1 read autohs
  edit "", 4, 70 75 155 23, tab 1 autohs
  button "OK", 7, 188 126 57 25, ok
  button "Cancel", 8, 126 126 59 25, cancel
}

on *:dialog:editkey:init:0:{
  did -b $dname 7
  did -f $dname 4
}

on *:dialog:editkey:edit:4:{
  if ($did($dname,4) && $did($dname,5)) {
    did -e $dname 7
  }
  else {
    did -b $dname 7
  }
}

on *:dialog:editkey:sclick:7:{
  if ($did($dname,4) && $did($dname,5)) {
    if ($istok($hget(blowfish,keys),$did($dname,5),44)) {
      hadd blowfish $did($dname,5) $did($dname,4)
      writeini $keyring Keyring keys $hget(blowfish,keys)
      writeini $keyring Keyring $did($dname,5) $did($dname,4)
    }
  }
  did -r blowfish 4
  fillkeys
}

;---POPUPS---

alias blowpop {
  popups New blow 16 16
  popups SetMetrics blow iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem blow end + Add $cr addkey
  popups AddItem blow end + Delete $cr delkey $1 $2
  popups AddItem blow end
  popups AddItem blow end + Edit $cr editkey $1 $2
  popup blow $mouse.dx $mouse.dy
}
