;---EMAIL CHECKER by mr.man (c) 2008 Part of NeXtGenIRC---

on *:start: {
  loadsettings
}

on *:exit: {
  savesettings
}

;---ALIASES---

alias -l savesettings {
  if (!%restart) {
    hsave -i email $emailini Settings
  }
}

alias -l loadsettings {
  var %t = email
  if ($hget(%t)) { hfree %t }
  hmake %t 40
  if ($exists($emailini)) {
    hload -i %t $emailini Settings
  }
}

alias emailini {
  return $+(",$scriptdir,settings\email.ini,")
}

alias gotmail {
  did -o toolbar 5 2 2 $chr(9) $+ $1 Message(s)
}

alias nomail {
  did -o toolbar 5 2 1 $chr(9) $+ No Messages
}

;---DIALOG STUFF---

alias email {
  hadd email rec 0
  hadd email num 0
  nomail
  if (!$dialog(email)) {
    dialog -m email email
  }
}

dialog email {
  title "Email Checker"
  size -1 -1 323 322
  option pixels
  tab "Settings", 1, 5 74 311 212
  box "Checker Settings", 6, 13 97 178 55, tab 1
  check "Email Checker Active", 7, 6 293 140 20, tab 1
  text "Check mail every", 10, 25 120 82 16, tab 1
  edit "", 11, 110 116 45 23, tab 1 center
  text "mins", 12, 158 120 23 16, tab 1
  list 3, 22 171 278 92, tab 1 size
  box "Email Accounts", 2, 13 155 296 119, tab 1
  check "Beep", 13, 209 118 44 20, tab 1
  box "On Receive", 5, 198 97 111 55, tab 1
  check "Msg", 14, 258 118 40 20, tab 1
  icon 8, -2 0 326 64, $scriptdir $+ libraries\icons\emailheader.png, 0, tab 1 noborder
  button "OK", 4, 242 292 75 22, tab 1 ok
  button "Check Now", 9, 162 292 75 22, tab 1
}

on *:dialog:email:init:0: {
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 3 listview single sortascending rowselect showsel report > $views
  did -i $dname 3 1 headerdims 255:1
  did -i $dname 3 1 headertext 0 Name
  did -i $dname 3 1 iconsize normal small
  did -i $dname 3 1 seticon list $shortfn($scriptdirlibraries\icons\address.ico)
  fillemailaxx
  if ($hget(email,active)) {
    did -c $dname 7
  }
  if ($hget(email,beep)) {
    did -c $dname 13
  }
  if ($hget(email,msg)) {
    did -c $dname 14
  }
  did -ar $dname 11 $hget(email,checktime)
}

on *:dialog:email:sclick:3:{
  if ($gettok($did($dname,3,1),1,32) == rclick) {
    accountspop $did(3).sel $gettok($gettok($did(3).seltext,6,32),1,9)
  }
}

on *:dialog:email:sclick:9:{
  performcheck show
}

on *:dialog:email:sclick:7:{
  var %active = $did($dname,7).state
  hadd email active %active
  if (%active) {
    .timeremail 0 $calc($hget(email,checktime) * 60) performcheck
  }
  else {
    .timeremail off
  }
}

on *:dialog:email:sclick:14:{
  hadd email msg $did($dname,14).state
}

on *:dialog:email:sclick:13:{
  hadd email beep $did($dname,13).state
}

on *:dialog:email:edit:11:{
  hadd email checktime $did($dname,11)
}

alias performcheck {
  ;hadd email rec 0
  hadd email num 0
  checkmail 1 $1
}

alias accountspop {
  popups New accountspopup 16 16
  popups SetMetrics accountspopup iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem accountspopup end + Add $cr newemailacc
  popups AddItem accountspopup end + Delete $cr delemailacc $1 $2
  if ($2) {
    popups AddItem accountspopup end +
    popups AddItem accountspopup end + Edit $2 $cr editemailacc $1 $2
  }
  popup accountspopup $mouse.dx $mouse.dy
}

alias emailaxxini {
  return $+(",$scriptdir,settings\emailaxx.ini,")
}

alias fillemailaxx {
  did -r email 3
  var %l = 1, %accounts = $readini($emailaxxini,Accounts,accounts)
  while (%l <= $numtok(%accounts,42)) {
    var %name = $readini($emailaxxini,$gettok(%accounts,%l,42),name)
    did -a email 3 + 1 0 0 %name
    inc %l
  }
}

alias delemailacc {
  remini $emailaxxini $2
  var %accounts = $readini($emailaxxini,Accounts,accounts)
  writeini $emailaxxini Accounts accounts $remtok(%accounts,$2,42) $ $+ null
  fillemailaxx
}

alias newemailacc {
  if (!$dialog(newemailacc)) {
    dialog -m newemailacc newemailacc
  }
}

dialog newemailacc {
  title "New Account"
  size -1 -1 384 371
  option pixels
  tab "Email Settings", 1, 6 74 370 262
  box "Details", 2, 14 97 355 227, tab 1
  text "Name:", 3, 61 129 85 16, tab 1 right
  text "Email Address:", 5, 31 160 115 16, tab 1 right
  edit "", 6, 147 125 199 23, tab 1 autohs
  edit "", 7, 147 156 199 23, tab 1 autohs
  text "Incoming Mail Server:", 8, 31 191 115 16, tab 1 right
  edit "", 9, 147 187 199 23, tab 1 autohs
  text "Password:", 13, 31 284 115 16, tab 1 right
  text "Username:", 12, 61 253 85 16, tab 1 right
  edit "", 11, 147 218 147 23, tab 1 autohs
  edit "", 14, 147 249 199 23, tab 1 autohs
  edit "", 15, 147 280 199 23, tab 1 autohs
  text "Incoming Mail Port:", 10, 31 222 115 16, tab 1 right
  check "SSL", 16, 307 220 38 20, tab 1
  button "OK", 4, 302 341 75 22, disable ok
  icon 31, -2 0 387 64,  $scriptdir $+ libraries\icons\newemailaccheader.png, 0, noborder
}

on *:dialog:newemailacc:init:0: {
  if ($sslready) {
    did -e $dname 16
  }
  else {
    did -b $dname 16
  }
  did -f $dname 6
}

on *:dialog:newemailacc:sclick:4: {
  var %accounts = $readini($emailaxxini,Accounts,accounts)
  writeini $emailaxxini Accounts accounts $addtok(%accounts,$did($dname,6),42)
  writeini $emailaxxini $did($dname,6) name $did($dname,6)
  writeini $emailaxxini $did($dname,6) address $did($dname,7)
  writeini $emailaxxini $did($dname,6) incoming $did($dname,9)
  writeini $emailaxxini $did($dname,6) incomingport $did($dname,11)
  writeini $emailaxxini $did($dname,6) username $did($dname,14)
  writeini $emailaxxini $did($dname,6) password $did($dname,15)
  writeini $emailaxxini $did($dname,6) ssl $did($dname,16).state  
  fillemailaxx
}

on *:dialog:newemailacc:edit:6: {
  if ($did($dname,6)) && ($did($dname,7)) && ($did($dname,9)) && ($did($dname,11)) && ($did($dname,14)) && ($did($dname,15)) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:newemailacc:edit:7: {
  if ($did($dname,6)) && ($did($dname,7)) && ($did($dname,9)) && ($did($dname,11)) && ($did($dname,14)) && ($did($dname,15)) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:newemailacc:edit:9: {
  if ($did($dname,6)) && ($did($dname,7)) && ($did($dname,9)) && ($did($dname,11)) && ($did($dname,14)) && ($did($dname,15)) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:newemailacc:edit:11: {
  if ($did($dname,6)) && ($did($dname,7)) && ($did($dname,9)) && ($did($dname,11)) && ($did($dname,14)) && ($did($dname,15)) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:newemailacc:edit:14: {
  if ($did($dname,6)) && ($did($dname,7)) && ($did($dname,9)) && ($did($dname,11)) && ($did($dname,14)) && ($did($dname,15)) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:newemailacc:edit:15: {
  if ($did($dname,6)) && ($did($dname,7)) && ($did($dname,9)) && ($did($dname,11)) && ($did($dname,14)) && ($did($dname,15)) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

alias editemailacc {
  if (!$dialog(editemailacc)) {
    hadd email editname $2
    dialog -m editemailacc editemailacc
  }
}

dialog editemailacc {
  title "Edit Account"
  size -1 -1 385 371
  option pixels
  tab "Email Settings", 1, 7 75 370 262
  box "Details", 2, 15 98 355 227, tab 1
  text "Name:", 3, 62 130 85 16, tab 1 right
  text "Email Address:", 5, 32 161 115 16, tab 1 right
  edit "", 6, 148 126 199 23, tab 1 autohs
  edit "", 7, 148 157 199 23, tab 1 autohs
  text "Incoming Mail Server:", 8, 32 192 115 16, tab 1 right
  edit "", 9, 148 188 199 23, tab 1 autohs
  text "Password:", 13, 32 285 115 16, tab 1 right
  text "Username:", 12, 62 254 85 16, tab 1 right
  edit "", 11, 148 219 151 23, tab 1 autohs
  edit "", 14, 148 250 199 23, tab 1 autohs
  edit "", 15, 148 281 199 23, tab 1 autohs
  text "Incoming Mail Port:", 10, 32 223 115 16, tab 1 right
  check "SSL", 16, 308 222 40 20, tab 1
  button "OK", 4, 303 342 75 22, ok
  icon 31, -2 0 388 64,  $scriptdir $+ libraries\icons\editemailheader.png, 0, noborder
}

on *:dialog:editemailacc:init:0: {
  var %name = $hget(email,editname)
  did -ar $dname 6 %name
  did -ar $dname 7 $readini($emailaxxini,%name,address)
  did -ar $dname 9 $readini($emailaxxini,%name,incoming)
  did -ar $dname 11 $readini($emailaxxini,%name,incomingport)
  did -ar $dname 14 $readini($emailaxxini,%name,username)
  did -ar $dname 15 $readini($emailaxxini,%name,password)
  did -f $dname 6
  if ($sslready) {
    did -e $dname 16
  }
  else {
    did -b $dname 16
  }
  if ($readini($emailaxxini,%name,ssl)) {
    did -c $dname 16
  }
}

on *:dialog:editemailacc:sclick:4: {
  writeini $emailaxxini $did($dname,6) name $did($dname,6)
  writeini $emailaxxini $did($dname,6) address $did($dname,7)
  writeini $emailaxxini $did($dname,6) incoming $did($dname,9)
  writeini $emailaxxini $did($dname,6) incomingport $did($dname,11)
  writeini $emailaxxini $did($dname,6) username $did($dname,14)
  writeini $emailaxxini $did($dname,6) password $did($dname,15)
  writeini $emailaxxini $did($dname,6) ssl $did($dname,16).state
  fillemailaxx
}

on *:dialog:editemailacc:edit:6: {
  if ($did($dname,6)) && ($did($dname,7)) && ($did($dname,9)) && ($did($dname,11)) && ($did($dname,14)) && ($did($dname,15)) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:editemailacc:edit:7: {
  if ($did($dname,6)) && ($did($dname,7)) && ($did($dname,9)) && ($did($dname,11)) && ($did($dname,14)) && ($did($dname,15)) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:editemailacc:edit:9: {
  if ($did($dname,6)) && ($did($dname,7)) && ($did($dname,9)) && ($did($dname,11)) && ($did($dname,14)) && ($did($dname,15)) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:editemailacc:edit:11: {
  if ($did($dname,6)) && ($did($dname,7)) && ($did($dname,9)) && ($did($dname,11)) && ($did($dname,14)) && ($did($dname,15)) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:editemailacc:edit:14: {
  if ($did($dname,6)) && ($did($dname,7)) && ($did($dname,9)) && ($did($dname,11)) && ($did($dname,14)) && ($did($dname,15)) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:editemailacc:edit:15: {
  if ($did($dname,6)) && ($did($dname,7)) && ($did($dname,9)) && ($did($dname,11)) && ($did($dname,14)) && ($did($dname,15)) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

;---CHECK MAIL---

alias showprogress {
  dialog -m showprogress showprogress
}

dialog showprogress {
  title "Send/Receive Progress"
  size -1 -1 299 69
  option pixels
  text "Receiving...", 1, 11 15 278 16
  text "", 2, 11 39 278 13
}

on *:dialog:showprogress:init:0: {
  mdx MarkDialog $dname
  mdx SetControlMDX $dname 2 Progressbar > $ctl
  did -a $dname 2 0 0 $hget(email,numofaxx)
}

alias checkmail {
  sockclose email
  var %l = $1, %accounts = $readini($emailaxxini,Accounts,accounts)
  if ($2 == show) {
    hadd email numofaxx $numtok(%accounts,42)
    showprogress
  }
  var %name = $gettok(%accounts,%l,42)
  if (%name) {
    hadd email account %l
    hadd email incoming $readini($emailaxxini,%name,incoming)
    hadd email inport $readini($emailaxxini,%name,incomingport)
    hadd email user $readini($emailaxxini,%name,username)
    hadd email pass $readini($emailaxxini,%name,password)
    hadd email ssl $readini($emailaxxini,%name,ssl)
    if ($hget(email,ssl)) {
      sockopen -e email $hget(email,incoming) $hget(email,inport)    
    }
    else {
      sockopen email $hget(email,incoming) $hget(email,inport)
    }
    if ($dialog(showprogress)) {
      did -a showprogress 2 $hget(email,account)
    }
    hinc email account
  }
  else {
    if ($hget(email,num) > $hget(email,rec)) {
      hadd email rec $hget(email,num)
      gotmail $hget(email,num)
      if ($hget(email,beep)) {
        splay mail.wav
      }
      if ($hget(email,msg)) {
        emailnotify $hget(email,num)
      }
    }
    if ($dialog(showprogress)) {
      dialog -x showprogress
    }
    unset %temp
  }
}

on *:sockopen:email: {
  sockmark $sockname CONN
}

on *:sockread:email:{
  if ($sockerr > 0) {
    theme.error An error occured while trying to connect to your email server.
    return
  }
  :nextread
  sockread %temp
  if ($sockbr == 0) return
  if (%temp == $null) %temp = -
  tokenize 32 %temp
  if ($1 == +OK) {
    if ($sock($sockname).mark == CONN) {
      sockmark $sockname USER
      sockwrite -n $sockname USER $hget(email,user)
      return
    }
    if ($sock($sockname).mark == USER) {
      sockmark $sockname PASS
      sockwrite -n $sockname PASS $hget(email,pass)
      return
    }
    if ($sock($sockname).mark == PASS) {
      sockmark $sockname STAT
      sockwrite -n $sockname STAT
      return
    }
    if ($sock($sockname).mark == STAT) { 
      hinc email num $2
      hadd email size $3
      sockmark $sockname QUIT
      sockwrite -n $sockname QUIT
      sockclose email
      checkmail $hget(email,account)
      return
    }
  }
  else {
    theme.error An error occured while trying to check your email.
    sockclose email
    if ($dialog(showprogress)) {
      dialog -x showprogress
    }
    return
  }
  goto nextread
}

;---NOTIFY MESSAGE---

alias emailnotify {
  mtooltips SetTooltipWidth 
  mtooltips SpawnTooltip +a $calc($window(-1).w - 310) $calc($window(-1).h - 100) 5000 > New Email Received: $chr(4) $1- Message(s)
  var %pos = $dll($+(",$scriptdir,libraries\mtooltips.dll,"), TooltipSize, 1) 
  mtooltips MoveTooltip 1 $calc($window(-1).w - $gettok(%pos,2,32) - 30) $calc($window(-1).h - $gettok(%pos,3,32) - 30)
}
