;---LOG VIEWER by mr.man (C) 2008 - Part of NeXtGenIRC---

;---EVENTS---

on *:start:{ hmake logs 32 }

on *:exit:{ hfree logs }

;---ALIASES---

alias logviewer {
  if (!$dialog(logviewer)) {
    dialog -m logviewer logviewer
  }
}

;---DIALOG STUFF---

dialog logviewer {
  title "Log Viewer"
  size -1 -1 477 516
  option pixels
  tab "Channel Logs", 1, 4 72 467 410
  box "Log Display", 6, 13 160 449 308, tab 1
  button "", 7, 24 178 428 278, tab 1
  text "Select Channel:", 4, 239 120 82 16, tab 1 right
  combo 15, 328 117 120 130, tab 1 size drop
  combo 3, 111 117 120 130, tab 1 size drop
  box "Select Log", 2, 13 96 449 61, tab 1
  text "Select Network:", 5, 21 120 82 16, tab 1 right
  tab "Query Logs", 9
  button "", 11, 24 178 428 278, tab 9
  box "Log Display", 12, 13 160 449 308, tab 9
  box "Select Log", 16, 13 96 449 61, tab 9
  text "Select Network:", 17, 21 120 82 16, tab 9 right
  combo 18, 111 117 120 130, tab 9 size drop
  text "Select Nickname:", 19, 239 120 82 16, tab 9 right
  combo 20, 328 117 120 130, tab 9 size drop
  button "OK", 8, 397 488 75 22, ok
  icon 10, -2 0 480 64, $scriptdir $+ libraries\icons\logviewheader.png, noborder
}

on *:dialog:logviewer:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX $dname 7 window > $dlg
  window -ah @chanlog
  did -a $dname 7 grab $window(@chanlog).hwnd @chanlog
  mdx SetControlMDX $dname 11 window > $dlg
  window -ah @querylog
  did -a $dname 11 grab $window(@querylog).hwnd @querylog
  listnets
}

alias listnets {
  hadd logs nets $null
  window -lh @logslist
  noop $findfile($mircdir $+ logs,*.log,@logslist)
  var %l = 1, %nets = $null
  while (%l <= $line(@logslist,0)) {
    tokenize 46 $nopath($line(@logslist,%l))
    if ($0 = 3) {
      hadd logs nets $addtok($hget(logs,nets),$2,32))
    }
    else if ($0 == 2) {
      ;do nothing!
    }
    else if ($0 == 4) {
      if ($3 !isnum) {
        hadd logs nets $addtok($hget(logs,nets),$3,32))
      }
    }
    inc %l
  }
  didtok logviewer 3 32 $hget(logs,nets)
  didtok logviewer 18 32 $hget(logs,nets)
}

on *:dialog:logviewer:sclick:3:{
  hadd logs chans $null
  did -r $dname 15
  var %n = $did($dname,3).text, %l = 1, %chans = $null
  while (%l <= $line(@logslist,0)) {
    tokenize 46 $nopath($line(@logslist,%l))
    if ($left($1,1) == $chr(35)) && (%n == $2) {
      hadd logs chans $addtok($hget(logs,chans),$1,32))
    }
    inc %l
  }
  didtok logviewer 15 32 $hget(logs,chans)
}

on *:dialog:logviewer:sclick:15:{
  var %c = $did($dname,15).text, %file = $+(%c,.,$did($dname,3).text,.log)
  loadbuf -rpi @chanlog $+(",$mircdir,\logs\,%file,")
}

on *:dialog:logviewer:sclick:18:{
  hadd logs querys $null
  did -r $dname 20
  var %n = $did($dname,18).text, %l = 1, %chans = $null
  while (%l <= $line(@logslist,0)) {
    tokenize 46 $nopath($line(@logslist,%l))
    if ($left($1,1) != $chr(35)) && (%n == $2) {
      hadd logs querys $addtok($hget(logs,querys),$1,32))
    }
    inc %l
  }
  didtok logviewer 20 32 $hget(logs,querys)
}

on *:dialog:logviewer:sclick:20:{
  var %c = $did($dname,20).text, %file = $+(%c,.,$did($dname,18).text,.log)
  loadbuf -rpi @querylog $+(",$mircdir,\logs\,%file,")
}

on *:dialog:logviewer:sclick:8:{
  window -c @logslist
}
