;---Mp3 System by mr.man (c) 2005 (Part of NeXtGenIRC)---

;---VARIOUS ALIASES---

alias mp3.eject {
  var %f = $+(",$scriptdir,settings\mp3.txt,")
  var %m = $msfile($hget(mp3,dir),Select Mp3's,Ok), %t = 1
  .remove %f
  if (%m == 1) && ($right($msfile(1),4) == .m3u) {
    var %p = $nofile($msfile(1)), %m3u = @m3u.list, %i = 1, %mp3 = @mp3.list
    window -lh %m3u
    window -lh %mp3
    loadbuf %m3u $+(",$msfile(1),")
    filter -cwwx %m3u %m3u #*
    while (%t <= $line(%m3u,0)) {
      if ($line(%m3u,%t)) {
        var %l = $ifmatch
        if ($nopath(%l) == %l) {
          aline %mp3 %p $+ %l
        }
        else {
          aline %mp3 %l
        }
        inc %t
      }
    }
    savebuf %mp3 %f
    window -c %mp3
    window -c %m3u
    hadd mp3 TrackNo 1
    mp3.play
  }
  else {
    while (%t <= %m) {
      write %f $msfile(%t)
      inc %t
    }
  }
  if ($exists(%f)) {
    theme.text $s.head(Mp3's Selected...) $s.encleft $+ $s.value($lines(%f)) $+ $s.encright 
    hadd mp3 TrackNo 1
  }
}

alias mp3player {
  dialog -m mp3player mp3player
}

alias -l inifile {
  return $+(",$scriptdir,settings\mp3.ini,")
}

alias -l loadsettings {
  var %h = mp3
  if ($hget(%h)) { hfree %h }
  hmake %h 10
  hload -i %h $inifile Settings
}

alias -l makedefaultsettings {
  var %h = mp3
  if ($hget(%h)) { hfree %h }
  hmake %h 10
  hadd %h Type 1
  hadd %h Advert 04&artist 07- 04&title
  savesettings
}

alias -l savesettings {
  hsave -i mp3 $inifile Settings
}

alias -l setfields {
  didtok mp3player 30 32 $hget(mp3,availfields)
  didtok mp3player 31 32 $hget(mp3,chosenfields)
}

alias doad {
  if ($hget(mp3,autoad)) {
    if ($hget(mp3,chans)) {
      var %s = 1
      while (%s <= $scon(0)) {
        scon %s
        var %l = 1
        while (%l <= $numtok($hget(mp3,chans),44)) {
          if ($gettok($hget(mp3,chans),%l,44) ischan) {
            msg $gettok($hget(mp3,chans),%l,44) $advert
          }  
          inc %l
        }
        inc %s
      }
    }
  }
}

alias mp3.volume {
  dialog -m mp3vol mp3vol
}

alias mp3.play {
  hadd mp3 Use 1
  var %f = $+(",$scriptdir,settings\mp3.txt,"))
  if ($hget(mp3,Type) == 1) {
    var %p = $rand(1,$lines(%f))
    hadd mp3 TrackNo %p
  }
  else {
    if (!$hget(mp3,TrackNo)) {
      hadd mp3 TrackNo 1
    }
  }
  hadd mp3 Playing $read(%f,$hget(mp3,TrackNo))
  splay -p $hget(mp3,Playing)
  doad
}

alias mp3.pause {
  if ($insong.pause) {
    splay -p resume
  }
  else {
    splay -p pause
  }
}

alias mp3.stop {
  hadd mp3 Use 0
  splay stop
}

alias mp3.prev {
  var %f = $+(",$scriptdir,settings\mp3.txt,"))
  if ($hget(mp3,Type) == 1) {
    var %p = $rand(1,$lines(%f))
    hadd mp3 TrackNo %p
  }
  else {
    if ($hget(mp3,TrackNo) > 1) {
      var %t = $hget(mp3,TrackNo)
      hadd mp3 TrackNo $calc(%t - 1)
    }
  }
  hadd mp3 Playing $read(%f,$hget(mp3,TrackNo))
  splay -p $hget(mp3,Playing)
  doad
}

alias mp3.next {
  var %f = $+(",$scriptdir,settings\mp3.txt,"))
  if ($hget(mp3,Type) == 1) {
    var %p = $rand(1,$lines(%f))
    hadd mp3 TrackNo %p
  }
  else {
    if ($hget(mp3,TrackNo) < $lines(%f)) {
      var %t = $hget(mp3,TrackNo)
      hadd mp3 TrackNo $calc(%t + 1)
    }
  }
  hadd mp3 Playing $read(%f,$hget(mp3,TrackNo))
  splay -p $hget(mp3,Playing)
  doad
}

alias -l preview {
  return $left($replace($hget(mp3,chosenfields),&artist,$m.artist,&title,$m.title,&album,$m.album,&length,$m.length,&bitrate,$m.bitrate,&size,$m.size,&year,$m.year,&comment,$m.comment,&genre,$m.genre,&track,$m.track,&version,$m.version,&vbr,$m.vbr,&sample,$m.sample,&mode,$m.mode,&copyright,$m.copyright,&private,$m.private,&crc,$m.crc),-3)
}

alias advert {
  if ($insong) || ($isdde(mPlug)) {
    return $left($replace($hget(mp3,chosenfields),&artist,$m.artist,&title,$m.title,&album,$m.album,&length,$m.length,&bitrate,$m.bitrate,&size,$m.size,&year,$m.year,&comment,$m.comment,&genre,$m.genre,&track,$m.track,&version,$m.version,&vbr,$m.vbr,&sample,$m.sample,&mode,$m.mode,&copyright,$m.copyright,&private,$m.private,&crc,$m.crc),-3)
  }
}

alias mp3 {
  if ($isdde(mPlug)) { %winamp = $true }
  else { %winamp = $false }
  say $advert
  unset %winamp
}

alias m.i {
  return $hget(sysinfo,$1)
}

alias m.encleft {
  return $iif($m.i(enc.bold),,$null) $+ $iif($m.i(enc.underline),,$null) $+  $+ $m.i(enc.colour) $+ $m.i(enc.left) $+ 
}

alias m.encright {
  return $iif($m.i(enc.bold),,$null) $+ $iif($m.i(enc.underline),,$null) $+  $+ $m.i(enc.colour) $+ $m.i(enc.right) $+ 
}

alias m.sep {
  return $iif($m.i(sep.bold),,$null) $+ $iif($m.i(sep.underline),,$null) $+  $+ $m.i(sep.colour) $+ $m.i(sep) $+ 
}

alias m.head {
  return $iif($m.i(head.bold),,$null) $+ $iif($m.i(head.underline),,$null) $+  $+ $m.i(head.colour) $+ $1- $+ 
}

alias m.value {
  var %v = $m.i(value.colour)
  if ($len(%v) == 1) {
    %v = 0 $+ %v
  }
  return $iif($s.i(value.bold),,$null) $+ $iif($s.i(value.underline),,$null) $+  $+ %v $+ $1- $+ 
}

alias -l m.album {
  return $m.head(Album:) $m.encleft $+ $m.value($mp3.info(album)) $+ $m.encright $m.sep 
}

alias -l m.title {
  return $m.head(Title:) $m.encleft $+ $m.value($mp3.info(title)) $+ $m.encright $m.sep 
}

alias -l m.artist {
  return $m.head(Artist:) $m.encleft $+ $m.value($mp3.info(artist)) $+ $m.encright $m.sep 
}

alias -l m.year {
  return $m.head(Year:) $m.encleft $+ $m.value($mp3.info(year)) $+ $m.encright $m.sep 
}

alias -l m.comment {
  return $m.head(Comment:) $m.encleft $+ $m.value($mp3.info(comment)) $+ $m.encright $m.sep 
}

alias -l m.genre {
  return $m.head(Genre:) $m.encleft $+ $m.value($mp3.info(genre)) $+ $m.encright $m.sep 

}

alias -l m.size {
  return $m.head(Size:) $m.encleft $+ $m.value($mp3.info(size)) $+ $m.encright $m.sep 
}

alias -l m.track {
  return $m.head(Track:) $m.encleft $+ $m.value($mp3.info(track)) $+ $m.encright $m.sep 
}

alias -l m.length {
  return $m.head(Length:) $m.encleft $+ $m.value($mp3.info(length)) $+ $m.encright $m.sep 
}

alias -l m.version {
  return $m.head(Version:) $m.encleft $+ $m.value($mp3.info(version)) $+ $m.encright $m.sep 
}

alias -l m.bitrate {
  return $m.head(Bitrate:) $m.encleft $+ $m.value($mp3.info(bitrate)) $+ $m.encright $m.sep 
}

alias -l m.vbr {
  return $m.head(Vbr:) $m.encleft $+ $m.value($mp3.info(vbr)) $+ $m.encright $m.sep 
}

alias -l m.sample {
  return $m.head(Sample:) $m.encleft $+ $m.value($mp3.info(sample)) $+ $m.encright $m.sep 
}

alias -l m.mode {
  return $m.head(Mode:) $m.encleft $+ $m.value($mp3.info(mode)) $+ $m.encright $m.sep 
}

alias -l m.copyright {
  return $m.head(Copyright:) $m.encleft $+ $m.value($mp3.info(copyright)) $+ $m.encright $m.sep 
}

alias -l m.private {
  return $m.head(Private:) $m.encleft $+ $m.value($mp3.info(private)) $+ $m.encright $m.sep 
}

alias -l m.crc {
  return $m.head(Crc:) $m.encleft $+ $m.value($mp3.info(crc)) $+ $m.encright $m.sep 
}

alias mp3.info {
  var %r, %f = $+(",$hget(mp3,Playing),")
  if (!%winamp) {
    if ($1 == bitrate) {
      if ($sound(%f).bitrate) { %r = $ifmatch kbps }
    }
    elseif ($1 == length) {
      if ($sound(%f).length) { %r = $duration($calc($ifmatch / 1000)) }
    }
    elseif ($1 == album) {
      if ($sound(%f).album) { %r = $ifmatch }
    }
    elseif ($1 == artist) {
      if ($sound(%f).artist) { %r = $ifmatch }
    }
    elseif ($1 == title) {
      if ($sound(%f).title) { %r = $ifmatch }
    }
    elseif ($1 == size) {
      if ($file(%f).size) { %r = $ifmatch bytes }
    }
    elseif ($1 == year) {
      if ($sound(%f).year) { %r = $ifmatch }
    }
    elseif ($1 == comment) {
      if ($sound(%f).comment) { %r = $ifmatch }
    }
    elseif ($1 == genre) {
      if ($sound(%f).genre) { %r = $ifmatch }
    }
    elseif ($1 == track) {
      if ($sound(%f).track) { %r = $ifmatch }
    }
    elseif ($1 == version) {
      if ($sound(%f).version) { %r = $ifmatch }
    }
    elseif ($1 == vbr) {
      if ($sound(%f).vbr) { %r = $ifmatch }
    }
    elseif ($1 == sample) {
      if ($sound(%f).sample) { %r = $ifmatch }
    }
    elseif ($1 == mode) {
      if ($sound(%f).mode) { %r = $ifmatch }
    }
    elseif ($1 == copyright) {
      if ($sound(%f).copyright) { %r = $ifmatch }
    }
    elseif ($1 == private) {
      if ($sound(%f).private) { %r = $ifmatch }
    }
    elseif ($1 == crc) {
      if ($sound(%f).crc) { %r = $ifmatch }
    }
  }
  elseif (%winamp) {
    if ($1 == bitrate) {
      %r = $dde(mPlug,var_br) kbps
    }
    elseif ($1 == length) {
      %r = $dde(mPlug,var_min) $+ mins $dde(mPlug,var_sec) $+ secs
    }
    elseif ($1 == album) {
      %r = $dde(mPlug,var_4)
    }
    elseif ($1 == artist) {
      %r = $dde(mPlug,var_1)
    }
    elseif ($1 == title) {
      %r = $dde(mPlug,var_2)
    }
    elseif ($1 == size) {
      %r = $dde(mPlug,var_fl) $+ Mb
    }
    elseif ($1 == year) {
      %r = $dde(mPlug,var_5)
    }
    elseif ($1 == comment) {
      %r = $dde(mPlug,var_6)
    }
    elseif ($1 == genre) {
      %r = $dde(mPlug,var_7)
    }
    elseif ($1 == track) {
      %r = $dde(mPlug,var_3)
    }
    elseif ($1 == sample) {
      %r = $dde(mPlug,var_sr) 
    }
  }
  if (%r) { return $replace(%r,_,$chr(32),$true,Yes,$false,No) }
  else { return ? }
}

on *:mp3end:{
  if ($hget(mp3,Use)) {
    var %f = $+(",$scriptdir,settings\mp3.txt,"))
    if ($hget(mp3,Type) == 1) {
      var %p = $rand(1,$lines(%f))
      hadd mp3 TrackNo %p
    }
    else {
      if ($hget(mp3,TrackNo) < $lines(%f)) {
        var %t = $hget(mp3,TrackNo)
        hadd mp3 TrackNo $calc(%t + 1)
      }
      else {
        hadd mp3 TrackNo 1
      }
    }
    var %trk = $read(%f,$hget(mp3,TrackNo))
    splay -p %trk
    hadd mp3 Playing %trk
    doad
  }
}  

;---DIALOG STUFF---

dialog mp3player {
  title "Mp3 Settings Editor"
  size -1 -1 396 415
  option pixels
  tab "Settings", 37, 4 74 387 310
  box "Advert Fields", 29, 12 99 370 149, tab 37
  list 30, 23 136 140 100, tab 37 size
  list 31, 231 136 140 100, tab 37 size
  button "->", 32, 169 140 57 21, disable tab 37
  button "<-", 33, 169 164 57 21, disable tab 37
  button "Up", 34, 169 188 57 21, disable tab 37
  button "Down", 35, 169 211 57 21, disable tab 37
  edit "", 40, 24 272 145 23, tab 37
  button "...", 41, 171 274 27 19, tab 37
  box "Mp3 Directory", 39, 12 252 199 59, tab 37
  text "Available Fields...", 42, 24 117 95 16, tab 37
  text "Chosen Fields...", 43, 234 117 95 16, tab 37
  box "Advertise in these Channels", 51, 221 252 161 118, tab 37
  list 47, 232 272 138 85, tab 37 size
  check "Mp3 Auto Advertise", 46, 7 388 142 20, tab 37
  button "OK", 21, 317 388 75 22, ok
  box "Playback Volume", 1, 14 317 199 54
  list 2, 27 333 170 27, size
  icon 3, -2 0 404 64, $scriptdir $+ libraries\icons\mp3header.png, noborder
}

on *:dialog:mp3player:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX $dname 2 TrackBar > $bars
  mdx SetBorderStyle $dname 2 windowedge
  did -i $dname 2 1 params 0 0 65535 1 5 * * *
  did -i $dname 2 1 ticfreq 5000
  did -i $dname 2 1 params $vol(wave) * * * * * *
  mdx SetControlMDX 47 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 47 1 headerdims 110:1
  did -i $dname 47 1 headertext 0 Channels
  did -ar mp3player 40 $hget(mp3,dir)
  fillmp3chans
  if ($hget(mp3,autoad) == 1) {
    did -c mp3player 46
  }
  else {
    did -u mp3player 46
  }
  setfields
}

on *:dialog:mp3player:sclick:2:{
  vol -p $gettok($did(2,1),1,32)
}

on *:dialog:mp3player:sclick:21: {
  hadd mp3 dir $did(mp3player,40).text
  hadd mp3 availfields $didtok(mp3player,30,32)
  hadd mp3 chosenfields $didtok(mp3player,31,32)
  hadd mp3 autoad $did(mp3player,46).state
  savesettings
  if ($dialog(cpanel)) {
    dialog -v cpanel
  }
}

on *:dialog:mp3player:sclick:28: {
  hadd mp3 dir $did(mp3player,40).text
  hadd mp3 availfields $didtok(mp3player,30,32)
  hadd mp3 chosenfields $didtok(mp3player,31,32)
  hadd mp3 autoad $did(mp3player,46).state
} 

on *:dialog:mp3player:sclick:30: {
  did -e mp3player 32
  did -b mp3player 33,34,35
}

on *:dialog:mp3player:sclick:31: {
  did -b mp3player 32
  did -e mp3player 33,34,35
}

on *:dialog:mp3player:sclick:32: {
  did -a $dname 31 $did($dname,30,$did($dname,30).sel)
  did -d $dname 30 $did($dname,30).sel
  did -c $dname 30 1
}

on *:dialog:mp3player:sclick:33: {
  did -a $dname 30 $did($dname,31,$did($dname,31).sel)
  did -d $dname 31 $did($dname,31).sel
  did -c $dname 31 1
}

on *:dialog:mp3player:sclick:34: {
  var %temp = $calc($did($dname,31).sel - 1)
  did -i $dname 31 %temp $did($dname,31,$did($dname,31).sel)
  did -d $dname 31 $did($dname,31).sel
  did -c $dname 31 %temp
}

on *:dialog:mp3player:sclick:35: {
  if ($did($dname,31).sel < $did($dname,31).lines) {
    var %temp = $calc($did($dname,31).sel + 2)
    did -i $dname 31 %temp $did($dname,31,$did($dname,31).sel)
    did -d $dname 31 $did($dname,31).sel
    did -c $dname 31 $calc(%temp - 1)
  }
}

on *:dialog:mp3player:sclick:41: {
  var %dir = $hget(mp3,dir)
  if (!%dir) { %dir = c:\ }
  var %dir = $sdir(%dir,Select Folder)
  if (%dir) { did -ar mp3player 40 %dir }
}

on *:dialog:mp3player:sclick:47:{
  if ($gettok($did($dname,47,1),1,32) == rclick) {
    mp3chanpop $did(47).sel $gettok($gettok($did(47).seltext,6,32),1,9)
  }
}

on *:dialog:mp3player:sclick:48:{
  if ($did(mp3player,50)) {
    hadd mp3 chans $addtok($hget(mp3,chans),$did(mp3player,50),44)	
    didtok -ar mp3player 47 44 $hget(mp3,chans)
  }
}

on *:dialog:mp3player:sclick:49:{
  did -d mp3player 47 $did(mp3player,47).sel
  hadd mp3 chans $didtok(mp3player,47,44)
}

alias fillmp3chans {
  var %l = 1, %chans = $hget(mp3,chans)
  while (%l <= $numtok(%chans,44)) {
    var %chan = $gettok(%chans,%l,44) 
    did -a mp3player 47 + 0 0 0 %chan
    inc %l
  }
}

alias mp3chanpop {
  popups New mp3chanpop 16 16
  popups SetMetrics mp3chanpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem mp3chanpop end + Add $cr newmp3chan
  popups AddItem mp3chanpop end + Delete $cr delmp3chan $1 $2
  popup mp3chanpop $mouse.dx $mouse.dy
}

alias newmp3chan {
  var %chan = $input(Please enter a Channel to Advertise in...,equ,Query...,$null)
  hadd mp3 chans $addtok($hget(mp3,chans),%chan,44)
  did -r mp3player 47
  fillmp3chans
}

alias delmp3chan {
  did -d mp3player 47 $1
  hadd mp3 chans $remtok($hget(mp3,chans),$2,44)
}

dialog mp3vol {
  size -1 -1 192 35
  title "Mp3 Volume"
  list 1,2 2 188 30,size
}

on *:dialog:mp3vol:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX $dname 1 TrackBar > $bars
  mdx SetBorderStyle $dname 1 windowedge
  did -i $dname 1 1 params 0 0 65535 1 5 * * *
  did -i $dname 1 1 ticfreq 5000
  did -i $dname 1 1 params $vol(wave) * * * * * *
}

on *:dialog:mp3vol:sclick:1:{
  vol -p $gettok($did(1,1),1,32)
}

;---EVENT STUFF---

on *:start:{
  if ($exists($inifile)) {
    loadsettings
  }
}
