;---Toolbar by mr.man (c) 2005 (Part of NeXtGenIRC)---

;---ALIASES---

alias toolbardat {
  return $+(",$scriptdir,toolbar.dat,")
}

alias serversdat {
  return $+(",$scriptdir,settings\servers.dat,")
}

alias tb.popup {
  popups New server 16 16
  popups SetMetrics server iconpad 0 0 contentpad 0 0 spacing 1 0
  var %l = 1 
  while (%l <= $lines($serversdat)) { 
    var %port = $gettok($read($serversdat,%l),2,42)
    popups AddItem server end + $gettok($read($serversdat,%l),1,42) $cr server $gettok($read($serversdat,%l),1,42) %port
    inc %l
  } 
  popups AddItem server end +
  popups AddItem server end +> New connection $cr newcon
  popups New newcon 16 16
  popups SetMetrics newcon iconpad 0 0 contentpad 0 0 spacing 1 0
  var %l = 1 
  while (%l <= $lines($serversdat)) { 
    var %port = $gettok($read($serversdat,%l),2,42)
    popups AddItem newcon end + $gettok($read($serversdat,%l),1,42) $cr server -m $gettok($read($serversdat,%l),1,42) %port 
    inc %l 
  }
  popup server $mouse.dx $mouse.dy
}

alias update.tb {
  if (!$dialog(toolbar)) { return }
  else {
    scid $activecid
    if ( $scid($activecid).status = connecting || $scid($activecid).status = connected ) { 
      did -o toolbar 1 2 +v 2 $chr(9) $+ Disconnect
    }
    else {
      did -o toolbar 1 2 +v 1 $chr(9) $+ Connect 
    }
  }
}

alias movelb {
  mdx MoveControl toolbar 3 $calc($window(-2).w - 55) 7 * *
  mdx MoveControl toolbar 2 $calc($window(-2).w - 210) 9 * *
  mdx MoveControl toolbar 4 $calc($window(-2).w - 235) 6 * *
  mdx MoveControl toolbar 5 $calc($window(-2).w - 275) 2 * *
}

;---DIALOGS STUFF---

dialog toolbar {
  title "toolbar"
  size 1 1 614 20
  option pixels
  list 1, 2 2 490 16, size
  text "0 0 10", 2, 525 9 150 9
  text "Waiting...", 3, 680 6 75 13
  text "Lag:", 4, 500 6 25 13
  list 5, 650 2 30 16, size
}

on *:dialog:toolbar:init:0: {
  var %seps 0
  mdx MarkDialog $dname
  mdx SetControlMDX $dname 1 Toolbar flat arrows nodivider wrap > $bars
  mdx SetControlMDX $dname 2 Progressbar > $ctl
  mdx SetFont $dname 3 -10 400 Tahoma
  mdx SetFont $dname 4 -10 400 Tahoma
  mdx SetDialog $dname style 
  mdx SetBorderStyle $dname 1
  did -i $dname 1 1 bmpsize 16 16
  did -i $dname 1 1 setimage icon small $shortfn($scriptdirlibraries\icons\connect.ico)
  did -i $dname 1 1 setimage icon small $shortfn($scriptdirlibraries\icons\disconnect.ico)
  var %t = 1
  while (%t <= $lines($toolbardat)) {
    if ($read($toolbardat,%t) = -) { inc %t }
    var %icon = $gettok($read($toolbardat,%t),1,42)
    did -i $dname 1 1 setimage icon small %icon
    inc %t
  }
  did -a $dname 1 +v 1 $chr(9) $+ Connect
  did -a $dname 1 -
  var %r = 1
  while (%r <= $lines($toolbardat)) {
    if ($read($toolbardat,%r) != -) {
      did -a $dname 1 $gettok($read($toolbardat,%r),4,42) $calc(%r + 2 - %seps) $chr(9) $+ $gettok($read($toolbardat,%r),2,42)
      inc %r
    } 
    else { 
      did -a $dname 1 -
      inc %r
      inc %seps
    }
  }
  mdx SetControlMDX $dname 5 Toolbar flat arrows nodivider wrap > $bars
  mdx SetBorderStyle $dname 5
  did -i $dname 5 1 bmpsize 16 16
  did -i $dname 5 1 setimage icon small $shortfn($scriptdirlibraries\icons\email.ico)
  did -i $dname 5 1 setimage icon small $shortfn($scriptdirlibraries\icons\recemail.ico)
  did -a $dname 5 1 $chr(9) $+ No Messages
  did -a $dname 5 -
  update.tb
  xdock -t $dialog(toolbar).hwnd +s
}

on *:dialog:toolbar:sclick:1: {
  if ($did($dname,1).sel isin 02) {
    if ($scid($activecid).status = connecting || $scid($activecid).status = connected) {
      scid $activecid disconnect
    }
    else {
      scid $activecid server
    }
    update.tb
    did -f $dname 2
    scid $activecid window -a "status window"
  }
  else {
    var %sel $calc($did($dname,1).sel - 3)
    .timer 1 0 $gettok($read($toolbardat,%sel),3,42)
  }
}

on *:dialog:toolbar:sclick:5: {
  if ($did($dname,5).sel == 2) {
    email
  }
}

on *:dialog:toolbar:dclick:1: {
  if ($did($dname,1).sel = 2) {
    tb.popup
  }
  else {
    var %sel $calc($did($dname,1).sel - 3)
    .timer 1 0 $gettok($read($toolbardat,%sel),5,42)
  }
}  

alias toolbar { 
  if ($1 = on && !$dialog(toolbar)) {
    dialog -m toolbar toolbar
  }
  elseif ($1 = off && $dialog(toolbar)) {
    dialog -x toolbar toolbar
  }
  elseif ($1 = refresh && $dialog(toolbar)) {
    dialog -x toolbar
    dialog -m toolbar toolbar
  }
}

alias sendkeys {
  var %a = sendkeys $+ $ticks
  .comopen %a WScript.Shell
  if !$comerr {
    var %b = $com(%a,SendKeys,3,bstr,$1-)
    .comclose %a
    return %b
  }
  return 0
}

alias alt { sendkeys % $+ $1 }

;---EVENTS---

on *:connect: {
  update.tb
}

on *:disconnect: {
  update.tb
}

on *:active:*: {
  update.tb
}

on *:close:*: {
  update.tb
}
