;---TREEVIEW SWITCHBAR by mr.man (c) 2006 (Part of NeXtGenIRC)---

on *:start:{
  dll $+(",$scriptdir,libraries\winevent.dll,") Load .
}

alias sbar {
  if ($1 == on) {
    dialog -m switchbar switchbar
    xdock -m $dialog(switchbar).hwnd +l
    xdock -r $dialog(switchbar).hwnd + $hget(various,tvwidth) 3000
    if (!$hget(various,tvprev)) {
      hadd various tvprev $active
    }
    hadd various channel.event $null
    hadd various channel.message $null
    hadd various channel.highlight $null
    hadd various highlightcol $color($calc($gettok($readini($mircini,options,n6),31,44) - 1))
    hadd various eventcol $color($calc($gettok($readini($mircini,options,n4),31,44) - 1))
    hadd various messagecol $color($calc($gettok($readini($mircini,options,n4),28,44) - 1))
    xdid -r switchbar 1
    xdid -w switchbar 1 +n 0 $shortfn($+(",$scriptdir,libraries\icons\status.ico,"))
    xdid -w switchbar 1 +n 0 $shortfn($+(",$scriptdir,libraries\icons\channel.ico,"))
    xdid -w switchbar 1 +n 0 $shortfn($+(",$scriptdir,libraries\icons\query.ico,"))
    xdid -w switchbar 1 +n 0 $shortfn($+(",$scriptdir,libraries\icons\dccs.ico,"))
    xdid -w switchbar 1 +n 0 $shortfn($+(",$scriptdir,libraries\icons\gets.ico,"))
    xdid -w switchbar 1 +n 0 $shortfn($+(",$scriptdir,libraries\icons\sends.ico,"))
    xdid -w switchbar 1 +n 0 $shortfn($+(",$scriptdir,libraries\icons\chats.ico,"))
    xdid -w switchbar 1 +n 0 $shortfn($+(",$scriptdir,libraries\icons\chanfade.ico,"))
    xdid -w switchbar 1 +n 0 $shortfn($+(",$scriptdir,libraries\icons\client.ico,"))
    xdid -w switchbar 1 +n 0 $shortfn($+(",$scriptdir,libraries\icons\ftp.ico,"))
    update.switchbar
    update.notify
    .enable #switchbar
    .timertv -mo 0 500 doflash
  }
  else if ($1 == off) {
    dialog -x switchbar
    .disable #switchbar
    .timertv off
  }
}

alias balloon {
  mtooltips SetTooltipWidth 300
  if ($1 == get) {
    mtooltips SpawnTooltip +bsa $mouse.dx $mouse.dy 2000 > DCC Get $+ : $chr(4) Nick: $get($2) $crlf Filename: $get($2).file $crlf Size: $bytes($get($2).size,3).suf $crlf Cps: $bytes($get($2).cps,3).suf $crlf Complete: $get($2).pc $+ %
  }
  else if ($1 == send) {
    mtooltips SpawnTooltip +bsa $mouse.dx $mouse.dy 2000 > DCC Send $+ : $chr(4) Nick: $send($2) $crlf Filename: $send($2).file $crlf Size: $bytes($send($2).size,3).suf $crlf Cps: $bytes($send($2).cps,3).suf $crlf Complete: $send($2).pc $+ %
  }
  else if ($1 == chat) {
    mtooltips SpawnTooltip +bsa $mouse.dx $mouse.dy 2000 > DCC Chat $+ : $chr(4) Nick: $chat($2) $crlf Hostmask: $address($chat($2),0) $crlf IP Address: $chat($2).ip
  }
  else if ($1 == ftpd) {
    if ($sock($replace($3,ctrl,data))) {
      if ($hget($3,COMM) == RETR) {
        var %status = Downloading, %progress = Sent: $bytes($sock($replace($3,ctrl,data)).sent).suf
      }
      if ($hget($3,COMM) == STOR) {
        var %status = Uploading, %progress = Received: $bytes($sock($replace($3,ctrl,data)).rcvd).suf
      }      
      mtooltips SpawnTooltip +bsa $mouse.dx $mouse.dy 2000 > FTP Client $+ : $chr(4) $chr(160) $+ User: $2 $crlf IP: $sock($3).ip $crlf Status: %status $crlf %progress
    }
    else {
      mtooltips SpawnTooltip +bsa $mouse.dx $mouse.dy 2000 > FTP Client $+ : $chr(4) $chr(160) $+ User: $2 $crlf IP: $sock($3).ip $crlf Status: Idle
    }
  }
}

dialog switchbar {
  title "Switchbar"
  size -1 -1 140 514
  option pixels
}

on *:dialog:switchbar:init:0:{
  dcx Mark $dname treeview
  xdialog -c $dname 2 divider 0 0 $calc($hget(various,tvwidth) - 2) 1000 notheme
  xdid -l $dname 2 200 0 $chr(9) 1 treeview 0 0 100 600 haslines nohscroll notooltips
  xdid -r $dname 2 200 0 $chr(9) 3 treeview 0 0 100 400 haslines nohscroll notooltips
  xdid -i $dname 1 +b $color($color(back))
  xdid -i $dname 1 +l $color($hget(various,tvlines))
  xdid -i $dname 1 +t $color($hget(various,tvtext))
  xdid -f $dname 1 +a ansi $hget(various,tvfont)
  xdid -i $dname 3 +b $color($color(back))
  xdid -i $dname 3 +l $color($hget(various,tvlines))
  xdid -i $dname 3 +t $color($hget(various,tvtext))
  xdid -f $dname 3 +a ansi $hget(various,tvfont)
  xdialog -l $dname root 1 2 $chr(9) +p 0 0 0 0
  xdid -v $dname 2 500
  colour.networks $hget(various,tvnetwork)
}

alias colour.networks {
  var %l = 1
  while (%l <= $scon(0)) {
    scon %l
    var %i = $xdid(switchbar,1,$chr(9) $scon(%l).network $+ * $chr(9),W,1).find
    if (%i) {
      xdid -Q switchbar 1 +bc $color($1) %i
    }
    inc %l
  }
  var %i = $xdid(switchbar,1,$chr(9) DCCs:* $chr(9),W,1).find
  if (%i) {
    xdid -Q switchbar 1 +bc $color($1) %i
  }
  var %i = $xdid(switchbar,1,$chr(9) FTPd:* $chr(9),W,1).find
  if (%i) {
    xdid -Q switchbar 1 +bc $color($1) %i
  }
  var %i = $xdid(switchbar,3,$chr(9) Online:* $chr(9),W,1).find
  if (%i) {
    xdid -Q switchbar 3 +bc $color($1) %i
  }
  var %i = $xdid(switchbar,3,$chr(9) Offline:* $chr(9),W,1).find
  if (%i) {
    xdid -Q switchbar 3 +bc $color($1) %i
  }
}

alias event.switchbar {
  if (($2 != $scid($activecid).active) || ($1 != $scid($activecid).network)) && (!$istok($hget(various,channel.message),$+($1,$chr(44),$2),32)) && (!$istok($hget(various,channel.highlight),$+($1,$chr(44),$2),32)) {
    var %n = 1, %l = 0
    while (%n <= $scon(0)) {
      if ($1 == $scon(%n).network) {
        %l = %n
      }
      inc %n
    }
    var %f = $xdid(switchbar,1,$chr(9) $2 $chr(9),W,1,%l).find
    if (%f) {
      xdid -Q switchbar 1 +c $hget(various,eventcol) %f
      xdid -j switchbar 1 %f $chr(9) 2 2
    }
    hadd various channel.event $addtok($hget(various,channel.event),$+($1,$chr(44),$2),32)
  }
}

alias message.switchbar {
  if (($2 != $scid($activecid).active) || ($1 != $scid($activecid).network)) && (!$istok($hget(various,channel.highlight),$+($1,$chr(44),$2),32)) {
    var %n = 1, %l = 0
    while (%n <= $scon(0)) {
      if ($1 == $scon(%n).network) {
        %l = %n
      }
      inc %n
    }
    var %f = $xdid(switchbar,1,$chr(9) $2 $chr(9),W,1,%l).find
    if (%f) {
      xdid -Q switchbar 1 +c $hget(various,messagecol) %f
      xdid -j switchbar 1 %f $chr(9) 2 2
    }
    hadd various channel.message $addtok($hget(various,channel.message),$+($1,$chr(44),$2),32)
  }
}

alias highlight.switchbar {
  if (($2 != $scid($activecid).active) || ($1 != $scid($activecid).network)) && (!$istok($hget(various,channel.highlight),$+($1,$chr(44),$2),32)) {
    var %n = 1, %l = 0
    while (%n <= $scon(0)) {
      if ($1 == $scon(%n).network) {
        %l = %n
      }
      inc %n
    }
    var %f = $xdid(switchbar,1,$chr(9) $2 $chr(9),W,1,%l).find
    if (%f) {
      xdid -Q switchbar 1 +c $hget(various,highlightcol) %f
      xdid -j switchbar 1 %f $chr(9) 2 2
    }
    hadd various channel.highlight $addtok($hget(various,channel.highlight),$+($1,$chr(44),$2),32)
  }
}

alias doflash {
  if ($hget(various,flash) == $true) {
    hadd various flash $false
    var %c = $numtok($hget(various,channel.highlight),32), %l = 1
    while (%l <= %c) {
      var %network = $gettok($gettok($hget(various,channel.highlight),%l,32),1,44)
      var %chan = $gettok($gettok($hget(various,channel.highlight),%l,32),2,44)
      var %n = 1, %x = 0
      while (%n <= $scon(0)) {
        if (%network == $scon(%n).network) {
          %x = %n
        }
        inc %n
      }
      var %f = $xdid(switchbar,1,$chr(9) %chan $chr(9),W,1,%x).find
      if (%f) {
        xdid -j switchbar 1 %f $chr(9) 8 8
      }
      else {
        var %i = $xdid(switchbar,1,$chr(9) %chan $chr(9),W,1).find
        if (%i) {
          xdid -j switchbar 1 %i $chr(9) 8 8
        }
      }
      inc %l
    }
  }
  else {
    hadd various flash $true
    var %c = $numtok($hget(various,channel.highlight),32), %l = 1
    while (%l <= %c) {
      var %network = $gettok($gettok($hget(various,channel.highlight),%l,32),1,44)
      var %chan = $gettok($gettok($hget(various,channel.highlight),%l,32),2,44)
      var %n = 1, %x = 0
      while (%n <= $scon(0)) {
        if (%network == $scon(%n).network) {
          %x = %n
        }
        inc %n
      }
      var %f = $xdid(switchbar,1,$chr(9) %chan $chr(9),W,1,%x).find
      if (%f) {
        xdid -j switchbar 1 %f $chr(9) 2 2
      }
      else {
        var %i = $xdid(switchbar,1,$chr(9) %chan $chr(9),W,1).find
        if (%i) {
          xdid -j switchbar 1 %i $chr(9) 2 2
        }
      }
      inc %l
    }
  }
}

alias update.notify {
  var %on = 0, %off = 0
  xdid -r switchbar 3    
  xdid -w switchbar 3 +n 0 $shortfn($+(",$scriptdir,libraries\icons\online.ico,"))
  xdid -w switchbar 3 +n 0 $shortfn($+(",$scriptdir,libraries\icons\offline.ico,"))
  xdid -a switchbar 3 $tab(-1,+eb 1 1 1 0 0 255 0 Online:,$chr(9))
  var %n = 1
  while (%n <= $scon(0)) {
    scon %n
    var %l = 1
    while (%l <= $notify(0)) {
      if ($notify(%l).ison) {
        var %i = $xdid(switchbar,3,$chr(9) $notify(%l) ( $+ $notify(%l).network $+ ) $chr(9), W, 0).find
        if (%i == 0) {
          xdid -a switchbar 3 $tab(-1 -1,+e 1 1 1 0 0 255 0 $notify(%l) ( $+ $notify(%l).network $+ ) ,$chr(9))
          inc %on
        }
      }
      inc %l
    }
    inc %n
  }
  xdid -a switchbar 3 $tab(-1,+eb 2 1 1 0 0 255 0 Offline:,$chr(9))
  var %n = 1
  while (%n <= $scon(0)) {
    scon %n
    var %l = 1
    while (%l <= $notify(0)) {
      if (!$notify(%l).ison) {
        var %i = $xdid(switchbar,3,$chr(9) $notify(%l) ( $+ $notify(%l).network $+ ) $chr(9), W, 0).find
        if (%i == 0) {
          xdid -a switchbar 3 $tab(-1 -1,+e 2 2 1 0 0 255 0 $notify(%l) ( $+ $notify(%l).network $+ ) ,$chr(9))
          inc %off
        }
      }
      inc %l
    }
    inc %n
  }
  var %i = $xdid(switchbar,3,$chr(9) Online: $chr(9), W, 1).find
  xdid -v switchbar 3 %i $chr(9) Online: %on
  var %j = $xdid(switchbar,3,$chr(9) Offline: $chr(9), W, 1).find
  xdid -v switchbar 3 %j $chr(9) Offline: %off
}

alias update.switchbar {
  var %a = 1
  xdid -r switchbar 1
  while (%a <= $scon(0)) {
    scon %a
    xdid -a switchbar 1 $tab(-1,+eb 1 1 1 0 0 255 0 $iif($scon(%a).network == $null,$iif($scon(%a).server == $null,Not Connected,$scon(%a).server),$scon(%a).network $me),$chr(9))
    xdid -a switchbar 1 $tab(%a -1,+eb 2 2 0 0 0 255 0 Channels: $chan(0))
    var %x = 1, %net = $scon(%a).network
    while (%x <= $chan(0)) {
      if ($chan(%x) != $active) {
        if ($istok($hget(various,channel.highlight),$+(%net,$chr(44),$chan(%x)),32) == $true) {
          xdid -a switchbar 1 $tab(%a +1 1,+ce 2 2 0 0 0 $hget(various,highlightcol) 0 $chan(%x))
        }
        else if ($istok($hget(various,channel.message),$+(%net,$chr(44),$chan(%x)),32) == $true) {
          xdid -a switchbar 1 $tab(%a +1 1,+ce 2 2 0 0 0 $hget(various,messagecol) 0 $chan(%x))
        }
        else if ($istok($hget(various,channel.event),$+(%net,$chr(44),$chan(%x)),32) == $true) {
          xdid -a switchbar 1 $tab(%a +1 1,+ce 2 2 0 0 0 $hget(various,eventcol) 0 $chan(%x))
        }
        else {
          xdid -a switchbar 1 $tab(%a +1 1,+ce 2 2 0 0 0 $color($hget(various,tvtext)) 0 $chan(%x))
        } 
      }
      else {
        xdid -a switchbar 1 $tab(%a +1 1,+ce 2 2 0 0 0 $color($hget(various,tvtext)) 0 $chan(%x))
      } 
      inc %x
    }
    xdid -a switchbar 1 $tab(%a -1,+eb 3 3 0 0 0 255 0 Queries: $query(0))
    var %x = 1
    while (%x <= $query(0)) {
      xdid -a switchbar 1 $tab(%a +2 1,+ce 3 3 0 0 0 $color($hget(various,tvtext)) 0 $query(%x))
      inc %x
    }
    inc %a
  }
  xdid -a switchbar 1 $tab(-1,+eb 4 4 0 0 0 255 0 DCCs: $calc($get(0) + $send(0) + $chat(0)))
  xdid -a switchbar 1 $tab(%a -1,+eb 5 5 0 0 0 255 0 Gets: $get(0))
  var %x = 1
  while (%x <= $get(0)) {
    xdid -a switchbar 1 $tab(%a +1 1,+e 5 5 0 0 0 255 0 $get(%x) $get(%x).file)
    inc %x
  }
  xdid -a switchbar 1 $tab(%a -1,+eb 6 6 0 0 0 255 0 Sends: $send(0))
  var %x = 1
  while (%x <= $send(0)) {
    xdid -a switchbar 1 $tab(%a +2 1,+e 6 6 0 0 0 255 0 $send(%x) $send(%x).file)
    inc %x
  }
  xdid -a switchbar 1 $tab(%a -1,+eb 7 7 0 0 0 255 0 Chats: $chat(0))
  var %x = 1
  while (%x <= $chat(0)) {
    xdid -a switchbar 1 $tab(%a +3 1,+e 7 7 0 0 0 255 0 $chat(%x))
    inc %x
  }
  var %i = 1
  while (%i <= $scon(0)) {
    xdid -z switchbar 1 +tab %i 1
    xdid -z switchbar 1 +tab %i 2
    inc %i
  }
  inc %a
  if ($hget(ftpd,active) == 1) {
    xdid -a switchbar 1 $tab(-1,+eb 10 10 0 0 0 255 0 FTPd: Online)
  }
  else {
    xdid -a switchbar 1 $tab(-1,+eb 10 10 0 0 0 255 0 FTPd: Offline)
  }
  xdid -a switchbar 1 $tab(%a +1,+eb 9 9 0 0 0 255 0 Clients: $ftp(0) $+ / $+ $hget(ftpd,maxusers))
  var %f = 1
  while (%f <= $ftp(0)) {
    xdid -a switchbar 1 $tab(%a +1 1,+e 9 9 0 0 0 255 0 $ftp(%f))
    inc %f
  }
  colour.networks $hget(various,tvnetwork)
  var %l = 0, %n = 0
  while (%n <= $scon(0)) {
    if ($scid($activecid).network == $scon(%n).network) {
      %l = %n
    }
    inc %n
  }
  var %f = $xdid(switchbar,1,$chr(9) $active $chr(9),W,1,%l).find
  if (%f) {
    xdid -Q switchbar 1 +c $color($hget(various,tvactive)) %f
    xdid -j switchbar 1 %f $chr(9) 2 2
  }
  hadd various tvprev $+($scid($activecid).network,$chr(44),$active)
}

alias treeview {
  if ($2 == rclick && $3 == 3) {
    notifypop $xdid(switchbar,3,1).seltext
    return
  }
  if ($3 == 3) {
    halt
  }
  var %com = $2
  tokenize 32 $4-
  if ($1 <= $scon(0)) {
    scon $1
  }
  if (%com == sclick) {
    if (!$1) {
      return
    }
    var %network = $gettok($xdid(switchbar,1,$1).text,1,32)
    var %p = $xdid(switchbar,1,$1-).selpath
    tokenize 32 %p
    var %n = $xdid(switchbar,1,$1-2).text
    if (Clients* iswm %n) {
      if (Clients* iswm $xdid(switchbar,1,1).seltext) {
        return
      }
      else {
        var %n = $xdid(switchbar,1,1).seltext
        balloon ftpd %n $usertosock(%n)
        return
      }
    }
    if ($mouse.key & 4) {
      var %p = $xdid(switchbar,1,$1-).text
      if (%p ischan) {
        part %p
        return
      }
    }
    if ($1-) {
      var %p = $xdid(switchbar,1,$1-).text
      hadd various activechan %p
    }
    var %l = 1
    while (%l <= $get(0)) {
      if (%p == $get(%l) $get(%l).file) {
        balloon get %l
        return
      }
      inc %l
    }
    var %l = 1
    while (%l <= $send(0)) {
      if (%p == $send(%l) $send(%l).file) {
        balloon send %l
        return
      }
      inc %l
    }
    var %l = 1
    while (%l <= $chat(0)) {
      if (%p == $chat(%l)) {
        balloon chat %l
        return
      }
      inc %l
    }
    if ($1-) {
      if (!$2) && ($xdid(switchbar,1,$1-).text != DCCs $+ *) {
        .timer 1 0 window -a "Status Window"
      }
    }
    if ($2 == 1) {
      if (Channels* iswm $xdid(switchbar,1).seltext) {
        return
      } 
      if (Gets:* iswm $xdid(switchbar,1).seltext) {
        return
      } 
      if (Sends:* iswm $xdid(switchbar,1).seltext) {
        return
      } 
      if (Clients:* iswm $xdid(switchbar,1).seltext) {
        return
      } 
      if ($1-) {
        .timer 1 0 window -a $+(@,$chan($3).wid)
      }
      var %chan = $xdid(switchbar,1).seltext
      hadd various channel.highlight $remtok($hget(various,channel.highlight),$+(%network,$chr(44),%chan),1,32)
      hadd various channel.event $remtok($hget(various,channel.event),$+(%network,$chr(44),%chan),1,32)
      hadd various channel.message $remtok($hget(various,channel.message),$+(%network,$chr(44),%chan),1,32)
      var %l = 0, %n = 0
      while (%n <= $scon(0)) {
        if ($gettok($hget(various,tvprev),1,44) == $scon(%n).network) {
          %l = %n
        }
        inc %n
      }
      var %f = $xdid(switchbar,1,$chr(9) $gettok($hget(various,tvprev),2,44) $chr(9),W,1,%l).find
      if (%f) {
        xdid -Q switchbar 1 +c $color($hget(various,tvtext)) %f
        xdid -j switchbar 1 %f $chr(9) 2 2
      }
      xdid -Q switchbar 1 +c $color($hget(various,tvactive)) $1-
      xdid -j switchbar 1 $1- $chr(9) 2 2
      hadd various tvprev $+(%network,$chr(44),%chan)
    }
    if ($2 == 2) {
      if (Sends* iswm $xdid(switchbar,1).seltext) {
        return
      }
      if (Queries* iswm $xdid(switchbar,1).seltext) {
        return
      }
      var %q = $xdid(switchbar,1).selpath
      if (%q) {
        .timer 1 0 window -a $query($3)
        var %i = $xdid(switchbar,1,$chr(9) $query($3) $chr(9),W,1).find
        if (%i) {
          xdid -Q switchbar 1 +c $color($hget(various,tvactive)) %i
        }
        var %i = $xdid(switchbar,1,$chr(9) $gettok($hget(various,tvprev),2,44) $chr(9),W,1).find
        if (%i) {
          xdid -Q switchbar 1 +c $color($hget(various,tvtext)) %i
        }
        hadd various tvprev $+(%network,$chr(44),$query($3))
      }
    }
  }
  if (%com == dclick) {
    var %p = $xdid(switchbar,1).seltext
    var %l = 1
    while (%l <= $get(0)) {
      if (%p == $get(%l) $get(%l).file) {
        window -a "Get %p $+ "
      }
      inc %l
    }
    var %l = 1
    while (%l <= $send(0)) {
      if (%p == $send(%l) $send(%l).file) {
        window -a "Send %p $+ "
      }
      inc %l
    }
    var %l = 1
    while (%l <= $chat(0)) {
      if (%p == $chat(%l)) {
        .timer -o 1 0 window -a "Chat %p $+ "
        var %i = $xdid(switchbar,1,$chr(9) %p $chr(9),W,1).find
        if (%i) {
          xdid -Q switchbar 1 +c $color($hget(various,tvtext)) %i
        }
      }
      inc %l
    }
    var %l = 1
    while (%l <= $ftp(0)) {
      if (%p == $ftp(%l)) {
        ftpdialog $xdid(switchbar,1).seltext
      }
      inc %l
    }
  }
  if (%com == rclick) {
    if ($1-) {
      var %p = $xdid(switchbar,1,$1-).selpath
      tokenize 32 %p
      var %n = $xdid(switchbar,1,$1-2).text, %s = $xdid(switchbar,1).seltext
      if (Clients* iswm %n) {
        if (Clients* !iswm %s) {
          clientpop %s
          return
        }
        return
      }
      if (FTPd: * iswm $xdid(switchbar,1).seltext) {
        ftppop %s
        return
      }
      else {
        tvpop $1-
        return
      }
    }
  }
}

#switchbar on

on *:connect:{
  update.switchbar
}

on *:disconnect:{
  update.switchbar
}

on *:join:#:{
  if ($nick == $me) {
    update.switchbar
  }
  else {
    if (!$istok($hget(various,channel.event),$+($network,$chr(44),$chan),32)) {
      event.switchbar $network $chan
    }
  }
}

on *:part:#:{
  if ($nick == $me) {
    update.switchbar
  }
  else {
    if (!$istok($hget(various,channel.event),$+($network,$chr(44),$chan),32)) {
      event.switchbar $network $chan
    }
  }
}

on *:action:*:#: {
  var %l = $strip($1-)
  var %loop = 97
  while (%loop <= 122) {
    var %l = $replace(%l,$mid($hget(ncomp,Chars),$calc(%loop - 96),1),$chr(%loop))
    inc %loop
  }
  tokenize 32 %l
  if ($istok(%l,$me,32) || ($me isin $1)) {
    if ($ismin) {
      syspop $nick just mentioned you in $chan on $network
    }
    if ($dialog(switchbar)) {
      highlight.switchbar $network $chan
    }
    if ($hget(various,pager)) && ($chan !isin $hget(various,exhighlight)) { 
      splay -w $+(",$sound(wave),pager.wav,")
    }
  }
  if ($chan != $active) {
    hadd various channel $addtok($hget(various,channel),$chan,32)
    message.switchbar $network $chan
  }
}

on *:action:*:?: {
  if ($nick != $active) {
    hadd various query $addtok($hget(various,query),$nick,32)
    message.switchbar $nick
  }
}

on *:signal:winevent:{
  if ($1-2 == Create mIRC_Query) {
    splay -w $+(",$sound(wave),query.wav,")
  }
  if ($2 != mIRC_Custom) {
    if (!$timer(connect)) {
      update.switchbar
    }
  }
}

on *:kick:#: { if ($knick == $me) { .timer -m 1 5 update.switchbar } }

on *:nick: { if ($nick == $me) { .timer -m 1 5 update.switchbar } }

on *:text:*:?: {
  if ($nick != $active) {
    hadd various query $addtok($hget(various,query),$nick,32)
    message.switchbar $network $nick
  }
}

on *:chat:*: {
  if ($nick !isin $active) {
    var %i = $xdid(switchbar,1,$chr(9) $nick $chr(9),W,1).find
    xdid -Q switchbar 1 +c $color($calc($gettok($readini($mircini,options,n4),28,44) - 1)) %i
  }
  var %l = $strip($1-)
  var %loop = 97
  while (%loop <= 122) {
    var %l = $replace(%l,$mid($hget(ncomp,Chars),$calc(%loop - 96),1),$chr(%loop))
    inc %loop
  }
  tokenize 32 %l
  if ($istok(%l,$me,32) || ($me isin $1)) {
    if ($hget(various,pager)) { 
      splay -w $+(",$sound(wave),pager.wav,")
    }
  }
}

#switchbar end

on *:text:*:*:{
  var %l = $strip($1-)
  var %loop = 97
  while (%loop <= 122) {
    var %l = $replace(%l,$mid($hget(ncomp,Chars),$calc(%loop - 96),1),$chr(%loop))
    inc %loop
  }
  tokenize 32 %l
  if ($istok(%l,$me,32) || ($me isin $1)) {
    if ($ismin) {
      syspop $nick just mentioned you in $chan on $network
    }
    if ($dialog(switchbar)) {
      highlight.switchbar $network $chan
    }
    if ($hget(various,pager)) && ($chan !isin $hget(various,exhighlight)) { 
      splay -w $+(",$sound(wave),pager.wav,")
    }
    if (($active != $chan) && ($network != $scid($activecid).network)) { 
      echo 04 -ati2 $+($chr(40),$nick,/,$chan,@,$network,$chr(41)) %l
    }
    var %n = $network
    if ($me == $hget(%n,AwayNick)) || ($me == $hget(%n,AwayDownNick)) {
      dolog $timestamp $chan $nick $1-
    }
  }
  else if ($dialog(switchbar)) {
    hadd various channel $addtok($hget(various,channel),$chan,32)
    if (!$istok($hget(various,channel.message),$+($network,$chr(44),$chan),32)) {
      message.switchbar $network $chan
    }
  }
}

alias tvpop {
  popups New switchbar 16 16
  popups SetMetrics switchbar iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem switchbar end + Close $cr doclose $1-
  popups AddItem switchbar end + Refresh $cr update.switchbar
  popup switchbar $mouse.dx $mouse.dy
}

alias ftppop {
  popups New switchbar 16 16
  popups SetMetrics switchbar iconpad 0 0 contentpad 0 0 spacing 1 0
  if ($hget(ftpd,active) == 1) {
    popups AddItem switchbar end + FTPd Offline $cr ftpstop
  }
  else {
    popups AddItem switchbar end + FTPd Online $cr ftpstart
  }  
  popups AddItem switchbar end + Msg All... $cr msgall
  popups AddItem switchbar end + Setup... $cr ftpd
  popup switchbar $mouse.dx $mouse.dy
}

alias clientpop {
  popups New switchbar 16 16
  popups SetMetrics switchbar iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem switchbar end + Kick... $cr kickuser $1-
  popups AddItem switchbar end + Ban $cr banuser $1-
  popups AddItem switchbar end + Msg... $cr msguser $1-
  popups AddItem switchbar end + Log... $cr showlog
  popup switchbar $mouse.dx $mouse.dy
}

alias doclose {
  if ($1 <= $scon(0)) {
    scon $1 
  }
  else if (DCCs:* iswm $xdid(switchbar,1,$1).text) {
    if (Sends:* iswm $xdid(switchbar,1,$1-2).text) {
      window -c "Send $xdid(switchbar,1,$1-).text $+ "
      return
    }
    if (Gets:* iswm $xdid(switchbar,1,$1-2).text) {
      window -c "Get $xdid(switchbar,1,$1-).text $+ "
      return
    }
  }
  else {
    if ($2 == 3) {
      close -c $xdid(switchbar,1,$1-).text
    }
  }
  if (!$2) && ($xdid(switchbar,1,$1-).text != DCCs) {
    .timeractivate -m 1 10 window -c "Status Window"
    ;update.switchbar
  }
  if ($2 == 1) && ($1 <= $scon(0)) {
    part $chan($3) 
    update.switchbar
    if ($chan($3) isin $hget(various,channel)) {
      hadd various channel $remtok($hget(various,channel),$chan($3),1,32)
    }
  }
  if ($2 == 2) {
    window -c $query($3) 
    update.switchbar
    if ($query($3) isin $hget(various,query)) {
      hadd various query $remtok($hget(various,query),$query($3),1,32)
    }
  }
  if ($2 == 3) {
    var %i = $xdid(switchbar,1,$1-).text
    window -c = $+ %i
  }
}

alias notifydlgpop {
  popups New notifydlgpop 16 16
  popups SetMetrics notifydlgpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem notifydlgpop end + Add $cr notifyadd
  popups AddItem notifydlgpop end + Delete $cr notifydel $2
  popup notifydlgpop $mouse.dx $mouse.dy
}

alias notifyadd {
  dialog -m notifydlg notifydlg
  did -ar notifydlg 5 $network
  did -f notifydlg 4
}

alias notifydel {
  .notify -r $1
  update.notify
  fillnotifys
}

dialog notifydlg {
  title "Add nickname to Notify List..."
  size -1 -1 252 254
  option pixels
  tab "Add", 1, 5 73 241 147
  box "Notify Settings", 2, 14 99 223 107, tab 1
  text "Nickname:", 3, 30 131 54 16, tab 1
  edit "", 4, 86 127 136 23, tab 1 autohs
  edit "", 5, 86 161 136 23, tab 1 autohs
  text "Network:", 6, 30 165 54 16, tab 1
  button "Ok", 10, 184 225 63 22, ok
  button "Cancel", 7, 119 225 63 22, cancel
  icon 8, -2 0 256 64, $scriptdir $+ libraries\icons\notifyheader.png, noborder
}

on *:dialog:notifydlg:sclick:10: {
  if ($did($dname,4) && $did($dname,5)) {
    .notify -n $did($dname,4) $did($dname,5)
  }
  update.notify
  if ($dialog(tvsetup)) {
    fillnotifys
  }
}

on ^*:notify:{
  if (!$istok($hget(various,notifys),$nick,32)) {
    hadd various notifys $addtok($hget(various,notifys),$nick,32)
    if ($hget(various,notify) == 1) {
      splay -w $+(",$sound(wave),notify.wav,")
    }
  }
  update.notify
  if ($ismin) {
    syspop $nick just connected to $network
  }
  haltdef
}

on ^*:unotify:{
  hadd various notifys $remtok($hget(various,notifys),$nick,32)
  update.notify
  haltdef
}

alias notifypop {
  popups New notifypop 16 16
  popups SetMetrics notifypop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem notifypop end + Add $cr newnotify
  popups AddItem notifypop end + Delete $cr delnotify $1 $2
  popups AddItem notifypop end +
  popups AddItem notifypop end + Msg... $cr msgnotify $1 $2
  popups AddItem notifypop end + DCC Send $cr dccsendnotify $1 $2
  popups AddItem notifypop end + DCC Chat $cr dccchatnotify $1 $2
  popups AddItem notifypop end + Whois $cr whoisnotify $1 $2
  popup notifypop $mouse.dx $mouse.dy
}

alias newnotify {
  notifyadd
}

alias delnotify {
  .notify -r $1
  update.notify
}

alias msgnotify {
  if ($notify($1).ison) {
    msg $1 $input(Please enter a Message to send to $1 $+ .,equ,Query...,$null)
  }
}

alias dccsendnotify {
  if ($notify($1).ison) {
    s $1
  }
}

alias dccchatnotify {
  if ($notify($1).ison) {
    dcc chat $1
  }
}

alias whoisnotify {
  if ($notify($1).ison) {
    whois $1
  }
}

;---SETUP DIALOG---

alias tvsetup {
  dialog -m tvsetup tvsetup
}

dialog tvsetup {
  title "Treeview Settings"
  size -1 -1 288 303
  option pixels
  tab "Treeview", 47, 5 74 276 194
  box "Colours", 48, 14 165 258 88, tab 47
  text "Headings:", 50, 30 188 50 16, tab 47
  text "Lines:", 51, 97 188 31 16, tab 47
  text "Text:", 53, 155 188 33 16, tab 47
  box "Settings", 39, 14 101 258 60, tab 47
  button "...", 45, 241 123 20 21, tab 47
  edit "", 42, 146 122 92 23, disable tab 47
  text "Font:", 43, 116 126 29 16, tab 47
  edit "", 44, 62 122 46 23, tab 47
  text "Width:", 41, 27 126 35 16, tab 47
  text "Active:", 57, 212 188 37 16, tab 47
  icon 49, 41 209 24 24,  $mircexe, 1, tab 47
  icon 52, 99 209 24 24,  $mircexe, 1, tab 47
  icon 54, 156 209 24 24,  $mircexe, 1, tab 47
  icon 56, 216 209 24 24,  $mircexe, 1, tab 47
  check "Treeview Active", 32, 8 275 108 20, tab 47
  button "Apply", 33, 163 274 58 22, tab 47
  ;check "", 5, 120 275 19 20, tab 47
  tab "Notify", 1
  box "Users", 2, 14 101 258 152, tab 1
  check "Play notify sound ", 3, 8 275 110 20, tab 1
  list 4, 26 121 233 117, tab 1 size
  button "OK", 8, 224 274 58 22, ok
  icon 6, -2 0 289 64, $scriptdir $+ libraries\icons\tvheader.png, noborder
}

on *:dialog:tvsetup:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 4 listview single rowselect showsel alignleft report > $views
  did -i $dname 4 1 headerdims 130:1 80:2
  did -i $dname 4 1 headertext 0 Nickname $+ $chr(9) $+ 0 Network
  did -ar $dname 42 $hget(various,tvfont)
  did -ar $dname 44 $hget(various,tvwidth)
  var %p = $hget(various,tvnetwork) $+ .bmp
  did -g $dname 49 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(various,tvlines) $+ .bmp
  did -g $dname 52 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(various,tvtext) $+ .bmp
  did -g $dname 54 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(various,tvactive) $+ .bmp
  did -g $dname 56 $+(",$scriptdir,libraries\icons\,%p,")
  if ($hget(various,switchbar) == 1) {
    did -c $dname 32
  }
  if ($hget(various,notify)) {
    did -c $dname 3
  }
  fillnotifys
}

on *:dialog:tvsetup:sclick:3: {
  hadd various notify $did($dname,3).state
}

on *:dialog:tvsetup:sclick:4: {
  if ($gettok($did($dname,4,1),1,32) == rclick) {
    notifydlgpop $did(4).sel $gettok($gettok($did(4).seltext,6,32),1,9)
  }
}

on *:dialog:tvsetup:sclick:32:{
  if ($did($dname,32).state == 1) {
    hadd various switchbar 1
    if (!$dialog(switchbar)) {
      sbar on
      update.notify
    }
  }
  else {
    hadd various switchbar 0
    if ($dialog(switchbar)) {
      sbar off
    }
  }
}

on *:dialog:tvsetup:sclick:33:{
  ;---APPLY---
  if ($did($dname,44)) {
    hadd various tvwidth $ifmatch
    xdock -r $dialog(switchbar).hwnd + $ifmatch 3000
  }
  colour.networks $hget(various,tvnetwork)
  xdid -i switchbar 1 +l $color($hget(various,tvlines))
  xdid -i switchbar 1 +t $color($hget(various,tvtext))
  xdid -i switchbar 3 +l $color($hget(various,tvlines))
  xdid -i switchbar 3 +t $color($hget(various,tvtext))
  sbar off
  sbar on
  update.switchbar
  update.notify
}

on *:dialog:tvsetup:sclick:45:{
  var %font = $gettok($dcx(FontDialog,ansi),4-,32)
  if (%font) {
    hadd various tvfont %font
    did -ra $dname 42 %font
    xdid -f switchbar 1 +a ansi %font
  }
}

on *:dialog:tvsetup:sclick:49:{
  var %p = various
  hadd various ColSet %p $+ ,tvnetwork
  colpick
}

on *:dialog:tvsetup:sclick:52:{
  var %p = various
  hadd various ColSet %p $+ ,tvlines
  colpick
}

on *:dialog:tvsetup:sclick:54:{
  var %p = various
  hadd various ColSet %p $+ ,tvtext
  colpick
}

on *:dialog:tvsetup:sclick:56:{
  var %p = various
  hadd various ColSet %p $+ ,tvactive
  colpick
}

alias fillnotifys {
  var %n = 1
  did -r tvsetup 4
  while (%n <= $notify(0)) {
    did -a tvsetup 4 + 0 0 0 $notify(%n) $+ $chr(9) $+ + 0 0 0 $notify(%n).network
    inc %n
  }
}
