;---Assorted Functions for NeXtGenIRC by mr.man (c) 2008---
;                          __                       .__                
;    ____   ____ ___  ____/  |_  ____   ____   ____ |__|______   ____  
;   /    \_/ __ \\  \/  /\   __\/ ___\_/ __ \ /    \|  \_  __ \_/ ___\ 
;  |   |  \  ___/ >    <  |  | / /_/  >  ___/|   |  \  ||  | \/\  \___ 
;  |___|  /\___  >__/\_ \ |__| \___  / \___  >___|  /__||__|    \___  >
;       \/     \/      \/     /_____/      \/     \/                \/  v2.02

;---ALIASES---

alias mdx { dll $shortfn($scriptdir $+ libraries\mdx.dll) $$1- }
alias popups { dll $shortfn($scriptdir $+ libraries\popups.dll) $$1- }
alias bars { return $shortfn($scriptdir $+ libraries\bars.mdx) }
alias ctl { return $shortfn($scriptdir $+ libraries\ctl_gen.mdx) } 
alias views { return $shortfn($scriptdir $+ libraries\views.mdx) }
alias dlg { return $shortfn($scriptdir $+ libraries\dialog.mdx) }
alias mtooltips { return $dll($scriptdir $+ libraries\mtooltips.dll,$1,$2-) }
alias nlist { dll $shortfn($scriptdir $+ libraries\nicklist.dll) $$1- }
alias whilefix { dll $shortfn($scriptdir $+ libraries\whilefix.dll) WhileFix . }
alias wmi { dll $shortfn($scriptdir $+ libraries\sysinfo.dll) _wmi $$1- }

alias popup { 
  tokenize 32 $dll($shortfn($scriptdir $+ libraries\popups.dll),Popup,$1-) 
  if ($isid) return $1- 
  $iif($4- != did not select a menu item,$4-)
}

alias dcx {
  if ($isid) return $dll($scriptdir $+ libraries\dcx.dll,$1,$2-)
  else dll " $+ $scriptdir $+ libraries\dcx.dll" $1 $2-
}

alias udcx {
  if ($dcx(IsUnloadSafe)) $iif($menu, .timer 1 0) dll -u dcx.dll
  else echo 4 -qmlbfti2 [DCX] Unable to Unload Dll.
}

alias xdid {
  if ( $isid ) return $dcx( _xdid, $1 $2 $prop $3- )
  dcx xdid $2 $3 $1 $4-
}

alias xdialog {
  if ( $isid ) return $dcx( _xdialog, $1 $prop $2- )
  dcx xdialog $2 $1 $3-
}

alias xpop {
  if ( $isid ) return $dcx( _xpop, $1 $prop $2- )
  dcx xpop $2 $1 $3-
}

alias xpopup {
  if ( $isid ) return $dcx( _xpopup, $1 $prop $2- )
  dcx xpopup $2 $1 $3-
}

alias mpopup {
  dcx mpopup $1 $2
}

alias xdock {
  if ($isid) return $dcx( _xdock, $1 $prop )
  dcx xdock $1-
}

alias xtray {
  if ($isid) return $dcx(TrayIcon, $1 $prop $2-)
  dcx TrayIcon $1-
}

alias xstatusbar {
  if ($isid) returnex $dcx( _xstatusbar, mIRC $prop $1- )
  dcx xstatusbar $1-
}

alias dcxml dcx dcxml $1-

alias tab {
  var %i = 1, %tab
  while (%i <= $0) {
    if ($eval($+($,%i),2) != $null) {
      %tab = $instok(%tab,$eval($+($,%i),2),$calc($numtok(%tab,9) + 1),9)
    }
    inc %i
  }
  return %tab
}

;---SOUNDS SYSTEM---

alias snd { dialog -m sounds sounds }

on *:nosound: {
  if ($hget(various,requests)) {
    theme.text $s.head(Getting Sound from) $s.encleft $+ $s.value($nick) $+ $s.encright
    .msg $nick ! $+ $nick $filename
  }
}

dialog sounds {
  title "Sound Player"
  size -1 -1 344 422
  option pixels
  tab "Sounds", 1, 4 72 335 316
  box "Select Sound", 2, 14 159 316 181, tab 1
  list 3, 24 176 295 152, tab 1 sort size
  radio "Play to Self", 4, 54 351 100 20, tab 1
  radio "Play to Channel", 5, 180 351 100 20, tab 1
  box "Sounds Directory", 11, 14 98 316 56, tab 1
  edit "", 10, 24 117 251 23, tab 1
  button "...", 12, 279 118 40 21, tab 1
  button "Cancel", 7, 226 394 55 22
  button "Play", 8, 285 394 55 22
  button "Select...", 13, 167 394 55 22
  icon 6, -2 0 347 64, $scriptdir $+ libraries\icons\soundsheader.png, noborder
}

on *:dialog:sounds:init:0: {
  var %f = $findfile($hget(various,sounddir),*.wav,0,did -a sounds 3 $nopath($1-))
  var %f = $findfile($hget(various,sounddir),*.mp3,0,did -a sounds 3 $nopath($1-))
  if ($hget(various,soundplay) == 0) {
    did -c sounds 4
    did -u sounds 5
  }
  else if ($hget(various,soundplay) == 1) {
    did -c sounds 5
    did -u sounds 4
  }
  did -ar sounds 10 $hget(various,sounddir)
}

on *:dialog:sounds:dclick:3:{
  if ($did(sounds,3).seltext) {
    var %s = $ifmatch
    dialog -x sounds
    if ($hget(various,soundplay) == 0) {
      if ($right(%s,4) == .wav) {
        splay $+(",$hget(various,sounddir),%s,")
      }
      else if ($right(%s,4) == .mp3) {
        splay -p $+(",$hget(various,sounddir),%s,")
      }
    }
    else if ($hget(various,soundplay) == 1) && ($active ischan) {
      sound $active $+(",$hget(various,sounddir),%s,")
    }
  }
}

on *:dialog:sounds:sclick:4:{
  hadd various soundplay 0
}

on *:dialog:sounds:sclick:5:{
  hadd various soundplay 1
}

on *:dialog:sounds:sclick:7:{
  dialog -x sounds
}

on *:dialog:sounds:sclick:8:{
  if ($did(sounds,3).seltext) {
    var %s = $ifmatch
    dialog -x sounds
    if ($hget(various,soundplay) == 0) {
      if ($right(%s,4) == .wav) {
        splay $+(",$hget(various,sounddir),%s,")
      }
      else if ($right(%s,4) == .mp3) {
        splay -p $+(",$hget(various,sounddir),%s,")
      }
    }
    else if ($hget(various,soundplay) == 1) && ($active ischan) {
      sound $active $+(",$hget(various,sounddir),%s,")
    }
  }
}

on *:dialog:sounds:edit:10:{
  hadd various sounddir $did(sounds,10).text
}

on *:dialog:sounds:sclick:12:{
  var %f = $hget(various,sounddir)
  if (%f) {
    var %f = $sdir($hget(various,sounddir),Select Sounds Directory)
  }
  else {
    var %f = $sdir(C:\,Select Sounds Directory)
  }
  if (%f) {
    hadd various sounddir %f
  }
  did -ar sounds 10 $hget(various,sounddir)
  did -r sounds 3
  var %f = $findfile($hget(various,sounddir),*.*,0,did -a sounds 3 $nopath($1-))
}

on *:dialog:sounds:sclick:13:{
  var %s = $sfile($hget(various,sounddir),Select Sound...,OK)
  if (%s) {
    if ($hget(various,soundplay) == 0) {
      if ($right(%s,4) == .wav) {
        splay %s
      }
      else if ($right(%s,4) == .mp3) {
        splay -p %s
      }
    }
    else if ($hget(various,soundplay) == 1) && ($active ischan) {
      sound $active $+(",%s,")
    }
  }
}
;---MESSAGE LOGGER SYSTEM---

alias logger { dialog -m logger logger }

dialog logger {
  title "Message Logger"
  size -1 -1 412 413
  option pixels
  tab "Logger", 1, 6 74 398 305
  box "Messages", 3, 13 101 384 265, tab 1
  button "", 5, 24 119 363 236, tab 1
  button "OK", 4, 330 384 75 22, ok
  icon 2, -2 0 415 64, $scriptdir $+ libraries\icons\logheader.png, noborder
}

on *:dialog:logger:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX $dname 5 window > $dlg
  window -ah @log
  did -a $dname 5 grab $window(@log).hwnd @log
  if ($exists($+(",$scriptdir,settings\log.log,"))) {
    loadbuf -pi5 @log $+(",$scriptdir,settings\log.log,")
  }
}

menu @log {
  Clear Logs:clear | write -c $+(",$scriptdir,settings\log.log,")
}

;---MESSAGES SYSTEM---

alias sversion {
  return v2.02
}

alias myversion {
  return Client: mIRC $version - Script: NeXtGenIRC $sversion
}

alias myquit {
  return http://www.nextgenirc.net
}

alias logo {
  return 0415N14e15X14t15G14en15IRC04
}

alias versionmsg {
  if ($hget(various,version) == 1) {
    return $myversion
  }
  else if ($hget(various,version) == 2) {
    return $hget(various,vcustom)
  }
  else if ($hget(various,version) == 3) {
    return $read($+(",$scriptdir,texts\,$gettok($vfiles,$hget(various,vlist),32),"))
  }
}

alias quitmsg {
  if ($hget(various,quit) == 1) {
    return $myquit
  }
  else if ($hget(various,quit) == 2) {
    return $hget(various,qcustom)
  }
  else if ($hget(various,quit) == 3) {
    return $read($+(",$scriptdir,texts\,$gettok($qfiles,$hget(various,qlist),32),"))
  }
}

alias vfiles {
  return versions.txt
}

alias qfiles {
  return anagrams.txt confucius.txt oneline.txt quitmsgs.txt wisdom.txt
}

;---VARIOUS FUNCTIONS---

on *:start:{
  unset %restart
  hmake various 10
  hload -i various $settingsini Settings
  hadd various cf12 
  var %f = $+(",$mircdir,welcome.txt,")
  if ($exists(%f)) {
    var %e = $input(This appears to be the first time you have run NXG. $crlf Do you want to import settings from a previous installation?,iuy,Information,$null)
    if (%e) {
      wz_transfer
    }
    else {
      wz_first
      .remove %f
    }
  }
  startup
  connect_profiles
}

alias ctcphandler {
  tokenize 32 $1
  var %nick = $right($gettok($2,1,33),-1)
  if ($2 == $server) {
    halt
  }
  if ($3 == PRIVMSG) {
    if (:VERSION* iswm $5) {
      .ctcpreply %nick VERSION $versionmsg
      halt
    }
    if (:ID* iswm $5) {
      idmode $6 $remove($7,$chr(1)) %nick $address(%nick,1)
      halt
    }
    if (:XDCC* iswm $5) {
      xdcchandle %nick XDCC $remove($6-,$chr(1))
      halt
    }
  }
}

alias startup {
  hmake titlebar 10
  if ($exists($titlebarini)) {
    loadtitlebarsettings
  }
  if ($hget(various,toolbar) == 1) { toolbar on }
  if ($hget(various,statusbar) == 1) { statusbar on }  
  if ($hget(various,switchbar) == 1) { sbar on }  
  nick $hget(various,Nick)
  hinc various scriptstarted
  theme.text $s.head(Welcome to NeXtGenIRC...)
  theme.text $s.head(Script Started) $s.encleft $+ $s.value($hget(various,scriptstarted)) $+ $s.encright $s.head(Times...)
  .timereverysec -o 0 1 everysec
}

alias everysec {
  titlebar $customtitlebar $str($chr(160),400)
  update.tb
  update.sb
  movelb
  if (!$hget(various,uptimerec)) {
    hadd various uptimerec 0
  }
  if ($ticks > $hget(various,uptimerec)) {
    hadd various uptimerec $ticks
    hadd various recdate $left($day,3) $date $time
  }
  if ($server) && ($hget(various,autoaway)) {
    var %l = 1
    while (%l <= $scon(0)) {
      if (!$scon(%l).away) {
        if ($calc($scon(%l).idle / 60) > $hget(various,awaytime)) {
          var %away = $hget(various,awaymessage)
          if (!%away) { var %away = I'm Away... }
          var %network = $scon(%l).network
          scon %l away %away
          scon %l a
          scon %l theme.text $s.head(You are now Auto-Away on) $s.encleft $+ $s.value(%network) $+ $s.encright $s.head(after) $s.encleft $+ $s.value($hget(various,awaytime)) $+ $s.encright $s.head(minutes.)
        }
      }
      inc %l
    }
  }
}

alias customtitlebar {
  return $left($replace($hget(titlebar,chosenfields),&script,NeXtGenIRC $sversion $strip($s.sep),&time,$time(hh:nn.sstt) $strip($s.sep),&date,$date(ddd dd/mm/yy) $strip($s.sep),&channel,$scid($activecid).chaninfo $strip($s.sep),&server,$scid($activecid).server $s.sep,&network,$scid($activecid).network $strip($s.sep)),-2)
}

on *:connect:{
  .debug -i NUL ctcphandler
  .ignore -t *
  .timermyip 1 5 myip
  lagcheck
}

;---GET EXTERNAL IP---

alias myip {
  if ($sock(myip)) { sockclose myip }
  sockopen myip checkip.dyndns.org 80 
}

on *:sockopen:myip:{ 
  sockwrite -n $sockname GET /index.php HTTP/1.0
  sockwrite -n $sockname Host: checkip.dyndns.org
  sockwrite -n $sockname user-agent: Mozilla/??
  sockwrite -n $sockname Connection: Keep-Alive
  sockwrite -n $sockname $crlf
}

on *:sockread:myip:{
  if ($sockerr > 0) return
  :nextread
  sockread %temp
  if ($sockbr == 0) return
  if (<html> isin %temp) { 
    var %ip = $remove(%temp,<html><head><title>Current IP Check</title></head><body>Current IP Address:,</body></html>)
    scon -a localinfo $chr(10) %ip 
    theme.text $s.head(Your External IP is ) $s.encleft $+ $s.value($ip) $+ $s.encright
  }  
  goto nextread
}

;---OTHER ALIASES AND EVENTS---

alias settingsini {
  return $+(",$scriptdir,settings\settings.ini,")
}

on *:exit:{
  if (!%restart) {
    hadd various nick $me
    hsave -i various $settingsini Settings
    savetitlebarsettings
  }
  .timereverysec off
  dll -u dcx.dll
  dll -u winevent.dll
  dll -u nicklist.dll
  dll -u sysinfo.dll
}

alias b {
  if ($2 isnum) {
    ban -u $+ $2 $active $1 $hget(prot,BanType)
    hinc various bans
  }
  else {
    ban $active $1 $hget(prot,BanType)
    hinc various bans
  }
}

alias dehp {
  if ($server) {
    if ($0 > 1) {
      var %o = 1
      while (%o <= $0) {
        mode $active -h [ [ $ $+ [ [ %o ] ] ] ]
        inc %o
      }
    }
    else {
      mode $active -h $1
    }
  }
}

alias hp {
  if ($server) {
    if ($0 > 1) {
      var %o = 1
      while (%o <= $0) {
        mode $active +h [ [ $ $+ [ [ %o ] ] ] ]
        inc %o
      }
    }
    else {
      mode $active +h $1
    }
  }
}

alias op {
  if ($server) {
    if ($0 > 1) {
      var %o = 1
      while (%o <= $0) {
        mode $active +o [ [ $ $+ [ [ %o ] ] ] ]
        inc %o
      }
    }
    else {
      mode $active +o $1
    }
  }
}

alias deop {
  if ($server) {
    if ($0 > 1) {
      var %o = 1
      while (%o <= $0) {
        mode $active -o [ [ $ $+ [ [ %o ] ] ] ]
        inc %o
      }
    }
    else {
      mode $active -o $1
    }
  }
}

alias j {
  if ($server) {
    var %chan = $1, %key = $2
    if ($left(%chan,1) != $chr(35)) {
      %chan = $chr(35) $+ %chan
    }
    join %chan %key
  }
}

alias v {
  if ($server) {
    if ($0 > 1) {
      var %o = 1
      while (%o <= $0) {
        mode $active +v [ [ $ $+ [ [ %o ] ] ] ]
        inc %o
      }
    }
    else {
      mode $active +v $1
    }
  }
}

alias dev {
  if ($server) {
    if ($0 > 1) {
      var %o = 1
      while (%o <= $0) {
        mode $active -v [ [ $ $+ [ [ %o ] ] ] ]
        inc %o
      }
    }
    else {
      mode $active -v $1
    }
  }
}

alias i {
  ignore -pcint $1
}

dialog kicks {
  title "Select Kick Message..."
  size -1 -1 380 354
  option pixels
  box "Select Kick Message", 1, 15 100 349 208
  list 2, 26 118 327 178, size vsbar
  button "OK", 3, 317 327 59 22, ok
  button "Cancel", 4, 254 327 59 22
  tab "Kick Messages", 5, 4 72 371 251
  icon 6, -2 0 383 64, $scriptdir $+ libraries\icons\kicksheader.png, noborder
}

on *:dialog:kicks:init:0:{
  var %i = 1
  var %k = $+(",$scriptdir,settings\kicks.dat,")
  while (%i <= $lines(%k)) {
    did -a kicks 2 $read(%k,%i)
    inc %i
  }
}

on *:dialog:kicks:sclick:3:{
  if ($did(kicks,2).sel) {
    kick $active %knick $did(kicks,2).seltext [Kick $chr(35) $+ $hget(various,kicks) $+ ]
    hinc various kicks
    if (%ban) {
      hinc various bans
      %ban
    }
    unset %knick %ban
  }
  else {
    var %k = $+(",$scriptdir,kicks.dat,")
    kick $active %knick $read(%k) [Kick $chr(35) $+ $hget(various,kicks) $+ ]
    hinc various kicks
    if (%ban) {
      hinc various bans
      %ban
    }
    unset %knick %ban
  }
}

on *:dialog:kicks:sclick:4:{
  dialog -x kicks
}

alias k {
  if ($2) {
    kick $active $1 $2- [Kick $chr(35) $+ $hget(various,kicks) $+ ]
    hinc various kicks
  }
  else {
    if ($1 ison $active) {
      %knick = $1
      dialog -m kicks kicks
    }
  }
}

alias kb {
  if ($2 isnum) && ($3) {
    ban -u $+ $2 $active $1 $hget(prot,BanType)
    hinc various bans
    kick $active $1 $3-
    hinc various kicks
  }
  else if ($2 isnum) {
    %knick = $1
    %ban = ban -u $+ $2 $active $1 $hget(prot,BanType)
    hinc various bans
    dialog -m kicks kicks
  }
  else if ($2) {
    ban $active $1 $hget(prot,BanType)
    hinc various bans
    kick $active $1 $2-
  }
  else {
    %knick = $1
    %ban = ban $active $1 $hget(prot,BanType)
    hinc various bans
    dialog -m kicks kicks
  }
}

alias p {
  ctcp $1 ping
}

alias s {
  dcc send $1 $2-
}

alias ver {
  ctcp $1 version
}

alias t {
  topic $active $1-
}

alias om {
  if ($active ischan) {
    var %to = $hget(various,opsonly)
    if (%to) {
      notice @ $+ $active $decorate(%to) $1-
    }
  }
}

alias ohm {
  if ($active ischan) {
    var %to = $hget(various,hopsandops)
    if (%to) {
      notice @ $+ % $+ $active $decorate(%to) $1-
    }
  }
}

alias ovm {
  if ($active ischan) {
    var %to = $hget(various,voiceandops)
    if (%to) {
      notice @ $+ + $+ $active $decorate(%to) $1-
    }
  }
}

alias pm {
  notice $1 $decorate($hget(various,private)) $2-
}

alias tz {
  if ($asctime(z) == -4) { return Atlantic }
  if ($asctime(z) == -5) { return EST }
  if ($asctime(z) == -6) { return CST }
  if ($asctime(z) == -7) { return MST }
  if ($asctime(z) == -8) { return PST }
  if ($asctime(z) == 0) { return GMT }
  if ($asctime(z) == +10) { return AUS-EST }
}

alias lagcheck {
  .timerLag. [ $+ [ $cid ] ] 0 10 .lagtime. $!+ $!ticks
  .raw -q lagtime. $+ $ticks 
}

raw 421:*: {
  if ($cid == $activecid) {
    if (($left($2,8) == lagtime.) && ($gettok($2,2,46) isnum)) {
      set %lag.s.time. [ $+ [ $cid ] ] $int($calc(($ticks - $gettok($2,2,46))/100))
      set %lag.ms.time. [ $+ [ $cid ] ] $calc($ticks - $gettok($2,2,46))
      if ($dialog(toolbar)) {
        did -ra toolbar 3 %lag.ms.time. [ $+ [ $activecid ] ] ms
        did -ra toolbar 2 %lag.s.time. [ $+ [ $activecid ] ]
      }
      haltdef
      unset %lag.*
    }
  }
  else halt
}

alias pri {
  var %p = $hget(various,PriCol)
  if ($len(%p) == 1) {
    %p = 0 $+ %p
  }
  return  $+ %p
}

alias sec {
  var %s = $hget(various,SecCol)
  if ($len(%s) == 1) {
    %s = 0 $+ %s
  }
  return  $+ %s
}

alias col {
  var %msg $replace($1-,$chr(32),_)
  var %x 1
  while (%x < $calc($len(%msg) + 1)) {
    set %out %out $+  $+ $base($rand(2,15),10,10,2) $+ $right($left(%msg,%x),1)
    inc %x
  }
  if ($isid == $true) { return $replace(%out,_,$chr(32)) }
  else { say $replace(%out,_,$chr(32)) }
  unset %out
}

;---TITLEBAR STUFF---

alias -l titlebarini {
  return $+(",$scriptdir,settings\titlebar.ini,")
}

alias -l loadtitlebarsettings {
  var %h = titlebar
  if ($hget(%h)) { hfree %h }
  hmake %h 10
  hload -i %h $titlebarini Settings
}

alias -l maketitlebarsettings {
  var %h = titlebar
  if ($hget(%h)) { hfree %h }
  hmake %h 10
  hadd %h chosenfields &script &time &date
  hadd %h availfields &network &server &channel
  savetitlebarsettings
}

alias -l savetitlebarsettings {
  hsave -i titlebar $titlebarini Settings
}

alias -l settitlebarfields {
  didtok various 69 32 $hget(titlebar,availfields)
  didtok various 72 32 $hget(titlebar,chosenfields)
}

dialog various {
  title "Various Settings"
  size -1 -1 479 423
  option pixels
  tab "Messages", 5, 4 74 470 314
  box "Version Messages", 7, 14 105 451 101, tab 5
  radio "Default Message", 21, 29 125 108 20, tab 5
  radio "Custom Message", 22, 29 149 104 20, tab 5
  radio "Random Message", 23, 29 173 105 20, tab 5
  edit "", 24, 137 147 308 22, tab 5 autohs
  combo 25, 137 173 308 100, tab 5 size drop
  edit "", 11, 137 122 308 22, tab 5 read autohs
  box "Quit Messages", 10, 14 210 451 102, tab 5
  radio "Default Message", 14, 29 231 108 20, tab 5
  radio "Custom Message", 15, 29 255 104 20, tab 5
  radio "Random Message", 16, 29 279 105 20, tab 5
  combo 18, 137 279 308 100, tab 5 size drop
  edit "", 17, 137 253 308 22, tab 5 autohs
  edit "", 12, 137 228 308 22, tab 5 read autohs
  box "Message Prefixes", 58, 14 316 450 61, tab 5
  text "Private:", 62, 314 343 40 16, tab 5
  edit "", 66, 357 339 88 23, tab 5 autohs
  edit "", 64, 216 339 96 23, tab 5 autohs
  text "Ops && Hops:", 60, 154 343 61 16, tab 5
  edit "", 63, 59 339 92 23, tab 5 autohs
  text "Ops:", 59, 31 344 25 16, tab 5
  tab "Misc", 13
  box "Sound System", 26, 14 103 132 78, tab 13
  check "Pager Active", 30, 27 205 96 20, tab 13
  box "Pager Settings", 67, 14 186 132 188, tab 13
  list 77, 26 248 109 112, tab 13 size
  check "Sounds Active", 1, 27 125 100 20, tab 13
  check "Requests Active", 6, 27 146 100 20, tab 13
  box "Titlebar Settings", 68, 155 103 310 155, tab 13
  text "Available Fields...", 70, 167 126 93 16, tab 13
  list 69, 165 145 107 100, tab 13 size
  button "->", 73, 288 147 44 21, disable tab 13
  button "<-", 74, 288 172 44 21, disable tab 13
  button "Up", 75, 288 197 44 21, disable tab 13
  button "Down", 76, 288 223 44 21, disable tab 13
  list 72, 347 145 107 100, tab 13 size
  text "Selected Fields...", 71, 349 126 93 16, tab 13
  box "Custom Settings", 9, 154 262 147 111, tab 13
  check "Toolbar Active", 19, 167 282 100 20, tab 13
  edit "", 82, 166 336 100 23, disable tab 13
  button "...", 83, 268 337 20 21, tab 13
  check "Statusbar Active", 20, 167 308 100 20, tab 13
  text "Exclude Channels...", 27, 27 230 103 16, tab 13
  box "Google Settings", 28, 310 262 155 47, tab 13
  radio "IE", 2, 335 280 34 20, group tab 13
  radio "FireFox", 3, 379 280 74 20, tab 13
  icon 4, 343 334 24 24,  $mircexe, 1, tab 13
  icon 29, 401 334 24 24,  $mircexe, 1, tab 13
  box "Script Colours", 31, 310 312 155 61, tab 13
  button "OK", 8, 400 394 75 22, ok
  icon 32, -2 0 484 64, $scriptdir $+ libraries\icons\variousheader.png, noborder
}

alias various {
  dialog -m various various
}

on *:dialog:various:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 77 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 77 1 headerdims 85:1
  did -i $dname 77 1 headertext 0 Channels
  if ($hget(various,Browser) == 1) {
    did -c various 2
    did -u various 3
  }
  else if ($hget(various,Browser) == 2) {
    did -c various 3
    did -u various 2
  }
  if ($hget(various,version) == 1) {
    did -c various 21
  }
  else if ($hget(various,version) == 2) {
    did -c various 22
  }
  else if ($hget(various,version) == 3) {
    did -c various 23
  }
  if ($hget(various,quit) == 1) {
    did -c various 14
  }
  else if ($hget(various,quit) == 2) {
    did -c various 15
  }
  else if ($hget(various,quit) == 3) {
    did -c various 16
  }
  if ($hget(various,sounds) == 1) {
    .sound on
    did -c various 1
  }
  else if ($hget(various,sounds) == 0) {
    .sound off
    did -u various 1
  }
  if ($hget(various,requests) == 1) {
    did -c various 6
  }
  else if ($hget(various,requests) == 0) {
    did -u various 6
  }
  did -ar various 11 $myversion
  did -ar various 24 $hget(various,vcustom)
  didtok various 25 32 $vfiles
  did -c various 25 $hget(various,vlist)
  did -ar various 12 $myquit
  did -ar various 17 $hget(various,qcustom)
  didtok various 18 32 $qfiles
  did -c various 18 $hget(various,qlist)
  if ($hget(various,pager)) {
    did -c various 30
  }
  else {
    did -u various 30
  }
  if ($hget(various,toolbar) == 1) {
    did -c various 19
  }
  else if ($hget(various,toolbar) == 0 ) {
    did -u various 19
  }
  if ($hget(various,statusbar) == 1) {
    did -c various 20
  }
  else if ($hget(various,statusbar) == 0) {
    did -u various 20
  }
  did -ar various 63 $hget(various,opsonly)
  did -ar various 64 $hget(various,hopsandops)
  did -ar various 66 $hget(various,private)
  settitlebarfields
  didtok -ar various 77 32 $hget(various,exhighlight)
  did -ar various 82 $hget(various,statusbarfont)
  var %p = $hget(various,PriCol) $+ .bmp
  did -g various 4 $+(",$scriptdir,libraries\icons\,%p,")
  var %s = $hget(various,SecCol) $+ .bmp
  did -g various 29 $+(",$scriptdir,libraries\icons\,%s,")
}

on *:dialog:various:sclick:2:{
  hadd various Browser 1
}

on *:dialog:various:sclick:3:{
  hadd various Browser 2
}

on *:dialog:various:sclick:4: {
  hadd various ColSet various $+ ,PriCol
  colpick
}

on *:dialog:various:sclick:29: {
  hadd various ColSet various $+ ,SecCol
  colpick
}

on *:dialog:various:sclick:8:{
  colour.networks $hget(various,tvnetwork)
  xdid -i switchbar 1 +l $color($hget(various,tvlines))
  xdid -i switchbar 1 +t $color($hget(various,tvtext))
  hadd titlebar availfields $didtok($dname,69,32)
  hadd titlebar chosenfields $didtok($dname,72,32)
  dialog -v cpanel
}

on *:dialog:various:sclick:19:{
  if ($did($dname,19).state == 1) {
    hadd various toolbar 1
    toolbar on
  }
  else {
    hadd various toolbar 0
    toolbar off
  }
}

on *:dialog:various:sclick:20:{
  if ($did($dname,20).state == 1) {
    hadd various statusbar 1
    statusbar on
  }
  else {
    hadd various statusbar 0
    statusbar off
  }
}

on *:dialog:various:sclick:21:{
  hadd various version 1
}

on *:dialog:various:sclick:22:{
  hadd various version 2
}

on *:dialog:various:sclick:23:{
  hadd various version 3
}

on *:dialog:various:edit:24:{
  hadd various vcustom $did($dname,24)
}

on *:dialog:various:edit:17:{
  hadd various qcustom $did($dname,17)
}

on *:dialog:various:sclick:14:{
  hadd various quit 1
}

on *:dialog:various:sclick:15:{
  hadd various quit 2
}

on *:dialog:various:sclick:16:{
  hadd various quit 3
}

on *:dialog:various:sclick:18:{
  hadd various qlist $did(various,18).sel
}

on *:dialog:various:sclick:25:{
  hadd various vlist $did(various,25).sel
}

on *:dialog:various:sclick:1:{
  if ($did($dname,1).state == 1) {
    .sound on
    hadd various sounds 1
  }
  else {
    .sound off
    hadd various sounds 0
  }  
}

on *:dialog:various:sclick:6:{
  if ($did($dname,6).state == 1) {
    hadd various requests 1
  }
  else {
    hadd various requests 0
  }
}

on *:dialog:various:sclick:30:{
  hadd various pager $did(various,30).state
}

on *:dialog:various:edit:63:{
  hadd various opsonly $did($dname,63).text
}

on *:dialog:various:edit:64:{
  hadd various hopsandops $did($dname,64).text
}

on *:dialog:various:edit:65:{
  hadd various voiceandops $did($dname,65).text
}

on *:dialog:various:edit:66:{
  hadd various private $did($dname,66).text
}

on *:dialog:various:sclick:77:{
  if ($gettok($did($dname,77,1),1,32) == rclick) {
    expagerpop $did(77).sel $gettok($gettok($did(77).seltext,6,32),1,9)
  }
}

on *:dialog:various:sclick:69: {
  did -e $dname 73
  did -b $dname 74,75,76
}

on *:dialog:various:sclick:72: {
  did -b $dname 73
  did -e $dname 74,75,76
}

on *:dialog:various:sclick:73: {
  did -a $dname 72 $did($dname,69,$did($dname,69).sel)
  did -d $dname 69 $did($dname,69).sel
  did -c $dname 69 1
}

on *:dialog:various:sclick:74: {
  did -a $dname 69 $did($dname,72,$did($dname,72).sel)
  did -d $dname 72 $did($dname,72).sel
  did -c $dname 72 1
}

on *:dialog:various:sclick:75: {
  var %temp = $calc($did($dname,72).sel - 1)
  did -i $dname 72 %temp $did($dname,72,$did($dname,72).sel)
  did -d $dname 72 $did($dname,72).sel
  did -c $dname 72 %temp
}

on *:dialog:various:sclick:76: {
  if ($did($dname,72).sel < $did($dname,72).lines) {
    var %temp = $calc($did($dname,72).sel + 2)
    did -i $dname 72 %temp $did($dname,72,$did($dname,72).sel)
    did -d $dname 72 $did($dname,72).sel
    did -c $dname 72 $calc(%temp - 1)
  }
}

on *:dialog:various:sclick:78: {
  var %p = $input(Please enter channel name.,equ,Query...,$null)
  if (%p) {
    if ($left(%p,1) != $chr(35)) {
      %p = $chr(35) $+ %p
    }
    did -a various 77 %p
    hadd various exhighlight $didtok(various,77,32)
  }
}

on *:dialog:various:sclick:79: {
  var %t = $did(various,77).sel
  if (%t) {
    did -d various 77 %t
    hadd various exhighlight $didtok(various,77,32)
  }
}

on *:dialog:various:sclick:83:{
  var %font = $gettok($dcx(FontDialog,ansi),4-,32)
  hadd various statusbarfont %font
  did -ra various 82 %font
  xstatusbar -f + ansi %font
}

;---POPUP---

alias expagerpop {
  popups New expagerpop 16 16
  popups SetMetrics expagerpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem expagerpop end + Add $cr addexpager
  popups AddItem expagerpop end + Delete $cr delexpager $1 $2
  popup expagerpop $mouse.dx $mouse.dy
}

alias addexpager {
  var %c = $input(Please enter a channel name.,equ,Query...,$null)
  if (%c) {
    hadd various exhighlight $addtok($hget(various,exhighlight),%c,32)
    did -a various 77 + 0 0 0 %c
  }
}

alias delexpager {
  did -d various 77 $1
  hadd various exhighlight $remtok($hget(various,exhighlight),$2,32)
}

alias statusbar {
  if ($1 == on) {
    xstatusbar -A 1
    xstatusbar -f + ansi $hget(various,statusbarfont)
    xstatusbar -l 220 220 240 175 -1
    xstatusbar -w + 0 $shortfn($+(",$scriptdir,libraries\icons\status.ico,"))
    xstatusbar -w + 0 $shortfn($+(",$scriptdir,libraries\icons\channel.ico,"))
    xstatusbar -w + 0 $shortfn($+(",$scriptdir,libraries\icons\idle.ico,"))
    xstatusbar -w + 0 $shortfn($+(",$scriptdir,libraries\icons\vidmem.ico,"))
    xstatusbar -w + 0 $shortfn($+(",$scriptdir,libraries\icons\music.ico,"))

  }
  else if ($1 == off) {
    xstatusbar -A 0
  }
}

dialog away {
  title "Away System "
  size -1 -1 300 242
  option pixels
  tab "Away...", 1, 4 75 290 138
  box "Settings", 3, 13 100 272 99, tab 1
  edit "", 4, 138 124 54 23, tab 1
  text "Set Auto Away after", 5, 28 129 104 16, tab 1
  text "minutes idle.", 6, 200 128 65 16, tab 1
  text "Message:", 7, 28 162 47 16, tab 1
  combo 8, 79 158 112 83, tab 1 size edit drop
  check "Auto Away Active", 12, 5 216 116 20, tab 1
  button "OK", 2, 221 216 75 22, ok
  button "Add", 11, 196 159 35 19
  button "Delete", 9, 233 159 40 19
  icon 10, -1 1 307 64, $scriptdir $+ libraries\icons\awayheader.png, noborder
}

on *:dialog:away:init:0:{
  did -ar away 4 $hget(various,awaytime)
  if ($hget(various,autoaway)) {
    did -c away 12
  }
  else {
    did -u away 12
  }
  var %l = 1
  while (%l <= $lines($scriptdirsettings\away.dat)) {
    did -a away 8 $read($scriptdirsettings\away.dat,%l)
    inc %l
  }
  var %l = 1
  while (%l <= $did(away,8).lines) {
    if ($did(away,8,%l).text == $hget(various,awaymessage)) {
      did -c away 8 %l
    }
    inc %l
  }
  did -c away 8 $hget(various,awaymsgnum)
}

on *:dialog:away:sclick:2:{
  hadd various awaytime $did(away,4).text
  hadd various awaymessage $did(away,8).text
  hadd various awaymsgnum $did(away,8).sel
  hadd various autoaway $did(away,12).state
  dialog -v cpanel
}

on *:dialog:away:sclick:9:{
  did -d away 8 $did(away,8,1).sel
  write -c $+(",$scriptdir,settings\away.dat,")
  var %l = 1
  while (%l <= $did(away,8).lines) {
    write $+(",$scriptdir,settings\away.dat,") $did(away,8,%l).text
    inc %l
  }
}

on *:dialog:away:sclick:11:{
  var %a = $input(Please enter a new Away Message...,equ,Query...,$null)
  write $+(",$scriptdir,settings\away.dat,") %a
  did -a away 8 %a
}

alias awaysys {
  dialog -m away away
}

on *:notice:*:*:{
  if (!$istok(HostServ.Chanserv.NickServ.SecureServ.Global.Da_Man,$nick,46)) {
    if ($hget(various,pager)) { 
      ;splay -w $+(",$sound(wave),pager.wav,")
    }
    var %n = $network
    if ($me == $hget(%n,AwayNick)) || ($me == $hget(%n,AwayDownNick)) {
      dolog $timestamp Notice $nick $1-
    }
  }
}

alias dolog {
  write $+(",$scriptdir,settings\log.log,") $1 $2 ( $+ $3 $+ ) $4-
}

;---ALARM CLOCK---

alias alarm {
  dialog -m alarm alarm
}

dialog alarm {
  title "Alarm Clock"
  size -1 -1 301 224
  option pixels
  button "OK", 2, 222 197 75 22, ok
  tab "Alarm Settings", 12, 3 71 293 121
  box "Alarm", 1, 11 94 277 85, tab 12
  text "Alarm Time:", 5, 77 117 62 16, tab 12
  edit "", 6, 145 113 30 23, tab 12
  text ":", 7, 178 116 8 16, tab 12
  edit "", 8, 184 113 30 23, tab 12
  text "Alarm Sound:", 9, 20 146 66 16, tab 12
  edit "", 10, 89 141 156 23, tab 12 autohs
  button "...", 11, 248 142 27 21, tab 12
  check "Alarm Active", 3, 4 196 133 20
  icon 4, -2 0 304 64, $scriptdir $+ libraries\icons\alarmheader.png, noborder
}

on *:dialog:alarm:init:0:{
  if ($hget(various,AlarmHour)) {
    did -a $dname 6 $ifmatch
  }
  if ($hget(various,AlarmMin)) {
    did -a $dname 8 $ifmatch
  }
  if ($hget(various,AlarmSnd)) {
    did -a $dname 10 $ifmatch
  }
}

on *:dialog:alarm:sclick:3:{
  if ($did($dname,3).state == 1) {
    if ($hget(various,AlarmHour) && $hget(various,AlarmMin)) {
      .timeralarm $hget(various,AlarmHour) $+ : $+ $hget(various,AlarmMin) 1 1 doalarm
    }
  }
  else {
    .timeralarm off
  }
}

on *:dialog:alarm:sclick:2:{
}

on *:dialog:alarm:edit:6:{
  hadd various AlarmHour $did($dname,6)
}

on *:dialog:alarm:edit:8:{
  hadd various AlarmMin $did($dname,8)
}

on *:dialog:alarm:sclick:11:{
  var %alarm = $sfile($sound(wave),Select Alarm Sound...,OK)
  did -ar $dname 10 %alarm
  hadd various AlarmSnd %alarm
}

alias doalarm {
  splay $hget(various,AlarmSnd)
  noop $input(Your Alarm is Sounding...,owu,Info...,$null)
  splay stop
}

;---STATUS BAR STUFF---

alias update.sb {
  if ($xstatusbar().visible) {
    xstatusbar -t 1 + 1 Server: $+($iif($scid($activecid).server,$scid($activecid).server,Not Connected))
    xstatusbar -t 2 + 2 $iif($left($active,1) == $chr(35),Channel:,Query:) $scid($activecid).chaninfo
    xstatusbar -t 3 + 3 Idle: $duration($scid($activecid).idle)
    xstatusbar -t 4 + 4 RAM: $ram
    xstatusbar -t 5 + 5 MP3: $iif($insong,$mp3.info(title) by $mp3.info(artist) $chr(40) $+ $mp3.info(length) $+ $chr(41) $chr(40) $+ $duration($calc($insong.pos / 1000)) $+ $chr(41),None)) 
  }
}

alias -l chaninfo {
  return $active $iif($active ischan,$chr(40) $+ $nick($active,0) $+ $chr(41) $chan($active).mode,$null)
}

alias -l ram {
  tokenize 32 $dll($scriptdir $+ libraries\sysinfo.dll,_mem,.)
  return $round($calc($calc($1 - $2) / 1024 / 1024),0) $+ MB $+ / $+ $round($calc($1 / 1024 / 1024),0) $+ MB
}

alias helpsys {
  dialog -m helpsys helpsys
}

dialog helpsys {
  title "Help System"
  size -1 -1 534 448
  option pixels
  icon 4, -2 0 537 64, $scriptdir $+ libraries\icons\helpheader.png, noborder
}

on *:dialog:helpsys:init:0:{
  dcx Mark $dname help_callback
  xdialog -c $dname 1 tab 5 75 522 335 tabstop notheme
  xdid -a $dname 1 0 0 Help System $chr(9) 2 panel 4 22 292 174 0 0 300 200
  xdialog -c $dname 3 button 452 418 75 22
  xdid -t $dname 3 OK
  xdid -c $dname 2 5 treeview 4 5 150 300 haslines tabstop
  xdid -c $dname 2 6 webctrl 160 5 350 300 tabstop
  xdid -f $dname 1 + ansi 8 Tahoma
  xdid -f $dname 5 + ansi 8 Tahoma
  list_features
}

alias list_features {
  xdid -a helpsys 5 $tab(-1,+eb 1 1 0 0 0 255 0 Welcome)
  xdid -a helpsys 5 $tab(-1 -1,+eb 1 1 0 0 0 255 0 Display)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 MTS)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Nicklist)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Statusbar)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Titlebar)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Toolbar)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Treeview)
  xdid -a helpsys 5 $tab(-1 -1,+eb 1 1 0 0 0 255 0 File Sharing)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 DCC Extras)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 FileFinder)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 FServe)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 FTPd)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 FTP Client)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Send Manager)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 XDCC Server)
  xdid -a helpsys 5 $tab(-1 -1,+eb 1 1 0 0 0 255 0 Messages)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Prefixes)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Quit)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Version)
  xdid -a helpsys 5 $tab(-1 -1,+eb 1 1 0 0 0 255 0 Protection)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Personal)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Channel)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Anti-Spam)
  xdid -a helpsys 5 $tab(-1 -1,+eb 1 1 0 0 0 255 0 Various)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Acronyms)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Away System)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Blowfish)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Commands)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Email Checker)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 F-Keys)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Mp3 Player)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Mode Manager)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Nick Completer)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Profiles)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Seen System)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Sysinfo)
  xdid -a helpsys 5 $tab(1 -1 -1,+e 1 1 0 0 0 255 0 Wizards)
  xdid -n helpsys 6 file:// $+ $+($scriptdir,libraries\docs\welcome.htm)
}

alias help_callback {
  if ($2 == sclick) {
    if ($3 == 3) {
      dialog -x helpsys
    }
    else if ($3 == 5) {
      var %url = $xdid(helpsys,5,$4-).text
      xdid -n helpsys 6 file:// $+ $+($scriptdir,libraries\docs\ $+ [ [ %url ] ] $+ ,.htm)
    }
  }
}

;---GOOGLE SEARCH---

alias g {
  if ($hget(various,Browser) == 1) {
    .run iexplore.exe www.google.com/search?hl=en&q= $+ $1-
  }
  else if ($hget(various,Browser) == 2) {
    .run firefox.exe " $+ www.google.com/search?hl=en&q= $+ $1- $+ "
  }
}

;---COLOUR PALETTE DIALOGS---

alias colpick {
  if (!$dialog(colpick)) {
    dialog -om colpick colpick
  }
}

dialog colpick {
  title "Colours"
  size -1 -1 123 123
  option pixels
  icon 1, 4 4 24 24
  icon 2, 34 4 24 24
  icon 3, 64 4 24 24
  icon 4, 94 4 24 24
  icon 5, 4 34 24 24
  icon 6, 34 34 24 24
  icon 7, 64 34 24 24
  icon 8, 94 34 24 24
  icon 9, 4 64 24 24
  icon 10, 34 64 24 24
  icon 11, 64 64 24 24
  icon 12, 94 64 24 24
  icon 13, 4 94 24 24
  icon 14, 34 94 24 24
  icon 15, 64 94 24 24
  icon 16, 94 94 24 24
}

on *:dialog:colpick:init:0:{
  var %l = 0,
  while (%l <= 15) {
    var %i = [ [ %l ] ] $+ .bmp
    did -g $dname $calc(%l + 1) $+(",$scriptdir,libraries\icons\,%i,")
    inc %l
  }
}

on *:dialog:colpick:sclick:*:{
  var %h = $gettok($hget(various,ColSet),1,44)
  var %i = $gettok($hget(various,ColSet),2,44)
  if (%h) && (%i) {
    hadd %h %i $calc($did - 1)
    if (%i == PriCol) {
      var %p = $hget(%h,PriCol) $+ .bmp
      did -g various 4 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == SecCol) {
      var %p = $hget(%h,SecCol) $+ .bmp
      did -g various 29 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == tvnetwork) {
      var %p = $hget(various,tvnetwork) $+ .bmp
      did -g tvsetup 49 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == tvlines) {
      var %p = $hget(various,tvlines) $+ .bmp
      did -g tvsetup 52 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == tvtext) {
      var %p = $hget(various,tvtext) $+ .bmp
      did -g tvsetup 54 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == tvactive) {
      var %p = $hget(various,tvactive) $+ .bmp
      did -g tvsetup 56 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == owner) {
      var %p = $hget(colours,owner) $+ .bmp
      did -g colours 3 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == admin) {
      var %p = $hget(colours,admin) $+ .bmp
      did -g colours 5 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == op) {
      var %p = $hget(colours,op) $+ .bmp
      did -g colours 7 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == help) {
      var %p = $hget(colours,help) $+ .bmp
      did -g colours 9 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == voice) {
      var %p = $hget(colours,voice) $+ .bmp
      did -g colours 15 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == reg) {
      var %p = $hget(colours,reg) $+ .bmp
      did -g colours 13 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == self) {
      var %p = $hget(colours,self) $+ .bmp
      did -g colours 11 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == howner) {
      var %p = $hget(colours,howner) $+ .bmp
      did -g colours 36 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == hadmin) {
      var %p = $hget(colours,hadmin) $+ .bmp
      did -g colours 31 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == hop) {
      var %p = $hget(colours,hop) $+ .bmp
      did -g colours 29 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == hhelp) {
      var %p = $hget(colours,hhelp) $+ .bmp
      did -g colours 27 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == hvoice) {
      var %p = $hget(colours,hvoice) $+ .bmp
      did -g colours 25 $+(",$scriptdir,libraries\icons\,%p,")
    }
    if (%i == hreg) {
      var %p = $hget(colours,hreg) $+ .bmp
      did -g colours 23 $+(",$scriptdir,libraries\icons\,%p,")
    }
  }
  dialog -x colpick 
}

alias colpickadv {
  if (!$dialog(colpickadv)) {
    dialog -om colpickadv colpickadv
  }
}

dialog colpickadv {
  title "Colours"
  size -1 -1 123 151
  option pixels
  icon 1, 4 4 24 24
  icon 2, 34 4 24 24
  icon 3, 64 4 24 24
  icon 4, 94 4 24 24
  icon 5, 4 34 24 24
  icon 6, 34 34 24 24
  icon 7, 64 34 24 24
  icon 8, 94 34 24 24
  icon 9, 4 64 24 24
  icon 10, 34 64 24 24
  icon 11, 64 64 24 24
  icon 12, 94 64 24 24
  icon 13, 4 94 24 24
  icon 14, 34 94 24 24
  icon 15, 64 94 24 24
  icon 16, 94 94 24 24
  icon 17, 4 123 114 24
}

on *:dialog:colpickadv:init:0:{
  var %l = 0,
  while (%l <= 16) {
    var %i = [ [ %l ] ] $+ .bmp
    did -g $dname $calc(%l + 1) $+(",$scriptdir,libraries\icons\,%i,")
    inc %l
  }
}

on *:dialog:colpickadv:sclick:*:{
  var %h = $gettok($hget(various,ColSet),1,44)
  var %i = $gettok($hget(various,ColSet),2,44)
  hadd %h %i $calc($did - 1)
  if (%i == head.colour) {
    if ($hget(%h,head.colour) == 16) {
      var %p = nocol.bmp
    }
    else {
      var %p = $hget(%h,head.colour) $+ .bmp
    }
    did -g sysinfo 9 $+(",$scriptdir,libraries\icons\,%p,")
  }
  if (%i == value.colour) {
    if ($hget(%h,value.colour) == 16) {
      var %p = nocol.bmp
    }
    else {
      var %p = $hget(%h,value.colour) $+ .bmp
    }
    did -g sysinfo 3 $+(",$scriptdir,libraries\icons\,%p,")
  }
  if (%i == enc.colour) {
    if ($hget(%h,enc.colour) == 16) {
      var %p = nocol.bmp
    }
    else {
      var %p = $hget(%h,enc.colour) $+ .bmp
    }
    did -g sysinfo 13 $+(",$scriptdir,libraries\icons\,%p,")
  }
  if (%i == sep.colour) {
    if ($hget(%h,sep.colour) == 16) {
      var %p = nocol.bmp
    }
    else {
      var %p = $hget(%h,sep.colour) $+ .bmp
    }
    did -g sysinfo 23 $+(",$scriptdir,libraries\icons\,%p,")
  }
  dialog -x colpickadv 
}

;---SCRIPTINFO---

alias scriptinfo {
  if (!$dialog(scriptinfo)) {
    dialog -m scriptinfo scriptinfo
  }
}

dialog scriptinfo {
  title "Script Information"
  size -1 -1 374 300
  option pixels
  icon 1, 0 0 373 62,  $shortfn($scriptdir $+ libraries\icons\logo.png), 0
  button "OK", 4, 303 269 65 22, ok
  text "______________________________________________________________________", 2, 1 247 375 16, disable
  text "Credits:", 3, 51 99 50 16
  text "Design and Script  mr.man", 5, 115 99 160 16
  text "Testing and ideas by bIOforger", 6, 115 121 160 16
  text "DLLs && Themes by various authors", 7, 115 144 200 16
  text "", 8, 320 65 40 16
  text "Website:", 9, 51 184 50 16
  text "Email:", 10, 51 212 50 16
}

on *:dialog:scriptinfo:init:0:{
  dcx Mark $dname info_callback
  did -ar $dname 8 $sversion
  xdialog -c $dname 11 link 115 180 200 20
  xdid -t $dname 11 www.nextgenirc.net
  xdialog -c $dname 12 link 115 208 200 20
  xdid -t $dname 12 mr.man@nextgenirc.net
}

alias info_callback {
  if ($2 == sclick) {
    if ($3 == 11) {
      if ($hget(various,Browser) == 1) {
        .run iexplore.exe www.nextgenirc.net
      }
      else if ($hget(various,Browser) == 2) {
        .run firefox.exe " $+ www.nextgenirc.net $+ "
      }
    }
    if ($3 == 12) {
      .run mailto:mr.man@nextgenirc.net
    }
  }
}

alias syspop {
  mtooltips SetTooltipWidth 
  mtooltips SpawnTooltip +a $calc($window(-1).w - 310) $calc($window(-1).h - 100) 5000 > NeXtGenIRC Event: $chr(4) $1-
  var %pos = $dll($+(",$scriptdir,libraries\mtooltips.dll,"), TooltipSize, 1) 
  mtooltips MoveTooltip 1 $calc($window(-1).w - $gettok(%pos,2,32) - 30) $calc($window(-1).h - $gettok(%pos,3,32) - 30)
}

alias ismin {
  if ($appstate == minimized) || ($appstate == tray) {
    return $true
  }
  else {
    return $false
  }
}

;---SCRIPT STATS---

alias sf {
  return $script(0)
}

alias sl {
  var %l = 0, %s = 1
  while (%s <= $script(0)) {
    %l = $calc(%l + $lines($+(",$script(%s),")))
    inc %s
  }
  return %l
}

;---MENU---

menu status,menubar,channel {
  Control Panel...:cpanel
  -
  DCC Xtras...
  .$iif($hget(ftps,Active) == 1,$style(1)) On:hadd ftps Active 1
  .$iif($hget(ftps,Active) != 1,$style(1)) Off:hadd ftps Active 0
  .Log...:dcc2ftp_display
  .Setup...:dccextras
  FServe...
  .Control:fscontrol
  .Settings:fserver
  .Advertise:fservead
  .$iif($hget(fserve,active) == $true,$style(1)) On:fserveon | hadd fserve active $true
  .$iif($hget(fserve,active) == $false,$style(1)) Off:fserveoff | hadd fserve active $false
  FTP Client...
  .Open...:ftpc
  .Stats...:ftpcstats
  .Activity...:ftpcactivity
  FTP Server...
  .Stats...:ftpdstats
  .Activity...:ftpdactivity
  .Setup...:ftpd
  .Reset Stats:clearftpstats
  .$iif($hget(ftpd,active) == 1,$style(1)) On:ftpstart
  .$iif($hget(ftpd,active) != 1,$style(1)) Off:ftpstop
  System Info...
  .System:sys
  .OS:say $iif($istok($hget(various,mono),$active,44),$strip($sys.os),$sys.os)
  .CPU:say $iif($istok($hget(various,mono),$active,44),$strip($sys.cpu),$sys.cpu)
  .Mobo:say $iif($istok($hget(various,mono),$active,44),$strip($sys.mobo),$sys.mobo)
  .BIOS:say $iif($istok($hget(various,mono),$active,44),$strip($sys.bios),$sys.bios)
  .Uptime:say $iif($istok($hget(various,mono),$active,44),$strip($sys.uptime),$sys.uptime)
  .Memory:say $iif($istok($hget(various,mono),$active,44),$strip($sys.mem),$sys.mem)
  .Disks: disks
  .HD Space:say $iif($istok($hget(various,mono),$active,44),$strip($sys.hds),$sys.hds)
  .Network:say $iif($istok($hget(various,mono),$active,44),$strip($sys.network),$sys.network)
  .Display:say $iif($istok($hget(various,mono),$active,44),$strip($sys.display),$sys.display)
  .Sound:say $iif($istok($hget(various,mono),$active,44),$strip($sys.sound),$sys.sound)
  .Temps:say $iif($istok($hget(various,mono),$active,44),$strip($sys.temps),$sys.temps)
  .Fans:say $iif($istok($hget(various,mono),$active,44),$strip($sys.fans),$sys.fans)
  .Monitor: say $iif($istok($hget(various,mono),$active,44),$strip($sys.mon),$sys.mon)
  .Bandwidth: bandwidth
  .Time/Date:say $iif($istok($hget(various,mono),$active,44),$strip($sys.td),$sys.td)
  .NXG:say $iif($istok($hget(various,mono),$active,44),$strip($sys.nxg),$sys.nxg)
  .mIRC:say $iif($istok($hget(various,mono),$active,44),$strip($sys.mirc),$sys.mirc)
  View Logs...
  .All Logs...:logviewer
  .Pager Log...:logger
  Wizards...
  .Add New Network...:wz_newnet
  .Transfer Settings...:wz_transfer
  XDCC Server...
  .Setup...:xdccserver
  .Advertise...:displayadvert
  .Stats...:xdccsrvstats
  .$iif($hget(xdccsrv,active) == 1,$style(1)) On:xdccsrvon
  .$iif($hget(xdccsrv,active) != 1,$style(1)) Off:xdccsrvoff
  -
  Alarm Clock...:alarm
  Channel Stats...:chanstats
  DCC Stats...:dccstats
  Email Checker...:email
  Mode Manager...:modemgr
  Mp3 Advert...:mp3
  Play Sounds...:snd
  Send Manager...:dccman
  System Stats...:sds
  XDCC Viewer...: { dialog -m xdccv xdccv | xdcc_refresh }
}
