;---Channel Central by mr.man (C) 2008 - Part of NeXtGenIRC---

;---EVENTS---

on *:start:{ hmake channel 32 }

on *:exit:{ hfree channel }

;---ALIASES---

alias channel {
  hadd channel chan $active
  if (!$chan($active).ibl) {
    mode $active +b
  }
  if (!$dialog(channel)) {
    dialog -m channel channel
  }
}

alias listbans {
  did -r channel 29
  var %b = 1, %chan = $hget(channel,chan)
  while (%b <= $ibl(%chan,0)) {
    whilefix
    did -a channel 29 + 0 0 0 $ibl(%chan,%b) $+ $chr(9) $+ + 0 0 0 $ibl(%chan,%b).by $+ $chr(9) $+ + 0 0 0 $asctime($ibl(%chan,%b).ctime,dd/mm/yy hh:nntt)
    inc  %b
  }
}    

alias listinvites {
  did -r channel 31
  var %i = 1, %chan = $hget(channel,chan)
  while (%i <= $iil(%chan,0)) {
    whilefix
    did -a channel 31 + 0 0 0 $iil(%chan,%i) $+ $chr(9) $+ + 0 0 0 $iil(%chan,%i).by $+ $chr(9) $+ + 0 0 0 $asctime($iil(%chan,%i).ctime,dd/mm/yy hh:nntt)
    inc  %i
  }
}    

alias listexcepts {
  did -r channel 32
  var %e = 1, %chan = $hget(channel,chan)
  while (%e <= $iel(%chan,0)) {
    whilefix
    did -a channel 32 + 0 0 0 $iel(%chan,%e) $+ $chr(9) $+ + 0 0 0 $iel(%chan,%e).by $+ $chr(9) $+ + 0 0 0 $asctime($iel(%chan,%e).ctime,dd/mm/yy hh:nntt)
    inc  %e
  }
}    

alias listusers {
  if (G isin $6) { var %away = Yes }
  if (* isin $6) { var %ircop = Yes }
  if (~ isin $6) { var %mode = Owner }
  else if (& isin $6) { var %mode = Admin }
  else if (@ isin $6) { var %mode = Op }
  else if (% isin $6) { var %mode = HalfOp }
  else if (+ isin $6) { var %mode = Voice }
  did -a channel 35 + 0 0 0 $5 $+ $chr(9) $+ + 0 0 0 $3 $+ $chr(9) $+ + 0 0 0 %away $+ $chr(9) $+ + 0 0 0 %mode $+ $chr(9) $+ + 0 0 0 %ircop
}

;---DIALOG STUFF---

dialog channel {
  title "Channel Central"
  size -1 -1 441 476
  option pixels
  tab "Topic/Modes", 2, 4 73 432 370
  box "Set Channel Modes", 10, 13 305 415 124, tab 2
  box "Edit Topic", 7, 13 96 415 207, tab 2
  edit "", 8, 23 113 395 65, tab 2 multi vsbar limit 500
  button "", 9, 23 184 395 75, tab 2
  check "No External Messages", 17, 75 400 140 20, tab 2
  check "Only Ops set Topic", 16, 75 376 115 20, tab 2
  check "Key:", 14, 75 351 47 20, tab 2
  edit "", 15, 122 348 100 23, tab 2
  check "Limit to", 11, 75 325 56 20, tab 2
  edit "", 12, 132 323 55 23, tab 2
  text "users", 13, 192 327 29 16, tab 2
  check "Secret Channel", 20, 252 400 109 20, tab 2
  check "Private Channel", 21, 252 376 109 20, tab 2
  check "Moderated Channel", 18, 252 351 121 20, tab 2
  check "Invite Only", 19, 252 325 109 20, tab 2
  text "Characters Used...", 22, 24 264 113 16, tab 2
  text "", 23, 24 282 392 10, tab 2
  text "0/0", 24, 293 264 123 16, tab 2 right
  button "Apply", 38, 283 448 75 22, disable tab 2
  tab "Bans", 3
  box "Ban List", 25, 13 96 415 333, tab 3
  list 29, 23 112 395 306, tab 3 size extsel
  tab "Invites", 4
  box "Invite List", 26, 13 96 415 333, tab 4
  list 31, 23 112 395 306, tab 4 size extsel
  tab "Excepts", 5
  box "Excepts List", 27, 13 96 415 333, tab 5
  list 32, 23 112 395 306, tab 5 size extsel
  tab "Statistics", 1
  box "Users", 28, 13 96 415 212, tab 1
  box "Clones", 34, 13 312 415 117, tab 1
  list 35, 23 112 394 184, tab 1 size extsel
  list 37, 23 328 395 90, tab 1 size extsel
  button "OK", 6, 362 448 75 22, ok
  icon 30, -2 0 444 64, $scriptdir $+ libraries\icons\ccheader.png, noborder
}

on *:dialog:channel:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX $dname 9 window > $dlg
  window -ph @topicpreview
  did -a $dname 9 grab $window(@topicpreview).hwnd @topicpreview
  mdx SetControlMDX $dname 23 Progressbar > $ctl
  mdx SetControlMDX $dname 29 listview rowselect sortascending showsel alignleft report > $views
  did -i $dname 29 1 headerdims 150:1 95:2 120:3
  did -i $dname 29 1 headertext 0 Mask $+ $chr(9) $+ 0 Set by $+ $chr(9) $+ 0 Date/Time
  mdx SetControlMDX $dname 31 listview rowselect sortascending showsel alignleft report > $views
  did -i $dname 31 1 headerdims 150:1 95:2 120:3
  did -i $dname 31 1 headertext 0 Mask $+ $chr(9) $+ 0 Set by $+ $chr(9) $+ 0 Date/Time
  mdx SetControlMDX $dname 32 listview rowselect sortascending showsel alignleft report > $views
  did -i $dname 32 1 headerdims 150:1 95:2 120:3
  did -i $dname 32 1 headertext 0 Mask $+ $chr(9) $+ 0 Set by $+ $chr(9) $+ 0 Date/Time
  mdx SetControlMDX $dname 35 listview rowselect sortascending showsel alignleft report > $views
  did -i $dname 35 1 headerdims 80:1 155:2 40:3 55:4 42:5
  did -i $dname 35 1 headertext 0 Nick $+ $chr(9) $+ 0 Host $+ $chr(9) $+ 0 Away $+ $chr(9) $+ 0 Mode $+ $chr(9) $+ 0 IRCop
  mdx SetControlMDX $dname 37 listview rowselect sortascending showsel alignleft report > $views
  did -i $dname 37 1 headerdims 220:1 150:2
  did -i $dname 37 1 headertext 0 Host $+ $chr(9) $+ 0 Clones
  did -a $dname 8 $chan($hget(channel,chan)).topic
  previewtopic $hget(channel,chan)
  dialog -t $dname Channel Central - $hget(channel,chan)
  tokenize 32 $chan($hget(channel,chan)).mode
  if (n isincs $1) {
    did -c $dname 17
  }
  if (t isincs $1) {
    did -c $dname 16
  }
  if (l isincs $1) {
    did -c $dname 11
    did -ar $dname 12 $2
  }
  if (k isincs $1) {
    did -c $dname 14
    did -ar $dname 15 $2
  }
  if (i isincs $1) {
    did -c $dname 19
  }
  if (m isincs $1) {
    did -c $dname 18
  }
  if (p isincs $1) {
    did -c $dname 21
  }
  if (s isincs $1) {
    did -c $dname 20
  }
  set -u5 %silent $true
  .who $hget(channel,chan)
  .timer 1 1 compilelists
}

alias compilelists {
  listbans
  listinvites
  listexcepts
  clonescan $hget(channel,chan)
}

on *:dialog:channel:sclick:6: {
  var %chan = $hget(channel,chan)
  if ($me isop %chan) {
    tokenize 32 $chan(%chan).mode
    if ($did($dname,19).state) {
      if (i !isincs $1) {
        mode %chan +i
      }
    }
    else {
      if (i isincs $1) {
        mode %chan -i
      }
    }
    if ($did($dname,18).state) {
      if (m !isincs $1) {
        mode %chan +m
      }
    }
    else {
      if (m isincs $1) {
        mode %chan -m
      }
    }
    if ($did($dname,21).state) {
      if (p !isincs $1) {
        mode %chan +p
      }
    }
    else {
      if (p isincs $1) {
        mode %chan -p
      }
    }
    if ($did($dname,20).state) {
      if (s !isincs $1) {
        mode %chan +s
      }
    }
    else {
      if (s isincs $1) {
        mode %chan -s
      }
    }
    if ($did($dname,11).state) {
      if (l !isincs $1) {
        mode %chan +l $did($dname,12)
      }
    }
    else {
      if (l isincs $1) {
        mode %chan -l
      }
    }
    if ($did($dname,14).state) {
      if (k !isincs $1) {
        mode %chan +k $did($dname,15)
      }
    }
    else {
      if (k isincs $1) {
        mode %chan -k $did($dname,15)
      }
    }
    if ($did($dname,16).state) {
      if (t !isincs $1) {
        mode %chan +t
      }
    }
    else {
      if (t isincs $1) {
        mode %chan -t
      }
    }
    if ($did($dname,17).state) {
      if (n !isincs $1) {
        mode %chan +n
      }
    }
    else {
      if (n isincs $1) {
        mode %chan -n
      }
    }
  }
}

on *:dialog:channel:edit:8: {
  previewtopic $hget(channel,chan)
  did -e $dname 38
}

on *:dialog:channel:sclick:29: {
  if ($gettok($did($dname,29,1),1,32) == rclick) {
    chanbanlistpop $did(29).sel $gettok($gettok($did(29).seltext,6,32),1,9)
  }
}

alias chanbanlistpop {
  popups New chanbanspop 16 16
  popups SetMetrics chanbanspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem chanbanspop end + Add Ban $cr addchanban
  if ($1) {
    popups AddItem chanbanspop end + Edit Ban $cr editchanban $1 $2-
  }
  popups AddItem chanbanspop end + 
  if ($1) {
    popups AddItem chanbanspop end + Remove Ban(s) $cr removechanban $1 $2-
  }
  popups AddItem chanbanspop end + Clear Bans $cr clearchanbans
  popup chanbanspop $mouse.dx $mouse.dy
}

alias addchanban {
  var %ban = $input(Please enter new Ban.,equ,Query...,$null)
  if (%ban) {
    mode $hget(channel,chan) +b %ban
    .timer -m 1 500 listbans
  }
}

alias editchanban {
  var %ban = $input(Please edit Ban.,equ,Query...,$2)
  if (%ban) {
    mode $hget(channel,chan) -b+b $2 %ban
    .timer -m 1 500 listbans
  }
}

alias removechanban {
  if ($did(channel,29).sel = 1) {
    mode $hget(channel,chan) -b $2-
    .timer -m 1 500 listbans
    return
  }
  else {
    var %s = 1, %n = 0, %bans = $null
    while (%s <= $did(channel,29,0).sel) {
      var %ban = $gettok($gettok($did(channel,29,$did(channel,29,%s).sel).text,6,32),1,9)
      inc %n
      var %bans = %bans %ban
      inc %s
    }
  }
  mode $hget(channel,chan) - $+ $str(b,%n) %bans
  .timer -m 1 500 listbans
}

alias clearchanbans {
  var %b = 1, %n = 0, %bans = $null
  while (%b <= $modespl) {
    var %ban = $gettok($gettok($did(channel,29,%b).text,6,32),1,9)
    inc %n
    var %bans = %bans %ban
    inc %b
  }
  mode $hget(channel,chan) - $+ $str(b,%n) %bans
  .timer -m 1 500 listbans
  if ($did(channel,29).lines > 0) {
    .timer 1 0 clearchanbans
  }
}

on *:dialog:channel:sclick:31: {
  if ($gettok($did($dname,31,1),1,32) == rclick) {
    chaninvitelistpop $did(31).sel $gettok($gettok($did(31).seltext,6,32),1,9)
  }
}

alias chaninvitelistpop {
  popups New chaninvitespop 16 16
  popups SetMetrics chaninvitespop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem chaninvitespop end + Add Invite $cr addchaninvite
  if ($1) {
    popups AddItem chaninvitespop end + Edit Invite $cr editchaninvite $1 $2-
  }
  popups AddItem chaninvitespop end + 
  if ($1) {
    popups AddItem chaninvitespop end + Remove Invite(s) $cr removechaninvite $1 $2-
  }
  popups AddItem chaninvitespop end + Clear Invites $cr clearchaninvites
  popup chaninvitespop $mouse.dx $mouse.dy
}

alias addchaninvite {
  var %inv = $input(Please enter new Invite.,equ,Query...,$null)
  if (%inv) {
    mode $hget(channel,chan) +I %inv
    .timer -m 1 500 listinvites
  }
}

alias editchaninvite {
  var %inv = $input(Please edit Invite.,equ,Query...,$2)
  if (%inv) {
    mode $hget(channel,chan) -I+I $2 %inv
    .timer -m 1 500 listinvites
  }
}

alias removechaninvite {
  if ($did(channel,31).sel = 1) {
    mode $hget(channel,chan) -I $2-
    .timer -m 1 500 listinvites
    return
  }
  else {
    var %s = 1, %n = 0, %invs = $null
    while (%s <= $did(channel,31,0).sel) {
      var %inv = $gettok($gettok($did(channel,31,$did(channel,31,%s).sel).text,6,32),1,9)
      inc %n
      var %invs = %invs %inv
      inc %s
    }
  }
  mode $hget(channel,chan) - $+ $str(I,%n) %invs
  .timer -m 1 500 listinvites
}

alias clearchaninvites {
  var %b = 1, %n = 0, %invs = $null
  while (%b <= $modespl) {
    var %inv = $gettok($gettok($did(channel,31,%b).text,6,32),1,9)
    inc %n
    var %invs = %invs %inv
    inc %b
  }
  mode $hget(channel,chan) - $+ $str(I,%n) %invs
  .timer -m 1 500 listinvites
  if ($did(channel,31).lines > 0) {
    .timer 1 0 clearchaninvites
  }
}

on *:dialog:channel:sclick:32: {
  if ($gettok($did($dname,32,1),1,32) == rclick) {
    chanexceptlistpop $did(32).sel $gettok($gettok($did(32).seltext,6,32),1,9)
  }
}

alias chanexceptlistpop {
  popups New chanexceptspop 16 16
  popups SetMetrics chanexceptspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem chanexceptspop end + Add Except $cr addchanexcept
  if ($1) {
    popups AddItem chanexceptspop end + Edit Except $cr editchanexcept $1 $2-
  }
  popups AddItem chanexceptspop end + 
  if ($1) {
    popups AddItem chanexceptspop end + Remove Except(s) $cr removechanexcept $1 $2-
  }
  popups AddItem chanexceptspop end + Clear Excepts $cr clearchanexcept
  popup chanexceptspop $mouse.dx $mouse.dy
}

alias addchanexcept {
  var %ext = $input(Please enter new Except.,equ,Query...,$null)
  if (%ext) {
    mode $hget(channel,chan) +e %ext
    .timer -m 1 500 listexcepts
  }
}

alias editchanexcept {
  var %ext = $input(Please edit Except.,equ,Query...,$2)
  if (%ext) {
    mode $hget(channel,chan) -e+e $2 %ext
    .timer -m 1 500 listexcepts
  }
}

alias removechanexcept {
  if ($did(channel,32).sel = 1) {
    mode $hget(channel,chan) -e $2-
    .timer -m 1 500 listexcepts
    return
  }
  else {
    var %s = 1, %n = 0, %exts = $null
    while (%s <= $did(channel,32,0).sel) {
      var %ext = $gettok($gettok($did(channel,32,$did(channel,32,%s).sel).text,6,32),1,9)
      inc %n
      var %exts = %exts %ext
      inc %s
    }
  }
  mode $hget(channel,chan) - $+ $str(e,%n) %exts
  .timer -m 1 500 listexcepts
}

alias clearchanexcept {
  var %b = 1, %n = 0, %exts = $null
  while (%b <= $modespl) {
    var %ext = $gettok($gettok($did(channel,32,%b).text,6,32),1,9)
    inc %n
    var %exts = %exts %ext
    inc %b
  }
  mode $hget(channel,chan) - $+ $str(e,%n) %exts
  .timer -m 1 500 listexcepts
  if ($did(channel,32).lines > 0) {
    .timer 1 0 clearchanexcepts
  }
}

alias gettopic {
  var %l = 1
  while (%l <= $did(channel,8).lines) {
    var %t = %t $did(channel,8,%l).text
    inc %l
  }
  return %t
}

alias previewtopic {
  var %i = 0, %win = @topicpreview, %t = $gettopic, %y = 1
  drawrect -nf %win $color(back) 1 0 0 $window(%win).w $window(%win).h
  if (%t) {
    while (%y < $window(%win).h) {
      drawtext -npb %win $color(topic) $color(back) Tahoma 11 $calc(2 - (%i * ($window(%win).w))) %y %t
      inc %y 14
      inc %i
    }
  }
  drawcopy %win 0 0 485 30 %win 0 0
  did -ar channel 24 $len(%t) $+ / $+ $hget(channel,topiclen. $+ $cid)
  did -a channel 23 $len(%t) 0 $hget(channel,topiclen. $+ $cid)
}

on *:dialog:channel:sclick:38: {
  if ($me isop $hget(channel,chan)) {
    topic $hget(channel,chan) $gettopic
  }
}

on *:dialog:channel:sclick:37: {
  if ($gettok($did($dname,37,1),1,32) == rclick) {
    clonespopup $did(37).sel $gettok($gettok($did(37).seltext,6,32),1,9)
  }
}

alias clonespopup {
  popups New clonespop 16 16
  popups SetMetrics clonespop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem clonespop end + Scan for Clones... $cr clonescan $hget(channel,chan)
  popup clonespop $mouse.dx $mouse.dy
}

;---CLONESCAN---

alias clonescan {
  did -r channel 37
  var %i = 1 , %w, %tmp, %c = 0
  hmake clones 100
  %tmp = $ialchan(*,$1,0)
  while (%i <= %tmp) {
    %w = $address($nick($1,%i),2)
    hadd clones %w $addtok($hget(clones,%w),$nick($1,%i),44)
    inc %i
  }
  %i = 1
  while (%i <= %tmp) {
    var %k = 1,
    %w = $null
    if ($numtok($hget(clones,%i).data,44) > 1) {
      %k = $ifmatch
      %w = $hget(clones,%i).data
      did -a channel 37 + 0 0 0 $hget(clones,%i).item $+ $chr(9) $+ + 0 0 0 ( $+ %k $+ ) %w
      inc %c
    }
    inc %i
  }
  if (%c == 0) {
    did -a channel 37 + 0 0 0 No Clones in $1
  }    
  hfree clones
}

;--RAW EVENTS---

raw 005:*:{
  if ($gettok($wildtok($1-,topiclen=?*,1,32),2,61)) {
    hadd channel topiclen. $+ $cid $ifmatch
  }
}

raw 352:*:{
  if ($dialog(channel)) { listusers $2- }
}
