;---DCC Extras by mr.man (c) 2005 (Part of NeXtGenIRC)---

;---DIALOGS STUFF---

alias dccextras {
  dialog -m dcctoftp dcctoftp
}

dialog dcctoftp {
  title "DCC Extras"
  size -1 -1 420 325
  option pixels
  tab "DCC to FTP Accounts", 1, 4 74 410 217
  box "Accounts", 4, 13 98 391 179, tab 1
  list 5, 24 116 369 148, tab 1 size
  button "OK", 2, 340 296 75 22, ok
  check "DCC Extras Active", 3, 8 297 129 20
  icon 6, -2 0 423 64, $scriptdir $+ libraries\icons\dccxheader.png, noborder
}

on *:dialog:dcctoftp:init:0: {
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 5 listview single rowselect showsel alignleft report > $views
  did -i $dname 5 1 headerdims 75:1 270:2
  did -i $dname 5 1 headertext 0 Account $+ $chr(9) $+ 0 URL
  if ($hget(ftps,Active) == 1) {
    did -c $dname 3
  }
  else {
    did -u $dname 3
  }
  filldccaxx
}

on *:dialog:dcctoftp:sclick:3:{
  hadd ftps Active $did($dname,3).state
}

on *:dialog:dcctoftp:sclick:5:{
  if ($gettok($did($dname,5,1),1,32) == rclick) {
    ftpspop $did(5).sel $gettok($gettok($did(5).seltext,6,32),1,9)
  }
}

alias d2fnewacc {
  dialog -m dcc2ftpnewacc dcc2ftpnewacc
}

dialog dcc2ftpnewacc {
  title "DCCtoFTP Account Setup"
  size -1 -1 269 320
  option pixels
  tab "New Account", 1, 5 73 257 213
  box "Details", 4, 14 98 238 174, tab 1
  text "Account:", 3, 29 127 50 16, tab 1 right
  text "Username:", 5, 24 153 55 16, tab 1 right
  text "Password:", 6, 29 180 50 16, tab 1 right
  text "Address:", 7, 29 205 50 16, tab 1 right
  text "Port:", 8, 29 231 50 16, tab 1 right
  edit "", 9, 81 122 153 23, tab 1 autohs
  edit "", 10, 81 148 153 23, tab 1 autohs
  edit "", 11, 81 173 153 23, tab 1 autohs
  edit "", 12, 81 200 153 23, tab 1 autohs
  edit "", 13, 81 226 153 23, tab 1 autohs
  button "OK", 2, 196 292 67 22, ok
  button "Cancel", 14, 126 292 67 22, cancel
  icon 15, -2 0 272 64, $scriptdir $+ libraries\icons\dccxnewaccheader.png, noborder
}

on *:dialog:dcc2ftpnewacc:init:0: {
  did -f $dname 9
  did -b $dname 2
}

on *:dialog:dcc2ftpnewacc:edit:9:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11) && $did($dname,12) && $did($dname,13)) {
    did -e $dname 2
  }
  else {
    did -b $dname 2
  }
}

on *:dialog:dcc2ftpnewacc:edit:10:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11) && $did($dname,12) && $did($dname,13)) {
    did -e $dname 2
  }
  else {
    did -b $dname 2
  }
}

on *:dialog:dcc2ftpnewacc:edit:11:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11) && $did($dname,12) && $did($dname,13)) {
    did -e $dname 2
  }
  else {
    did -b $dname 2
  }
}

on *:dialog:dcc2ftpnewacc:edit:12:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11) && $did($dname,12) && $did($dname,13)) {
    did -e $dname 2
  }
  else {
    did -b $dname 2
  }
}

on *:dialog:dcc2ftpnewacc:edit:13:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11) && $did($dname,12) && $did($dname,13)) {
    did -e $dname 2
  }
  else {
    did -b $dname 2
  }
}

on *:dialog:dcc2ftpnewacc:sclick:2:{
  var %entry = $did($dname,10) $+ : $+ $did($dname,11) $+ @ $+ $did($dname,12) $+ : $+ $did($dname,13), %acc = $replace($did($dname,9),$chr(32),_)
  if (%entry && %acc) {
    hadd ftps %acc %entry
    hadd ftps Sites $addtok($hget(ftps,Sites),%acc,44)
    did -r dcctoftp 5
    filldccaxx
  }
}

alias d2feditacc {
  dialog -m dcc2ftpeditacc dcc2ftpeditacc
  did -ar dcc2ftpeditacc 9 $2
  var %line = $hget(ftps,$2)
  did -ar dcc2ftpeditacc 12 $gettok($gettok($gettok(%line,1,47),2,64),1,58)
  did -ar dcc2ftpeditacc 13 $gettok($gettok($gettok(%line,1,47),2,64),2,58)
  did -ar dcc2ftpeditacc 10 $gettok($gettok(%line,1,64),1,58)
  did -ar dcc2ftpeditacc 11 $gettok($gettok(%line,1,64),2,58)
}

dialog dcc2ftpeditacc {
  title "DCCtoFTP Edit Account"
  size -1 -1 269 319
  option pixels
  tab "New Account", 1, 5 73 257 213
  box "Details", 4, 14 98 238 174, tab 1
  text "Account:", 3, 29 127 50 16, tab 1 right
  text "Username:", 5, 24 153 55 16, tab 1 right
  text "Password:", 6, 29 180 50 16, tab 1 right
  text "Address:", 7, 29 205 50 16, tab 1 right
  text "Port:", 8, 29 231 50 16, tab 1 right
  edit "", 9, 81 122 153 23, tab 1 read autohs
  edit "", 10, 81 148 153 23, tab 1 autohs
  edit "", 11, 81 173 153 23, tab 1 autohs
  edit "", 12, 81 200 153 23, tab 1 autohs
  edit "", 13, 81 226 153 23, tab 1 autohs
  button "OK", 2, 196 291 67 22, ok
  button "Cancel", 14, 126 291 67 22, cancel
  icon 15, -2 0 272 64, $scriptdir $+ libraries\icons\dccxeditaccheader.png, noborder
}

on *:dialog:dcc2ftpeditacc:init:0: {
  did -f $dname 10
}

on *:dialog:dcc2ftpeditacc:edit:9:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11) && $did($dname,12) && $did($dname,13)) {
    did -e $dname 2
  }
  else {
    did -b $dname 2
  }
}

on *:dialog:dcc2ftpeditacc:edit:10:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11) && $did($dname,12) && $did($dname,13)) {
    did -e $dname 2
  }
  else {
    did -b $dname 2
  }
}

on *:dialog:dcc2ftpeditacc:edit:11:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11) && $did($dname,12) && $did($dname,13)) {
    did -e $dname 2
  }
  else {
    did -b $dname 2
  }
}

on *:dialog:dcc2ftpeditacc:edit:12:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11) && $did($dname,12) && $did($dname,13)) {
    did -e $dname 2
  }
  else {
    did -b $dname 2
  }
}

on *:dialog:dcc2ftpeditacc:edit:13:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11) && $did($dname,12) && $did($dname,13)) {
    did -e $dname 2
  }
  else {
    did -b $dname 2
  }
}

on *:dialog:dcc2ftpeditacc:sclick:2:{
  var %entry = $did($dname,10) $+ : $+ $did($dname,11) $+ @ $+ $did($dname,12) $+ : $+ $did($dname,13), %acc = $did($dname,9)
  if (%entry && %acc) {
    hadd ftps %acc %entry
    hadd ftps Sites $addtok($hget(ftps,Sites),%acc,44)
    did -r dcctoftp 5
    filldccaxx
  }
}

alias d2fdelacc {
  did -d dcctoftp 5 $1
  hadd ftps Sites $remtok($hget(ftps,Sites),$2,44)
  hdel ftps $2
}

;---ALIASES---

alias ftpspop {
  popups New ftps 16 16
  popups SetMetrics ftps iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem ftps end + Add $cr d2fnewacc
  popups AddItem ftps end + Delete $cr d2fdelacc $1 $2
  popups AddItem ftps end
  popups AddItem ftps end + Edit $cr d2feditacc $1 $2
  popup ftps $mouse.dx $mouse.dy
}

alias filldccaxx {
  var %l = 1, %sites = $sorttok($hget(ftps,Sites),44)
  while (%l <= $numtok(%sites,44)) {
    var %acc = $gettok(%sites,%l,44), %url = $hget(ftps,%acc) 
    did -a dcctoftp 5 + 0 0 0 %acc $+ $chr(9) $+ + 0 0 0 %url
    inc %l
  }
}

alias -l inifile {
  return $+(",$scriptdir,settings\dccx.ini,")
}

alias -l loadsettings {
  hmake ftps 10
  hload -i ftps $inifile Settings
}

alias -l savesettings {
  if (!%restart) {
    hsave -oi ftps $inifile Settings
  }
}

alias dccfxp {
  if (!$1) { dialog -m dccfxp dccfxp }
  else { .privmsg $1 $chr(1) $+ DCC SEND $hget(ftps,inc.info) $+ $chr(1) }
}

alias dcc2ftp {
  hadd ftps dcc2ftp_filename $nopath($gettok($remove($1-,$chr(34)),1- $calc($numtok($1-,32) - 3),32)))
  hadd ftps dcc2ftp_port $gettok($1-,$calc($numtok($1-,32) - 1),32)
  hadd ftps dcc2ftp_ip $longip($gettok($1-,$calc($numtok($1-,32) - 2),32))
  hadd ftps dcc2ftp_size $gettok($1-,$numtok($1-,32),32)
  hadd ftps dcc2ftp_mark $gettok($1-,$numtok($1-,32),32)
  hadd ftps dcc2ftp_in_ip $replace($hget(ftps,in.ip) $+ . $+ $gettok($longip($hget(ftps,in.port)),3-,46),$chr(46),$chr(44))
  dialog -m dcc2ftp dcc2ftp
}

dialog dcc2ftp {
  title "DCCtoFTP Transfer"
  size -1 -1 381 343
  option pixels
  tab "Transfer Details", 1, 5 73 369 234
  box "Details", 2, 13 98 353 197, tab 1
  text "Address:", 6, 40 155 50 16, tab 1 right
  text "Port:", 7, 39 180 50 16, tab 1 right
  text "Username:", 8, 27 209 61 16, tab 1 right
  text "Password:", 9, 33 236 55 16, tab 1 right
  combo 14, 100 116 245 102, tab 1 size drop
  text "Send To:", 15, 40 120 50 16, tab 1 right
  edit "", 10, 101 152 245 23, tab 1
  edit "", 11, 101 178 245 23, tab 1
  edit "", 12, 101 206 245 23, tab 1
  edit "", 13, 101 234 245 23, tab 1
  text "Directory:", 16, 34 265 55 16, tab 1 right
  edit "", 17, 101 261 245 23, tab 1
  button "OK", 3, 300 313 75 22, ok
  button "Cancel", 4, 222 313 75 22, cancel
  icon 5, -2 0 384 64, $scriptdir $+ libraries\icons\dccxxferheader.png, noborder
}

on *:dialog:dcc2ftp:init:0: {
  did -a $dname 14 New Site
  didtok $dname 14 44 $hget(ftps,Sites)
  did -c $dname 14 1
  display_site
}

on *:dialog:dcc2ftp:sclick:3: {
  hadd ftps dcc2ftp_dest_addr $did($dname,10).text
  hadd ftps dcc2ftp_dest_port $did($dname,11).text
  hadd ftps dcc2ftp_dest_username $did($dname,12).text
  hadd ftps dcc2ftp_dest_password $did($dname,13).text
  hadd ftps dcc2ftp_dest_dir $did($dname,17).text
  dialog -x dcc2ftp
  do_dcc2ftp
}

on *:dialog:dcc2ftp:sclick:14: {
  display_site
}

alias display_site {
  var %ftp = $did(dcc2ftp,14).seltext
  var %line = $hget(ftps,%ftp)
  did -ra dcc2ftp 10 $gettok($gettok($gettok(%line,1,47),2,64),1,58)
  did -ra dcc2ftp 11 $gettok($gettok($gettok(%line,1,47),2,64),2,58)
  did -ra dcc2ftp 12 $gettok($gettok(%line,1,64),1,58)
  did -ra dcc2ftp 13 $gettok($gettok(%line,1,64),2,58)
  did -ra dcc2ftp 17 $gettok(%line,2-,47)
}

;---DISPLAY DIALOG---

alias dcc2ftp_display {
  dialog -m dcc2ftp_display dcc2ftp_display 
}

dialog dcc2ftp_display {
  title "DCCtoFTP Transfer"
  size -1 -1 409 412
  option pixels
  tab "DCCtoFTP", 1, 5 74 398 305
  box "Messages", 3, 12 101 384 265, tab 1
  button "", 5, 23 119 363 236, tab 1
  button "OK", 4, 329 384 75 22, ok
  icon 2, -2 0 412 64, $scriptdir $+ libraries\icons\dcctoftpheader.png, noborder
}

on *:dialog:dcc2ftp_display:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX $dname 5 window > $dlg
  if (!$window(@dcc2ftp)) { 
    .window -ah @dcc2ftp
  }
  did -a $dname 5 grab $window(@dcc2ftp).hwnd @dcc2ftp
  if ($exists($+(",$scriptdir,settings\ftp.log,"))) {
    loadbuf -pi5 @dcc2ftp $+(",$scriptdir,settings\ftp.log,")
  }
}

on *:dialog:dcc2ftp_display:sclick:4:{
  savebuf @dcc2ftp $+(",$scriptdir,settings\ftp.log,")
}

menu @dcc2ftp {
  Clear:clear | write -c $+(",$scriptdir,settings\ftp.log,")
}

;---ACTUAL WORK DONE HERE---

alias do_dcc2ftp {
  theme.text $s.head(Connecting to Address) $s.encleft $+ $s.value($hget(ftps,dcc2ftp_dest_addr)) $+ $s.encright $s.head(on Port) $s.encleft $+ $s.value($hget(ftps,dcc2ftp_dest_port)) $+ $s.encright $s.head(with Username) $s.encleft $+ $s.value($hget(ftps,dcc2ftp_dest_username)) $+ $s.encright $s.head(and Password) $s.encleft $+ $s.value($hget(ftps,dcc2ftp_dest_password)) $+ $s.encright
  var %sockname = dcc2ftp/ $+ $hget(ftps,dcc2ftp_dest_addr) $+ $rand(0,9999999)
  sockopen %sockname $hget(ftps,dcc2ftp_dest_addr) $hget(ftps,dcc2ftp_dest_port)
  sockmark %sockname $hget(ftps,dcc2ftp_mark)
}

alias ftp_sockread {
  var %sock_num = $calc($sock(dcc2ftp/*,0) + 1), %x = 1
  while (%x < %sock_num) {
    if ($sock(dcc2ftp/*,%x) == $sockname) { var %socket = %x | break }
    inc %x
  }
  if (!$window(@dcc2ftp)) { 
    .window -ah @dcc2ftp
    aline -p 04 @dcc2ftp ( $+ %socket $+ ) $2-
  }
  else { aline -p 04 @dcc2ftp ( $+ %socket $+ ) $2- }
  if (!$dialog(dcc2ftp_display)) {
    dialog -m dcc2ftp_display dcc2ftp_display
  }
  if ($2 == 200) {
    if (($3-5 == type set to) && ((image !isin $6) && (binary !isin $6) && ($remove($6,.) != i))) || (($3-4 == type is) && ((image !isin $5-) && (binary !isin $5-))) {
      sockwrite -n $sockname TYPE I
    }
    if ($3- == Port command successful.) || ($3- == Port command ok.) {
      hinc ftps dcc2ftp_num
    }
    if (($3-5 == type set to) && ((image isin $6) || (binary isin $6) || ($remove($6,.) == i))) || (($3-4 == type is) && ((image isin $6) || (binary isin $6))) {
      var %f = $hget(ftps,dcc2ftp_filename)
      sockwrite -n $1 STOR %f
      aline -p 15 @dcc2ftp ( $+ %socket $+ ) STOR %f
    }
  }
  if (($2 == 213) && ($3 > 0)) {
    sockwrite -n $1 REST $3
    aline -p 15 @dcc2ftp ( $+ %socket $+ ) REST $3
    .privmsg $hget(ftps,dcc.nick) $chr(1) $+ DCC RESUME $hget(ftps,dcc2ftp_dest_filename) $hget(ftps,dcc2ftp_dest_port) $3 $+ $chr(1)
    hadd ftps dcc.type DCC2FTP+RESUME
    sockwrite -n $1 TYPE I
    sockwrite -n $1 PORT $hget(ftps,dcc2ftp_in_ip)
    aline -p 15 @dcc2ftp ( $+ %socket $+ ) PORT $hget(ftps,dcc2ftp_in_ip)
    sockwrite -n $1 APPE $hget(ftps,dcc2ftp_filename)
    aline -p 15 @dcc2ftp ( $+ %socket $+ ) APPE $hget(ftps,dcc2ftp_filename)
  }
  if (($2 == 213) && ($3 == 0)) {
    sockwrite -n $1 TYPE I
    sockwrite -n $1 PORT $hget(ftps,dcc2ftp_in_ip)
    aline -p 15 @dcc2ftp ( $+ %socket $+ ) PORT $hget(ftps,dcc2ftp_in_ip)
  }
  if ($2 == 220) {
    sockwrite -n $1 USER $hget(ftps,dcc2ftp_dest_username)
    aline -p 15 @dcc2ftp ( $+ %socket $+ ) USER $hget(ftps,dcc2ftp_dest_username)
  }
  if ($2 == 221) {
    hdec ftps dcc2ftp_num
  }
  if ($2 == 230) {
    var %dir = $hget(ftps,dcc2ftp_dest_dir)
    if (!%dir) {
      %dir = /
    }
    sockwrite -n $1 CWD %dir
    aline -p 15 @dcc2ftp ( $+ %socket $+ ) CWD %dir
  }
  if ($2 == 226) {
    var %complete = $sock($sockname).to
    theme.text $s.head(DCC2FTP Transferred) $s.encleft $+ $s.value($bytes($sock($sockname).mark,3).suf) $+ $s.encright $s.head(in) $s.encleft $+ $s.value($duration(%complete)) $+ $s.encright $s.head(Transfers Remaining) $s.encleft $+ $s.value($calc($sock(dcc2ftp/*,0) - 1)) $+ $s.encright
    aline -p 15 @dcc2ftp ( $+ %socket $+ ) Transfer Complete!
    sockwrite -n $1 QUIT
  }
  if ($2 == 250) {
    aline -p 15 @dcc2ftp ( $+ %socket $+ ) CWD Command Sucessful
    aline -p 15 @dcc2ftp ( $+ %socket $+ ) SIZE $hget(ftps,dcc2ftp_filename)
    sockwrite -n $1 SIZE $hget(ftps,dcc2ftp_filename)
  }
  if ($2 == 331) {
    sockwrite -n $1 PASS $hget(ftps,dcc2ftp_dest_password)
    aline -p 15 @dcc2ftp ( $+ %socket $+ ) PASS $hget(ftps,dcc2ftp_dest_password)
  }
  if ($2 == 425) {
    sockwrite -n $1 QUIT
  }
  if ($2 == 421) {
    sockclose $1
  }
  if ($2 == 426) { 
    if (*Too many users* iswm $3-) {
      dialog -m dcc2ftp dcc2ftp
    }
    else {
      var %complete = $sock($sockname).to
      sockwrite -n $1 QUIT
      theme.text $s.head(DCC2FTP Transferred) $s.encleft $+ $s.value($bytes($sock($sockname).mark),3).suf) $+ $s.encright $s.head(in) $s.encleft $+ $s.value($duration(%complete)) $+ $s.encright 
    }
  }  
  if ($2 == 550) { 
    if (*not a plain file* iswm $3-) {
      sockwrite -n $1 TYPE I
      sockwrite -n $1 PORT $hget(ftps,dcc2ftp_in_ip)
      aline -p 15 @dcc2ftp ( $+ %socket $+ ) PORT  $hget(ftps,dcc2ftp_in_ip)
    }
    if (*Cannot STOR* iswm $3-) {
      aline 04 @dcc2ftp ( $+ %socket $+ ) SIZE $hget(ftps,dcc2ftp_filename)
      sockwrite -n $1 SIZE $hget(ftps,dcc2ftp_filename)
    }
    if (*no such file* iswm $3-) {
      sockwrite -n $1 TYPE I
      sockwrite -n $1 PORT $hget(ftps,dcc2ftp_in_ip)
      aline -p 15 @dcc2ftp ( $+ %socket $+ ) PORT $hget(ftps,dcc2ftp_in_ip)
    }
    if (*no such directory* iswm $3-) {
      aline 04 @dcc2ftp ( $+ %socket $+ ) MKDIR $mnick
      sockwrite -n $1 MKDIR $mnick
      sockwrite -n $1 CWD / $+ $mnick
    }
    if (*permission denied* iswm $3-) {
      aline 04 @dcc2ftp ( $+ %socket $+ ) -- Permission Denied --
      sockwrite -n $1 QUIT
    }
    if (*Access denied* iswm $3-) {
      aline 04 @dcc2ftp ( $+ %socket $+ ) -- Permission Denied --
      sockwrite -n $1 QUIT
    }
  }
}

on *:sockread:dcc2ftp/*: {
  var %dcc2ftp_sockread
  if ($sockerr) { error $sockerr }
  :loop
  sockread %dcc2ftp_sockread
  if ($sockbr) {
    if (%dcc2ftp_sockread != $null) { ftp_sockread $sockname %dcc2ftp_sockread }
    goto loop
  }
}

;---CTCP EVENT---

ctcp ^*:*:*: {
  if ($hget(ftps,Active) == 1) {
    if ($1 == DCC) && ($2 == SEND) {
      if ($nick != $me) {
        hadd ftps dcc.nick $nick
        hadd ftps inc.info $3-
        hadd ftps dcc.info $3-
        hadd ftps dcc.port $5
      }
      if ($hget(ftps,dcc) != Normal) {
        dialog -m dcc_options dcc_options 
        halt
      } 
      hdel ftps dcc 
    }
    if ($1 == DCC) && ($2 == RESUME) {
      if ($hget(ftps,dcc.type) == DCCFXP) || ($hget(ftps,dcc) == Normal) {
        hadd ftps dcc.accept $nick
        scon -at1 .privmsg $hget(ftps,dcc.nick) $+($chr(1),$1-,$chr(1))
      }
    }
    if ($1 == DCC) && ($2 == ACCEPT) { 
      if ($hget(ftps,dcc.type) == DCCFXP) || ($hget(ftps,dcc) == Normal) {
        scon -at1 .privmsg $hget(ftps,dcc.accept) $+($chr(1),$1-,$chr(1))
      } 
      if ($hget(ftps,dcc.type) == DCC2FTP+RESUME) {
        echo -a FTP RESUME
      }
    }
  }
}

;---DIALOGS---

dialog dcc_options {
  title "DCCX Options"
  size -1 -1 375 264
  option pixels
  button "Receive", 1, 4 234 87 22
  button "DCC FXP", 2, 96 234 88 22
  button "DCC FTP", 3, 188 234 88 22
  button "Cancel", 4, 280 234 88 22, ok
  tab "DCC Options", 14, 4 72 363 155
  box "Information", 11, 14 98 343 114, tab 14
  text "Filename:", 5, 18 122 56 16, tab 14 right
  text "Size:", 6, 18 150 56 16, tab 14 right
  text "User:", 7, 18 178 56 16, tab 14 right
  edit "", 8, 78 118 264 23, tab 14 read autohs
  edit "", 10, 78 175 264 23, tab 14 read autohs
  edit "", 12, 267 146 75 23, tab 14 read autohs
  text "Port:", 13, 230 150 34 16, tab 14 right
  edit "", 9, 78 146 151 23, tab 14 read autohs
  icon 15, -2 0 378 64, $scriptdir $+ libraries\icons\dccxoptionsheader.png, noborder
}

on *:dialog:dcc_options:init:0: {
  hadd ftps in.filename $gettok($hget(ftps,dcc.info),1,32)
  hadd ftps in.ip $longip($gettok($hget(ftps,dcc.info),2,32))
  hadd ftps in.port $gettok($hget(ftps,dcc.info),3,32)
  hadd ftps in.size $gettok($hget(ftps,dcc.info),4,32)
  did -ra dcc_options 8 $hget(ftps,in.filename)
  did -ra dcc_options 9 $hget(ftps,in.size)
  did -ra dcc_options 10 $address($hget(ftps,dcc.nick),5)
  did -ra dcc_options 12 $hget(ftps,in.port)
  hdel ftps dcc.type
}

on *:dialog:dcc_options:sclick:1: {
  hadd ftps dcc Normal
  .privmsg $me $chr(1) $+ DCC SEND $hget(ftps,inc.info) $+ $chr(1)
  dialog -x $dname $dname
  ;  hdel ftps inc.info
}

on *:dialog:dcc_options:sclick:2: {
  hadd ftps dcc.type DCCFXP
  dccfxp $hget(ftps,inc.info)
  dialog -x $dname $dname
}

on *:dialog:dcc_options:sclick:3: {
  dialog -x $dname
  dcc2ftp $hget(ftps,inc.info)
  ;var %q = $input(Sorry this feature is not active at the moment,o,Warning...,$null)
}

dialog dccfxp {
  title "DCC FXP"
  size -1 -1 206 226
  option pixels
  tab "DCC FXP", 4, 4 74 196 119
  combo 3, 30 141 144 100, tab 4 edit drop
  button "OK", 1, 126 198 75 22, tab 4
  text "Enter or Select Nick to FXP to:", 2, 30 120 150 18, tab 4
  box "Make Selection", 6, 13 99 178 79, tab 4
  icon 5, -2 0 209 64, $scriptdir $+ libraries\icons\dccxfxpheader.png, noborder
}

on *:dialog:dccfxp:init:0: {
  didtok dccfxp 3 46 $hget(ftps,nicks)
}

on *:dialog:dccfxp:sclick:1: {
  did -a $dname 3 $did($dname,3).text
  hadd ftps nicks $addtok($hget(ftps,nicks),$did(dccfxp,3),46)
  hsave -i ftps $inifile Settings
  dccfxp $gettok($dname,2,46) $did($dname,3).text
}

;---EVENT STUFF---

on *:start:{
  if ($exists($inifile)) {
    loadsettings
  }
}

on *:exit:{
  if (!%restart) {
    savesettings
  }
}
