;---Function Keys by mr.man (c) 2004 (Part of NeXtGenIRC)---

;---VARIOUS ALIASES---

alias fkeys {
  dialog -m fkeys fkeys
}

alias -l inifile {
  return $+(",$scriptdir,settings\fkeys.ini,")
}

alias -l makedefsettings {
  savesettings
}

alias -l savesettings {
  if (!%restart) {
    var %t = fkeys
    hsave -i %t $inifile Settings
  }
}

alias -l loadsettings {
  var %t = fkeys
  if ($hget(%t)) { hfree %t }
  hmake %t 40
  if ($exists($inifile)) {
    hload -i %t $inifile Settings
  }
}

;---DIALOG STUFF---

dialog fkeys {
  title "Function Keys"
  size -1 -1 394 498
  option pixels
  tab "Settings", 1, 5 76 383 389
  text "f1:", 5, 28 124 32 16, tab 1 right
  edit "", 4, 65 120 291 23, tab 1 autohs
  text "f2:", 7, 28 149 32 16, tab 1 right
  edit "", 6, 65 145 291 23, tab 1 autohs
  text "f3:", 9, 28 174 32 16, tab 1 right
  edit "", 8, 65 170 291 23, tab 1 autohs
  text "f4:", 14, 28 199 32 16, tab 1 right
  edit "", 15, 65 195 291 23, tab 1 autohs
  text "f5:", 13, 28 224 32 16, tab 1 right
  edit "", 12, 65 220 291 23, tab 1 autohs
  text "f6:", 11, 28 249 32 16, tab 1 right
  edit "", 10, 65 245 291 23, tab 1 autohs
  text "f7:", 20, 28 275 32 16, tab 1 right
  edit "", 21, 65 271 291 23, tab 1 autohs
  text "f8:", 19, 28 300 32 16, tab 1 right
  edit "", 18, 65 296 291 23, tab 1 autohs
  text "f9:", 17, 28 325 32 16, tab 1 right
  edit "", 16, 65 321 291 23, tab 1 autohs
  text "f10:", 26, 28 351 32 16, tab 1 right
  edit "", 27, 65 347 291 23, tab 1 autohs
  text "f11:", 25, 28 376 32 16, tab 1 right
  edit "", 24, 65 372 291 23, tab 1 autohs
  text "f12:", 23, 28 401 32 16, tab 1 right
  edit "", 22, 65 397 291 23, tab 1 autohs
  radio "Normal", 28, 121 425 66 20, group tab 1
  radio "Shift", 29, 209 425 56 20, tab 1
  box "F-Keys Settings", 3, 15 102 364 349, tab 1
  button "OK", 2, 314 470 75 22, ok
  icon 30, -2 1 397 64, $scriptdir $+ libraries\icons\fkeysheader.png, noborder
}

on *:dialog:fkeys:init:0:{
  did -c fkeys 28
  did -u fkeys 29
  just_f
}

on *:dialog:fkeys:sclick:2:{
  savesettings
  dialog -v cpanel
}

on *:dialog:fkeys:edit:4:{
  if ($did(fkeys,28).state == 1) {
    hadd fkeys f1 $did(fkeys,4).text
  }
  else if ($did(fkeys,29).state == 1) {
    hadd fkeys sf1 $did(fkeys,4).text
  }
}  

on *:dialog:fkeys:edit:6:{
  if ($did(fkeys,28).state == 1) {
    hadd fkeys f2 $did(fkeys,6).text
  }
  else if ($did(fkeys,29).state == 1) {
    hadd fkeys sf2 $did(fkeys,6).text
  }
}  

on *:dialog:fkeys:edit:8:{
  if ($did(fkeys,28).state == 1) {
    hadd fkeys f3 $did(fkeys,8).text
  }
  else if ($did(fkeys,29).state == 1) {
    hadd fkeys sf3 $did(fkeys,8).text
  }
}  

on *:dialog:fkeys:edit:15:{
  if ($did(fkeys,28).state == 1) {
    hadd fkeys f4 $did(fkeys,15).text
  }
  else if ($did(fkeys,29).state == 1) {
    hadd fkeys sf4 $did(fkeys,15).text
  }
}  

on *:dialog:fkeys:edit:12:{
  if ($did(fkeys,28).state == 1) {
    hadd fkeys f5 $did(fkeys,12).text
  }
  else if ($did(fkeys,29).state == 1) {
    hadd fkeys sf5 $did(fkeys,12).text
  }
}  

on *:dialog:fkeys:edit:10:{
  if ($did(fkeys,28).state == 1) {
    hadd fkeys f6 $did(fkeys,10).text
  }
  else if ($did(fkeys,29).state == 1) {
    hadd fkeys sf6 $did(fkeys,10).text
  }
}  

on *:dialog:fkeys:edit:21:{
  if ($did(fkeys,28).state == 1) {
    hadd fkeys f7 $did(fkeys,21).text
  }
  else if ($did(fkeys,29).state == 1) {
    hadd fkeys sf7 $did(fkeys,21).text
  }
}  

on *:dialog:fkeys:edit:18:{
  if ($did(fkeys,28).state == 1) {
    hadd fkeys f8 $did(fkeys,18).text
  }
  else if ($did(fkeys,29).state == 1) {
    hadd fkeys sf8 $did(fkeys,18).text
  }
}  

on *:dialog:fkeys:edit:16:{
  if ($did(fkeys,28).state == 1) {
    hadd fkeys f9 $did(fkeys,16).text
  }
  else if ($did(fkeys,29).state == 1) {
    hadd fkeys sf9 $did(fkeys,16).text
  }
}  

on *:dialog:fkeys:edit:27:{
  if ($did(fkeys,28).state == 1) {
    hadd fkeys f10 $did(fkeys,27).text
  }
  else if ($did(fkeys,29).state == 1) {
    hadd fkeys sf10 $did(fkeys,27).text
  }
}  

on *:dialog:fkeys:edit:24:{
  if ($did(fkeys,28).state == 1) {
    hadd fkeys f11 $did(fkeys,24).text
  }
  else if ($did(fkeys,29).state == 1) {
    hadd fkeys sf11 $did(fkeys,24).text
  }
}  

on *:dialog:fkeys:edit:22:{
  if ($did(fkeys,28).state == 1) {
    hadd fkeys f12 $did(fkeys,22).text
  }
  else if ($did(fkeys,29).state == 1) {
    hadd fkeys sf12 $did(fkeys,22).text
  }
}  

on *:dialog:fkeys:sclick:28:{
  just_f
}

on *:dialog:fkeys:sclick:29:{
  f_shift
}

;---OTHER FUNCTIONS---

alias -l just_f {
  if ($hget(fkeys,f1)) {
    did -ar fkeys 4 $ifmatch
  }
  else {
    did -r fkeys 4
  }
  if ($hget(fkeys,f2)) {
    did -ar fkeys 6 $ifmatch
  }
  else {
    did -r fkeys 6
  }
  if ($hget(fkeys,f3)) {
    did -ar fkeys 8 $ifmatch
  }
  else {
    did -r fkeys 8
  }
  if ($hget(fkeys,f4)) {
    did -ar fkeys 15 $ifmatch
  }
  else {
    did -r fkeys 15
  }
  if ($hget(fkeys,f5)) {
    did -ar fkeys 12 $ifmatch
  }
  else {
    did -r fkeys 12
  }
  if ($hget(fkeys,f6)) {
    did -ar fkeys 10 $ifmatch
  }
  else {
    did -r fkeys 10
  }
  if ($hget(fkeys,f7)) {
    did -ar fkeys 21 $ifmatch
  }
  else {
    did -r fkeys 21
  }
  if ($hget(fkeys,f8)) {
    did -ar fkeys 18 $ifmatch
  }
  else {
    did -r fkeys 18
  }
  if ($hget(fkeys,f9)) {
    did -ar fkeys 16 $ifmatch
  }
  else {
    did -r fkeys 16
  }
  if ($hget(fkeys,f10)) {
    did -ar fkeys 27 $ifmatch
  }
  else {
    did -r fkeys 27
  }
  if ($hget(fkeys,f11)) {
    did -ar fkeys 24 $ifmatch
  }
  else {
    did -r fkeys 24
  }
  if ($hget(fkeys,f12)) {
    did -ar fkeys 22 $ifmatch
  }
  else {
    did -r fkeys 22
  }
}

alias -l f_shift {
  if ($hget(fkeys,sf1)) {
    did -ar fkeys 4 $ifmatch
  }
  else {
    did -r fkeys 4
  }
  if ($hget(fkeys,sf2)) {
    did -ar fkeys 6 $ifmatch
  }
  else {
    did -r fkeys 6
  }
  if ($hget(fkeys,sf3)) {
    did -ar fkeys 8 $ifmatch
  }
  else {
    did -r fkeys 8
  }
  if ($hget(fkeys,sf4)) {
    did -ar fkeys 15 $ifmatch
  }
  else {
    did -r fkeys 15
  }
  if ($hget(fkeys,sf5)) {
    did -ar fkeys 12 $ifmatch
  }
  else {
    did -r fkeys 12
  }
  if ($hget(fkeys,sf6)) {
    did -ar fkeys 10 $ifmatch
  }
  else {
    did -r fkeys 10
  }
  if ($hget(fkeys,sf7)) {
    did -ar fkeys 21 $ifmatch
  }
  else {
    did -r fkeys 21
  }
  if ($hget(fkeys,sf8)) {
    did -ar fkeys 18 $ifmatch
  }
  else {
    did -r fkeys 18
  }
  if ($hget(fkeys,sf9)) {
    did -ar fkeys 16 $ifmatch
  }
  else {
    did -r fkeys 16
  }
  if ($hget(fkeys,sf10)) {
    did -ar fkeys 27 $ifmatch
  }
  else {
    did -r fkeys 27
  }
  if ($hget(fkeys,sf11)) {
    did -ar fkeys 24 $ifmatch
  }
  else {
    did -r fkeys 24
  }
  if ($hget(fkeys,sf12)) {
    did -ar fkeys 22 $ifmatch
  }
  else {
    did -r fkeys 22
  }
}

;---EVENTS STUFF---

on *:start:{
  loadsettings
}

on *:exit:{
  savesettings
}

;---FKEYS STUFF---

alias f1 { $hget(fkeys,f1) }
alias f2 { $hget(fkeys,f2) }
alias f3 { $hget(fkeys,f3) }
alias f4 { $hget(fkeys,f4) }
alias f5 { $hget(fkeys,f5) }
alias f6 { $hget(fkeys,f6) }
alias f7 { $hget(fkeys,f7) }
alias f8 { $hget(fkeys,f8) }
alias f9 { $hget(fkeys,f9) }
alias f10 { $hget(fkeys,f10) }
alias f11 { $hget(fkeys,f11) }
alias f12 { $hget(fkeys,f12) }
alias sf1 { $hget(fkeys,sf1) }
alias sf2 { $hget(fkeys,sf2) }
alias sf3 { $hget(fkeys,sf3) }
alias sf4 { $hget(fkeys,sf4) }
alias sf5 { $hget(fkeys,sf5) }
alias sf6 { $hget(fkeys,sf6) }
alias sf7 { $hget(fkeys,sf7) }
alias sf8 { $hget(fkeys,sf8) }
alias sf9 { $hget(fkeys,sf9) }
alias sf10 { $hget(fkeys,sf10) }
alias sf11 { $hget(fkeys,sf11) }
alias sf12 { $hget(fkeys,sf12) }
alias cf11 { fscontrol }
alias cf12 { run $hget(various,cf12) }
