;---FTPd by mr.man (c)2007 (Part of NeXtGenIRC)---

;---VARIOUS ALIASES---

alias timeout {
  if ($adminperms($socktouser($1)) != 1) {
    if ($sock($1)) {
      var %response = 421 Idle for $hget(ftpd,secsidle) Seconds... Closing connection
      doftplog < %response
      sockwrite -n $1 %response
      sockclose $1
      update.switchbar
    }
  }
}

alias doftplog {
  if ($1 == <) {
    var %msg = $pri $1-
  }
  else if ($1 == >) {
    var %msg = $sec $1-
  }
  else {
    var %msg = $1-
  }
  if ($window(@ftpdlog)) {
    aline -p @ftpdlog %msg
  }
  else {
    write $+(",$scriptdir,settings\ftpd.log,") %msg
  }
}

alias pwgen {
  var %n, %pw, %l = 1
  while (%l <= 8) {
    if ($calc($rand(0,9) % 2) == 0) {
      %n = $rand(0,9)
    }
    else {
      if ($calc($rand(0,9) % 2) == 0) {
        %n = $rand(A,Z)
      }
      else {
        %n = $rand(a,z)
      }
    }
    %pw = %pw $+ %n
    inc %l
  }
  return %pw
}

alias dlstats {
  var %dl = $readini($stats,stats,dl))
  %dl = $calc(%dl + $1)
  writeini $stats stats dl %dl
  var %df = $readini($stats,stats,df))
  %df = $calc(%df + 1)
  writeini $stats stats df %df
}

alias ulstats {
  var %ul = $readini($stats,stats,ul))
  %ul = $calc(%ul + $1)
  writeini $stats stats ul %ul
  var %uf = $readini($stats,stats,uf))
  %uf = $calc(%uf + 1)
  writeini $stats stats uf %uf
}

alias userdl {
  var %users = $readini($stats,stats,users))
  %users = $addtok(%users,$1,44)
  writeini $stats stats users %users
  var %dl = $readini($stats,$1,dl))
  %dl = $calc(%dl + $2)
  writeini $stats $1 dl %dl
  var %df = $readini($stats,$1,df))
  %df = $calc(%df + 1)
  writeini $stats $1 df %df
}

alias userul {
  var %users = $readini($stats,stats,users))
  %users = $addtok(%users,$1,44)
  writeini $stats stats users %users
  var %ul = $readini($stats,$1,ul))
  %ul = $calc(%ul + $2)
  writeini $stats $1 ul %ul
  var %uf = $readini($stats,$1,uf))
  %uf = $calc(%uf + 1)
  writeini $stats $1 uf %uf
}

alias -l stats {
  return $+(",$scriptdir,settings\stats.ini,")
}  

alias -l settings {
  return $+(",$scriptdir,settings\ftpd.ini,")
}

alias -l accounts {
  return $+(",$scriptdir,settings\accounts.ini,")
}

alias -l clients {
  return $+(",$scriptdir,settings\clients.ini,")
}

alias -l makedefsettings {
  hadd ftpd banner Welcome to $me $+ 's FTP
  hadd ftpd active 0
  hadd ftpd ctrlport 21
  hadd ftpd homedir c:/FTP/
  hadd ftpd pasvstart $gettok($readini($mircini,options,n4),13,44)
  hadd ftpd pasvend $gettok($readini($mircini,options,n4),26,44)
  hadd ftpd pasvip $ip
  hadd ftpd maxusers 3
  hadd ftpd trigger !trigger
  hadd ftpd address $ip
  hadd ftpd secsidle 300
  hadd ftpd notes Just a note!
  hadd ftpd autocreate 1
  hadd ftpd uploaduser upload
  hadd ftpd uploadpw upload
  hadd ftpd uploaddir c:/FTP/Uploads
  hadd ftpd autoclose 0
}

alias isuser {
  if ($istokcs($readini($accounts,accounts,axx),$1,44)) {
    return $true
  }
  else {
    return $false
  }
}

alias checkpass {
  if ($readini($accounts,$1,password)) {
    return $ifmatch
  }
}

alias gethomedir {
  if ($1 == $hget(ftpc,uploaduser)) {
    return $hget(ftpc,uploaddir)
  }
  else if ($readini($accounts,$1,homedir)) {
    return $ifmatch
  }
}

alias writeperms {
  if ($readini($accounts,$1,writeperms)) {
    return $ifmatch
  }
}

alias deleteperms {
  if ($readini($accounts,$1,deleteperms)) {
    return $ifmatch
  }
}

alias mkdirperms {
  if ($readini($accounts,$1,mkdirperms)) {
    return $ifmatch
  }
}

alias adminperms {
  if ($readini($accounts,$1,adminperms)) {
    return $ifmatch
  }
}

alias rmdirperms {
  if ($readini($accounts,$1,rmdirperms)) {
    return $ifmatch
  }
}

alias adduser {
  var %users = $readini($accounts,Accounts,axx)
  writeini $accounts Accounts axx $addtok(%users,$1,44)
  writeini $accounts $1 username $1
  writeini $accounts $1 password $pwgen
  writeini $accounts $1 homedir $hget(ftpd,homedir)
  writeini $accounts $1 writeperms 0
  writeini $accounts $1 deleteperms 0
  writeini $accounts $1 mkdirperms 0
}

alias deluser {
  var %users = $readini($accounts,Accounts,axx)
  if (%users) {
    writeini $accounts Accounts axx $remtok(%users,$1,44)
    remini $accounts $1
  }
  else {
    writeini $accounts Accounts axx $ $+ null
    remini $accounts $1
  }
}

alias addclient {
  var %clients = $readini($clients,Online,Users)
  writeini $clients Online Users $addtok(%clients,$2,44)
  writeini $clients Connected $1 $2
  writeini $clients Connected $2 $1
}

alias delclient {
  var %clients = $readini($clients,Online,Users)
  if (%clients) {
    writeini $clients Online Users $remtok(%clients,$2,44)
  }
  remini $clients Connected $1 $2
  remini $clients Connected $2 $1
}

alias usertosock {
  return $readini($clients,Connected,$1)
}

alias socktouser {
  return $readini($clients,Connected,$1)
}

alias ftp {
  if ($1 == 0) {
    return $sock(ctrl.*,0)
  }
  else if ($1) {
    return $socktouser($sock(ctrl.*,$1))
  }
}

alias onstart {
  if (!$hget(ftpd)) {
    hmake ftpd 16
  }
  if (!$isfile($settings)) {
    makedefsettings
  }
  else {
    hload -i ftpd $settings
  }
}

alias onexit {
  if (!%restart) {
    hsave -i ftpd $settings
  }
}

alias ftpstart {
  sockclose ftpctrl
  sockclose ctrl.*
  var %ctrl = $hget(ftpd,ctrlport)
  hadd ftpd pasvstart $gettok($readini($mircini,options,n4),13,44)
  hadd ftpd pasvend $gettok($readini($mircini,options,n4),26,44)
  ;if (!$portfree(%ctrl)) {
  ;  noop $input(Sorry... The Port you have specified is in use. Please select another.,owu,Warning!,$null)
  ;  did -u ftpd 7
  ;  halt
  ;}
  socklisten ftpctrl %ctrl
  hadd ftpd numofconns 0
  hadd ftpd active 1
  hadd ftpd activeconns none
  var %i = $xdid(switchbar,1,$chr(9) FTPd: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v switchbar 1 %i $chr(9) FTPd: Online
  }
}

alias ftpstop {
  sockclose ftpctrl
  sockclose ctrl.*
  sockclose data.*
  hadd ftpd activeconns $null
  hadd ftpd numofconns 0
  hadd ftpd active 0
  var %i = $xdid(switchbar,1,$chr(9) FTPd: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v switchbar 1 %i $chr(9) FTPd: Offline
  }
  update.switchbar
}

;---EVENTS---

on *:socklisten:ftpctrl:{
  var %conn = $+(ctrl.,$rand(10000,99999))
  sockaccept %conn
  if ($sock(%conn).ip isin $hget(ftpd,bans)) {
    var %response = 421 Sorry you are banned from this server!
    doftplog < %response
    sockwrite -n %conn %response
    sockclose %conn
    return
  }
  else {
    hadd ftpd activeconns $addtok($hget(ftpd,activeconns),%conn,44)
    doftplog < User from IP $sock(%conn).ip has connected.
    hinc ftpd numofconns
    hmake %conn 10
    hadd %conn currentdir $hget(ftpd,homedir)
    var %response = 220 $hget(ftpd,banner)
    doftplog < %response
    sockwrite -n %conn %response
  }
}

on *:sockread:ctrl.*:{
  if ($istok($hget(ftpd,activeconns),$sockname,44)) {
    if ($sockerr > 0) return
    :loop
    sockread %com
    if ($sockbr == 0) return
    if (%com == $null) %com = -
    tokenize 32 %com
    unset %com
    doftplog > $1-
    if ($1 == QUIT) {
      .timer $+ $sockname off
      hadd ftpd activeconns $remtok($hget(ftpd,activeconns),$sockname,44)
      delclient $sockname $usertosock($sockname)
      var %response = 221 Goodbye!
      doftplog < %response    
      sockwrite -n $sockname %response
      sockclose $sockname
      if ($hget(ftpd,numofconns) > 0) {
        hdec ftpd numofconns
      }
      update.switchbar
      return
    }
    if ($1 == USER) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      if ($adminperms($2)) {
        var %response = 331 Password required for admin account login.
        doftplog < %response
        hadd ftpd user $2
        sockwrite -n $sockname %response
        return
      }
      else if ($ftp(0) > $hget(ftpd,maxusers)) {
        var %response = 421 Max users limit has been reached. Please try later.
        doftplog < %response
        sockwrite -n $sockname %response
        sockclose $sockname
        hdec ftpd numofconns
        return
      }      
      var %l = 1
      while (%l <= $ftp(0)) {
        if ($2 == $ftp(%l)) {
          var %response = 421 You are already logged in.
          doftplog < %response
          sockwrite -n $sockname %response
          sockclose $sockname
        }
        inc %l  
      }
      if ($isuser($2)) {
        var %response = 331 Password required for login.
        doftplog < %response
        hadd ftpd user $2
        sockwrite -n $sockname %response
      }
      else if ($2 == $hget(ftpd,uploaduser)) {
        var %response = 331 Password required for Upload Account.
        doftplog < %response
        hadd ftpd user $2
        sockwrite -n $sockname %response
      }
      else {
        var %response = 421 Sorry you do not have an account on this server.
        doftplog < %response
        sockwrite -n $sockname %response
        sockclose $sockname
      }
      return
    }
    if ($1 == PASS) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      if ($hget(ftpd,user) == $hget(ftpd,uploaduser)) && ($2 == $hget(ftpd,uploadpw)) {
        var %response = 230 User in Upload Account successfully logged in.
        doftplog < %response
        sockwrite -n $sockname %response
        hadd $sockname currentdir $hget(ftpd,uploaddir)
        addclient $sockname $hget(ftpd,user)
      }
      else if ($2 === $checkpass($hget(ftpd,user))) {
        var %response = 230 User $hget(ftpd,user) successfully logged in.
        doftplog < %response
        sockwrite -n $sockname %response
        hadd $sockname currentdir $gethomedir($hget(ftpd,user))
        addclient $sockname $hget(ftpd,user)
      }
      else {
        var %response = 530 Password incorrect.
        doftplog < %response
        sockwrite -n $sockname %response
        sockclose $sockname
      }
      update.switchbar
      return      
    }
    if ($1 == SYST) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      var %response = 215 UNIX Type: L8
      doftplog < %response
      sockwrite -n $sockname %response
      return
    }
    if ($1 == REST) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      var %response = 350 REST supported. Ready to resume at byte offset $2 $+ .
      doftplog < %response
      sockwrite -n $sockname %response
      hadd ftpd restart $2
      return
    }      
    if ($1 == PWD) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      var %response = 257 $qt($hget($sockname,currentdir)) is Current Directory.
      doftplog < %response
      sockwrite -n $sockname %response
      return
    }
    if ($1 == NOOP) {
      var %response = 500 Invalid Command.
      doftplog < %response
      sockwrite -n $sockname %response
      return
    }
    if ($1 == CWD) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      if ($2 == .) {
        var %response = 500 Invalid Command.
        doftplog < %response
        sockwrite -n $sockname %response
        sockclose $sockname
        return
      }
      if ($right($2-,1) == /) {
        var %cwd = $left($2-,-1)
      }
      else {
        var %cwd = $2-
      }
      if ($socktouser($sockname) == $hget(ftpd,uploaduser)) {
        var %dir = $hget($sockname,currentdir)
        if ($numtok(%cwd,47) > 1) {
          var %new = $gettok(%cwd,$v1,47)
        }
        else {
          var %new = %cwd
        }
        if (%dir != %new) {
          if ($right(%dir,1) != /) && (%new != %dir) {
            %dir = %dir $+ / $+ %new
          }
          else {
            %dir = %dir $+ %new
          }
          if ($right(%dir,1) != /) {
            %dir = %dir $+ /
          }
        }
        if ($exists(%new)) {
          if ($hget(ftpd,uploaddir) isin %new) {
            %dir = %new
          }
        }
        if (!$exists(%dir)) {
          %dir = $hget(ftpd,uploaddir)
        }
        if (%new == /) {
          %dir = $hget(ftpd,uploaddir)
        }
        if ($hget(ftpd,resolve)) {
          if ($dll($+(",$scriptdir,libraries\ftpd.dll,"),resolve,%dir $+ %new $+ .lnk)) {
            %dir = $v1
            hadd $sockname shortcutdir $replace(%dir $+ /,\,/,//,/)
          }
        }
        else {
          %dir = $hget(ftpd,uploaddir)
        }
      }
      else {
        var %dir = $hget($sockname,currentdir)
        if ($numtok(%cwd,47) > 1) {
          var %new = $gettok(%cwd,$v1,47)
        }
        else {
          var %new = %cwd
        }
        if (%dir != %new) {
          if ($right(%dir,1) != /) && (%new != %dir) {
            %dir = %dir $+ / $+ %new
          }
          else {
            %dir = %dir $+ %new
          }
          if ($right(%dir,1) != /) {
            %dir = %dir $+ /
          }
        }
        if ($exists(%new)) {
          if ($gethomedir($socktouser($sockname)) isin %new) {
            %dir = %new
          }
        }
        if (!$exists(%dir)) {
          %dir = $gethomedir($socktouser($sockname))
        }
        if (%new == /) {
          %dir = $gethomedir($socktouser($sockname))
        }
        if ($hget(ftpd,resolve)) {
          if ($dll($+(",$scriptdir,libraries\ftpd.dll,"),resolve,%dir $+ %new $+ .lnk)) {
            hadd $sockname prevdir %dir
            %dir = $v1 $+ /
            hadd $sockname shortcutdir $replace(%dir,\,/,//,/)
          }
          else if ($dll($+(",$scriptdir,libraries\ftpd.dll,"),resolve,$hget($sockname,currentdir) $+ %new $+ .lnk)) {
            hadd $sockname prevdir $hget($sockname,currentdir)
            %dir = $v1 $+ /
            hadd $sockname shortcutdir $replace(%dir,\,/,//,/)
          }
        }
      }
      var %dir = $replace(%dir,\,/,//,/)
      if ($right(%dir,1) != /) {
        %dir = %dir $+ /
      }
      if ($isdir(%dir)) {
        hadd $sockname currentdir %dir
        var %response = 250 CWD command successful. $qt(%dir) is current directory.
        doftplog < %response
        sockwrite -n $sockname %response
        getdirs $sockname $hget($sockname,currentdir)
        listdirs $sockname $replace($sockname,ctrl,data)
        return
      }
      else {
        var %response = 530 Invalid directory.
        doftplog < %response
        sockwrite -n $sockname %response
        return        
      }
    }
    if ($1 == CDUP) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      var %cd = $hget($sockname,currentdir), %m = $numtok(%cd,47)
      if (%cd == $gethomedir($socktouser($sockname))) {
        var %response = 550 CWD failed. No permission.
        doftplog < %response
        sockwrite -n $sockname %response
      }
      else if ($socktouser($sockname) == $hget(ftpd,uploaduser)) {
        if (%cd == $hget(ftpd,uploaddir)) {
          var %response = 550 CWD failed. No permission.
          doftplog < %response
          sockwrite -n $sockname %response
        }
        else if ($hget($sockname,shortcutdir) == %cd) {
          %cd = $hget(ftpd,uploaddir))
          hadd $sockname currentdir %cd
          getdirs $sockname %cd
          listdirs $sockname $replace($sockname,ctrl,data)
          var %response = 250 CWD command successful. $qt(%cd) is current directory.
          doftplog < %response
          sockwrite -n $sockname %response
        }
        else {
          %cd = $gettok(%cd,$+(1-,$calc(%m - 1)),47) $+ /
          hadd $sockname currentdir %cd
          getdirs $sockname %cd
          listdirs $sockname $replace($sockname,ctrl,data)
          var %response = 250 CWD command successful. $qt(%cd) is current directory.
          doftplog < %response
          sockwrite -n $sockname %response
        }
      }
      else if ($hget($sockname,shortcutdir) == %cd) {
        %cd = $hget($sockname,prevdir)
        hadd $sockname currentdir %cd
        getdirs $sockname %cd
        listdirs $sockname $replace($sockname,ctrl,data)
        var %response = 250 CWD command successful. $qt(%cd) is current directory.
        doftplog < %response
        sockwrite -n $sockname %response
      }
      else {
        %cd = $gettok(%cd,$+(1-,$calc(%m - 1)),47) $+ /
        hadd $sockname currentdir %cd
        getdirs $sockname %cd
        listdirs $sockname $replace($sockname,ctrl,data)
        var %response = 250 CWD command successful. $qt(%cd) is current directory.
        doftplog < %response
        sockwrite -n $sockname %response
      }
      return
    }
    if ($1 == TYPE) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      var %response = 200 Type set to $2 $+ .
      doftplog < %response
      sockwrite -n $sockname %response
      return
    }
    if ($1 == PORT) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      var %portname = $replace($sockname,ctrl,data)
      if ($sock(%portname).status) sockclose %portname
      hadd $sockname PORT %portname $toaddress($2) $toport($replace($2,$chr(44),$chr(46)))
      hadd $sockname SCTYPE PORT
      hadd ftpd restart 0
      var %response = 200 PORT Command Successful.
      doftplog < %response
      sockwrite -n $sockname %response
      return
    }
    if ($1 == PASV) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      hadd $sockname SCTYPE PASV
      :portcheck
      var %pasv = $rand($hget(ftpd,pasvstart),$hget(ftpd,pasvend))
      if (!$portfree(%pasv)) {
        goto portcheck
      }
      sockclose dataport
      if (!$sock(dataport)) {
        socklisten dataport %pasv
      }
      hadd ftpd restart 0
      hadd ftpd newdataport $replace($sockname,ctrl,data)
      var %response = 227 Entering Passive Mode ( $+ $replace($hget(ftpd,pasvip),.,$chr(44)) $+ , $+ $replace($fromport(%pasv),.,$chr(44)) $+ )
      doftplog < %response
      sockwrite -n $sockname %response
      return
    }
    if ($1 == LIST) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      var %sc = $sockname
      hadd $sockname COMM LIST
      if ($hget(%sc,SCTYPE) == PASV) {
        getdirs %sc $hget(%sc,currentdir)
        listdirs %sc $replace(%sc,ctrl,data)
        var %response = 226 Transfer OK.
        doftplog < %response
        sockwrite -n %sc %response
        return
      }
      if ($hget($sockname,SCTYPE) == PORT) && ($hget($sockname,PORT)) {
        sockopen $hget($sockname,PORT)
        var %response = 150 Opening ASCII data connection for Directory List.
        doftplog < %response
        sockwrite -n $sockname %response
        return
      }
      return
    }
    if ($1 == RETR) {
      .timer $+ $sockname off
      hadd $sockname COMM RETR
      hadd $sockname FILE $2-
      if ($hget($sockname,SCTYPE) == PASV) {
        var %response = 150 Data connection accepted from $hget(ftpd,pasvip) $+ . Transfer starting for $2- $+ .
        doftplog < %response
        sockwrite -n $sockname %response
        ftpsend $sockname $replace($sockname,ctrl,data) $2-
      }
      if ($hget($sockname,SCTYPE) == PORT) && ($hget($sockname,PORT)) {
        sockopen $hget($sockname,PORT)
      }
      var %response = 150 Data connection accepted from $hget(ftpd,pasvip) $+ . Transfer starting for $2- $+ .
      theme.text $s.head(User) $s.encleft $+ $s.value($socktouser($sockname)) $+ $s.encright $s.head(is downloading) $s.encleft $+ $s.value($2-) $+ $s.encright
      doftplog < %response
      sockwrite -n $sockname %response
      return
    }
    if ($1 == DELE) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      if ($deleteperms($socktouser($sockname))) {
        .remove $+(",$hget($sockname,currentdir) $+ $2-,")
        var %response = 250 File/Dir ' $+ $2- $+ ' Deleted.
        doftplog < %response
        sockwrite -n $sockname %response
      }
      else {
        var %response = 550 Cannot DELE. No Permission.
        doftplog < %response
        sockwrite -n $sockname %response
      }
      return      
    }
    if ($1 == STOR) {
      .timer $+ $sockname off
      if ($right($2-,4) == .lnk) {
        var %response = 550 Cannot STOR. Illegal File.
        doftplog < %response
        sockwrite -n $sockname %response
      }
      else if ($writeperms($socktouser($sockname)) || $socktouser($sockname) == $hget(ftpd,uploaduser)) {
        hadd $sockname COMM STOR
        hadd $sockname FILE $hget($sockname,currentdir) $+ / $+ $2-
        theme.text $s.head(User) $s.encleft $+ $s.value($socktouser($sockname)) $+ $s.encright $s.head(is uploading) $s.encleft $+ $s.value($2-) $+ $s.encright
        %file. [ $+ [ $replace($sockname,ctrl,data) ] ] = $hget($sockname,FILE)
        if ($hget($sockname,SCTYPE) == PASV) {
          var %response = 150 Data connection accepted from $hget(ftpd,pasvip) $+ . Transfer starting for $2- $+ .
          doftplog < %response
          sockwrite -n $sockname %response
        }
        if ($hget($sockname,SCTYPE) == PORT) && ($hget($sockname,PORT)) {
          var %response = 150 Opening data connection for $2- $+ .
          doftplog < %response
          sockopen $hget($sockname,PORT)
          sockwrite -n $sockname %response
        }
      }
      else {
        var %response = 550 Cannot STOR. No Permission.
        doftplog < %response
        sockwrite -n $sockname %response
      }
      return
    }
    if ($1 == MKD) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      if ($mkdirperms($socktouser($sockname)) || $socktouser($sockname) == $hget(ftpd,uploaduser)) {
        var %cd = $hget($sockname,currentdir)
        if ($right(%cd,1) != /) {
          %cd = %cd $+ /
        }
        if (%cd isin $2-) {
          mkdir $+(",$2-,")
        }
        else {
          mkdir $+(",%cd,$2-,")
        }
        var %response = 257 ' $+ $2- $+ ': Directory Created.
        doftplog < %response
        sockwrite -n $sockname %response
      }
      else {
        var %response = 550 ' $+ $2- $+ ': Can't Create Directory. No Permission.
        doftplog < %response
        sockwrite -n $sockname %response
      }
      return
    }
    if ($1 == RMD) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      if ($rmdirperms($socktouser($sockname)) || $adminperms($socktouser($sockname)) || $socktouser($sockname) == $hget(ftpd,uploaduser)) {
        var %cd = $hget($sockname,currentdir)
        if ($right(%cd,1) != /) {
          %cd = %cd $+ /
        }
        if ($isdir($2-)) {
          var %dir = $+(",$2-,")
        }
        else if ($isdir(%cd $+ $2-)) {
          var %dir = $+(",%cd,$2-,")
        }
        var %files = $findfile(%dir,*,1)
        if (%files) {
          var %response = 550 ' $+ $2- $+ ': Can't Remove Directory. Not Empty.
          doftplog < %response
          sockwrite -n $sockname %response
          return
        }
        else {
          .rmdir %dir
          var %response = 250 RMD command successful.
          doftplog < %response
          sockwrite -n $sockname %response
          return
        }
      }
      else {
        var %response = 550 ' $+ $2- $+ ': Can't Remove Directory. No Permission.
        doftplog < %response
        sockwrite -n $sockname %response
      }
      return
    }
    if ($1 == ABOR) {
      var %response = 426 Connection closed; Transfer Aborted.
      sockclose ftp.data
      sockclose ftpdata
      doftplog < %response
      sockwrite -n $sockname %response
      return
    }
    if ($1 == SIZE) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      hadd $sockname FILE $hget($sockname,currentdir) $+ $2-
      var %fsize = $file($hget($sockname,FILE)).size
      hadd $sockname SIZE %fsize
      if (%fsize > 0) {
        var %response = 213 %fsize
        doftplog < %response
        sockwrite -n $sockname %response
      }
      else {
        var %response = 550 No such file or directory.
        doftplog < %response
        sockwrite -n $sockname %response
      }
      return
    }
    if ($1 == SITE) {
      .timer $+ $sockname off
      .timer $+ $sockname 1 $hget(ftpd,secsidle) timeout $sockname
      if ($2-) && ($2 != STAT) && ($3 != HELP) {
        theme.text $s.head(FTP message from $socktouser($sockname)) $s.encleft $+ $s.value($2-) $+ $s.encright
      }
      return
    }
    else {
      var %response = 500 Unknown command.
      doftplog < %response
      sockwrite -n $sockname %response
      return
    }
    goto loop
  }
}

on *:sockclose:ctrl.*:{
  hadd ftpd activeconns $remtok($hget(ftpd,activeconns),$sockname,1,44)
  if ($hget(ftpd,numofconns) > 0) {
    hdec ftpd numofconns
  }
  delclient $sockname $socktouser($sockname)
  if ($hget($sockname)) {
    hfree $sockname
  }
  .timer 1 0 update.switchbar
}

on *:sockopen:data.*:{
  var %sc = $replace($sockname,data,ctrl)
  if ($sockerr) {
    var %response = 425 Can't open data connection matey.
    doftplog < %response
    sockwrite -n %sc %response
    return
  }
  if ($hget(%sc,COMM) == LIST) {
    getdirs $sockname $hget(%sc,currentdir)
    listdirs %sc $sockname
    var %response = 226 Transfer Ok.
    doftplog < %response
    sockwrite -n %sc %response
    return
  }
  if ($hget(%sc,COMM) == RETR) {
    ftpsend $replace($sockname,data,ctrl) $sockname $hget($replace($sockname,data,ctrl),FILE)
    return
  }
  ;doftplog Data Connection Open...
}

on *:socklisten:dataport:{
  sockclose $hget(ftpd,newdataport)
  sockaccept $hget(ftpd,newdataport)
  ;doftplog Data Port Connected...
}

on *:sockread:data.*:{
  if ($sockerr > 0) return
  if (!$sock($sockname).mark) && (!$hget(ftpd,restart)) {
    .remove $+(",%file. [ $+ [ $sockname ] ],")
    sockmark $sockname 1
  }
  :next
  sockread -f 16384 &filedata
  if ($sockbr == 0) return
  bwrite $+(",%file. [ $+ [ $sockname ] ],") -1 16384 &filedata
  goto next
}

on *:sockclose:data.*:{
  var %response = 226 Transfer Groovy.
  sockmark $sockname $null
  doftplog < %response
  if ($sock($replace($sockname,data,ctrl))) {
    sockwrite -n $replace($sockname,data,ctrl) %response
    ulstats $file(%file. [ $+ [ $sockname ] ]).size
    userul $socktouser($replace($sockname,data,ctrl)) $file(%file. [ $+ [ $sockname ] ]).size
    unset %file. [ $+ [ $sockname ] ]
    .timer $+ $replace($sockname,data,ctrl) off
    .timer $+ $replace($sockname,data,ctrl) 1 $hget(ftpd,secsidle) timeout $replace($sockname,data,ctrl)
  }
}

alias listdirs {
  if ($sock($2).status) {
    var %dirs = $+(",$scriptdir,temp\,$1,") , %l = 0
    if ($hget($1,SCTYPE) == PORT) {
      %dirs = $replace(%dirs,ctrl,data)
    }
    var %response = 150 Data connection accepted; transfer starting.
    doftplog < %response
    sockwrite -n $1 %response
    listsend $2 $1 %dirs
    ;.remove %dirs
  }
}

alias getdirs {
  var %cm = $2-
  if ($right(%cm,1) != /) {
    %cm = %cm $+ /
  }
  dll $+(",$scriptdir,libraries\ftpd.dll,") listdir %cm
  dll $+(",$scriptdir,libraries\ftpd.dll,") compilelist $1
}

alias toaddress {
  tokenize 44 $1-4
  return $replace($1-4,$chr(32),$chr(46))
}

alias toport {
  return $longip($+(0.0.,$gettok($1,-2-,46)))
}

alias fromport {
  return $remove($longip($1),0.0.)
}

on *:sockwrite:data.*:{
  if ($hget($replace($sockname,data,ctrl),COMM) == RETR) {
    .timer 1 0 ftpsend $hget(ftpd,datasock) $hget(ftpd,sockname) $hget(ftpd,getfile)
  }
  else {
    .timer 1 0 listsend $hget(ftpd,datasock) $hget(ftpd,sockname) $hget(ftpd,listfile)
  }
}

alias listsend {
  hadd ftpd datasock $1
  hadd ftpd sockname $2
  hadd ftpd listfile $3-
  var %cf = $file($3-).size
  if (!$sock($1).mark) {
    sockmark $1 0
  }
  if ($sock($1).mark >= %cf) {
    sockclose $1
    var %response = 226 Transfer finished successfully. Data connection closed.
    doftplog < %response
    sockwrite -n $2 %response
    goto endlist
  }
  bread $3- $sock($1).mark 8192 &data
  sockwrite -b $1 8192 &data
  sockmark $1 $calc($sock($1).mark + 8192)
  :endlist
}

alias ftpsend {
  hadd ftpd datasock $1
  hadd ftpd sockname $2
  hadd ftpd getfile $3-
  var %cf = $file($+(",$hget($1,currentdir),$3-,")).size
  hadd $1 size %cf
  if (!$sock($2).mark) {
    sockmark $2 0
  }
  if ($hget(ftpd,restart) > 0) && ($sock($2).mark == 0) {
    sockmark $2 $hget(ftpd,restart)
  }
  if ($sock($2).mark >= %cf) {
    sockclose $2
    var %response = 226 Transfer finished successfully. Data connection closed.
    doftplog < %response
    sockwrite -n $1 %response
    dlstats %cf
    userdl $socktouser($replace($2,data,ctrl)) %cf
    .timer $+ $replace($2,data,ctrl) off
    .timer $+ $replace($2,data,ctrl) 1 $hget(ftpd,secsidle) timeout $replace($2,data,ctrl)
    goto endftp
  }
  bread $+(",$hget($1,currentdir),\,$3-,") $sock($2).mark 8192 &data
  sockwrite -b $2 8192 &data
  sockmark $2 $calc($sock($2).mark + 8192)
  :endftp
}

on *:start:{
  onstart
}

on *:exit:{
  onexit
}

;---DIALOG STUFF---

alias ftpd {
  dialog -m ftpd ftpd
}

dialog ftpd {
  title "FTP Server"
  size -1 -1 427 371
  option pixels
  tab "Settings", 1, 4 74 418 265
  box "Main Settings", 4, 12 100 401 112, tab 1
  check "FTP Server Active", 7, 4 344 108 20, tab 1
  edit "", 9, 109 119 82 23, tab 1 autohs
  text "Listen on Port:", 10, 34 124 70 16, tab 1
  text "PASV Mode IP:", 11, 200 124 71 16, tab 1
  edit "", 12, 273 119 105 23, tab 1 autohs
  text "Default Home Dir:", 20, 23 151 86 16, tab 1
  edit "", 21, 109 146 251 23, tab 1 autohs
  button "...", 22, 366 148 30 20, tab 1
  text "Trigger:", 14, 36 238 41 16, tab 1
  edit "", 15, 80 233 58 23, tab 1 autohs
  text "Max Users:", 18, 24 265 55 16, tab 1
  edit "", 17, 188 233 186 23, tab 1 autohs
  edit "", 19, 80 260 58 23, tab 1 autohs
  text "Address:", 16, 144 238 41 16, tab 1
  box "Trigger Settings", 13, 12 216 401 107, tab 1
  edit "", 24, 267 260 58 23, tab 1 autohs
  edit "", 26, 80 287 312 23, tab 1 autohs
  text "Kick User after", 23, 191 265 74 16, tab 1
  text "Notes:", 25, 41 292 34 16, tab 1
  text "Seconds Idle", 53, 329 265 66 16, tab 1
  button "?", 55, 381 121 15 20, tab 1
  button "?", 56, 380 235 15 20, tab 1
  text "Welcome Banner:", 75, 23 180 86 16, tab 1
  edit "", 76, 109 175 288 23, tab 1 autohs
  tab "Options", 3
  box "Upload Details", 29, 12 101 400 96, tab 3
  list 44, 23 219 173 92, tab 3 size
  box "Ban List", 43, 12 202 195 121, tab 3
  edit "", 50, 120 124 101 23, tab 3
  text "Upload Username:", 51, 29 129 90 16, tab 3
  box "Channels ", 45, 217 202 195 121, tab 3
  list 54, 228 220 173 92, tab 3 size
  text "Upload Home Dir:", 59, 31 162 86 16, tab 3
  edit "", 60, 120 157 234 23, tab 3 autohs
  button "...", 61, 362 159 30 20, tab 3
  check "Kick user on Part/Quit", 36, 4 344 152 20, tab 3
  text "Upload Pass:", 33, 226 129 66 16, tab 3
  edit "", 34, 292 124 101 23, tab 3
  tab "Accounts", 5
  box "Accounts Setup", 31, 12 101 400 222, tab 5
  list 32, 23 119 377 191, tab 5 size
  check "Auto Create Accounts on Trigger", 30, 4 344 183 20, tab 5
  tab "Statistics", 8
  box "User Statistics", 63, 12 101 400 139, tab 8
  list 64, 23 118 377 110, tab 8 size
  box "Total Statistics", 65, 12 244 400 80, tab 8
  text "Files Uploaded:", 66, 38 266 83 16, tab 8 right
  text "Files Downloaded:", 67, 31 294 89 16, tab 8 right
  edit "", 68, 124 261 63 23, tab 8 read autohs
  text "Total Downloaded:", 70, 202 294 94 16, tab 8 right
  edit "", 71, 301 289 85 23, tab 8 read autohs
  text "Total Uploaded:", 72, 209 266 88 16, tab 8 right
  edit "", 73, 301 261 85 23, tab 8 read autohs
  edit "", 69, 124 289 63 23, tab 8 read autohs
  check "Resolve Windows Shortcuts", 6, 4 344 214 20, tab 8
  tab "Log", 62
  button "", 28, 23 118 379 195, tab 62
  box "Activity Log", 27, 12 101 400 223, tab 62
  button "OK", 2, 348 343 75 22, ok
  icon 35, -2 0 430 64, $scriptdir $+ libraries\icons\ftpdheader.png, 0, noborder
}

on *:dialog:ftpd:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 32 listview single rowselect showsel alignleft report > $views
  did -i $dname 32 1 headerdims 100:1 90:2 100:3 60:4
  did -i $dname 32 1 headertext 0 Username $+ $chr(9) $+ 0 Password $+ $chr(9) $+ 0 Home $+ $chr(9) $+ 0 Perms
  mdx SetControlMDX 64 listview single rowselect showsel alignleft report > $views
  did -i $dname 64 1 headerdims 145:1 100:2 100:3
  did -i $dname 64 1 headertext 0 Username $+ $chr(9) $+ 0 Uploaded $+ $chr(9) $+ 0 Downloaded
  mdx SetControlMDX 44 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 44 1 headerdims 145:1
  did -i $dname 44 1 headertext 0 Banned IPs
  mdx SetControlMDX 54 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 54 1 headerdims 145:1
  did -i $dname 54 1 headertext 0 Channels
  fillstats
  fillaxx
  did -ar $dname 68 $readini($stats,stats,uf)
  did -ar $dname 69 $readini($stats,stats,df)
  did -ar $dname 73 $bytes($readini($stats,stats,ul)).suf
  did -ar $dname 71 $bytes($readini($stats,stats,dl)).suf
  mdx SetControlMDX $dname 28 window > $dlg
  window -hdae9kS @ftpdlog
  did -a $dname 28 grab $window(@ftpdlog).hwnd @ftpdlog
  if ($exists($+(",$scriptdir,settings\ftpd.log,"))) {
    loadbuf -pi5 @ftpdlog $+(",$scriptdir,settings\ftpd.log,")
  }
  did -ar $dname 9 $hget(ftpd,ctrlport)
  did -ar $dname 12 $hget(ftpd,pasvip)
  did -ar $dname 15 $hget(ftpd,trigger)
  did -ar $dname 17 $hget(ftpd,address)
  did -ar $dname 19 $hget(ftpd,maxusers)
  did -ar $dname 21 $hget(ftpd,homedir)
  did -ar $dname 24 $hget(ftpd,secsidle)
  did -ar $dname 26 $hget(ftpd,notes)
  if ($hget(ftpd,active) == 1) {
    did -c $dname 7
    did -b $dname 9,12,15,17,19,21,22,24,26,55,56,76
  }
  else {
    did -u $dname 7
    did -e $dname 9,12,15,17,19,21,22,24,26,55,56,76
  }  
  if ($hget(ftpd,autocreate) == 1) {
    did -c $dname 30
  }
  else {
    did -u $dname 30
  }
  if ($hget(ftpd,resolve) == 1) {
    did -c $dname 6
  }
  else {
    did -u $dname 6
  }
  if ($hget(ftpd,partkick) == 1) {
    did -c $dname 36
  }
  else {
    did -u $dname 36
  }
  did -ar $dname 50 $hget(ftpd,uploaduser)
  did -ar $dname 34 $hget(ftpd,uploadpw)
  did -ar $dname 60 $hget(ftpd,uploaddir)
  fillftpbans
  fillftpchans
  did -ar $dname 76 $hget(ftpd,banner)
}

on *:dialog:ftpd:close:0:{
  .remove $+(",$scriptdir,settings\ftpd.log,")
  savebuf @ftpdlog $+(",$scriptdir,settings\ftpd.log,")
}

on *:dialog:ftpd:sclick:2: {
  hadd ftpd active $did($dname,7).state
  hadd ftpd ctrlport $did($dname,9)
  hadd ftpd pasvip $did($dname,12)
  hadd ftpd trigger $did($dname,15)
  hadd ftpd address $did($dname,17)
  hadd ftpd maxusers $did($dname,19)
  hadd ftpd homedir $did($dname,21)
  hadd ftpd secsidle $did($dname,24)
  hadd ftpd notes $did($dname,26)
  hadd ftpd autocreate $did($dname,30).state
  hadd ftpd uploaduser $did($dname,50)
  hadd ftpd uploadpw $did($dname,34)
  hadd ftpd banner $did($dname,76)
}

on *:dialog:ftpd:sclick:6: {
  hadd ftpd resolve $did($dname,6).state
}

on *:dialog:ftpd:sclick:7: {
  if ($did($dname,7).state == 1) {
    ftpstart
    did -b $dname 9,12,15,17,19,21,22,24,26,55,56,76
  }
  else {
    ftpstop
    did -e $dname 9,12,15,17,19,21,22,24,26,55,56,76
  }
}

on *:dialog:ftpd:sclick:22: {
  did -ar $dname 21 $replace($sdir(C:\,Select Directory),\,/)
}

on *:dialog:ftpd:sclick:55: {
  did -ar $dname 12 $ip
}

on *:dialog:ftpd:sclick:56: {
  did -ar $dname 17 $ip
}

on *:dialog:ftpd:sclick:30: {
  hadd ftpd autocreate $did($dname,30).state
}

on *:dialog:ftpd:sclick:36: {
  hadd ftpd partkick $did($dname,36).state
}

on *:dialog:ftpd:sclick:32:{
  if ($gettok($did($dname,32,1),1,32) == rclick) {
    ftpnewaccpop $did(32).sel $gettok($gettok($did(32).seltext,6,32),1,9)
  }
}

on *:dialog:ftpd:sclick:44:{
  if ($gettok($did($dname,44,1),1,32) == rclick) {
    ftpbanpop $did(44).sel $gettok($gettok($did(44).seltext,6,32),1,9)
  }
}

on *:dialog:ftpd:sclick:54:{
  if ($gettok($did($dname,54,1),1,32) == rclick) {
    ftpchanpop $did(54).sel $gettok($gettok($did(54).seltext,6,32),1,9)
  }
}

on *:dialog:ftpd:sclick:64:{
  if ($gettok($did($dname,64,1),1,32) == rclick) {
    ftpstatspop $did(64).sel $gettok($gettok($did(64).seltext,6,32),1,9)
  }
}

on *:dialog:ftpd:edit:9: {
  hadd ftpd ctrlport $did($dname,9)
}

on *:dialog:ftpd:edit:12: {
  hadd ftpd pasvip $did($dname,12)
}

on *:dialog:ftpd:edit:21: {
  hadd ftpd homedir $did($dname,21)
}

on *:dialog:ftpd:edit:15: {
  hadd ftpd trigger $did($dname,15)
}

on *:dialog:ftpd:edit:17: {
  hadd ftpd address $did($dname,17)
}

on *:dialog:ftpd:edit:19: {
  hadd ftpd maxusers $did($dname,19)
}

on *:dialog:ftpd:edit:24: {
  hadd ftpd secsidle $did($dname,24)
}

on *:dialog:ftpd:edit:26: {
  hadd ftpd notes $did($dname,26)
}

on *:dialog:ftpd:edit:76: {
  hadd ftpd banner $did($dname,76)
}

on *:dialog:ftpd:edit:50: {
  hadd ftpd uploaduser $did($dname,50)
}

on *:dialog:ftpd:edit:34: {
  hadd ftpd uploadpw $did($dname,34)
}

on *:dialog:ftpd:edit:60: {
  hadd ftpd uploaddir $did($dname,60)
}

on *:dialog:ftpd:sclick:61: {
  did -ar $dname 60 $replace($sdir(C:\,Select Directory),\,/)
  hadd ftpd uploaddir $did($dname,60)
}

menu @ftpdlog {
  Clear:clear | write -c $+(",$scriptdir,settings\ftpd.log,")
}

on *:input:@ftpdlog: {
  ftpchat $1-
} 

alias fillftpbans {
  var %l = 1, %bans = $hget(ftpd,bans)
  while (%l <= $numtok(%bans,44)) {
    var %ban = $gettok(%bans,%l,44) 
    did -a ftpd 44 + 0 0 0 %ban
    inc %l
  }
}

alias fillftpchans {
  var %l = 1, %chans = $hget(ftpd,channels)
  while (%l <= $numtok(%chans,44)) {
    var %chan = $gettok(%chans,%l,44) 
    did -a ftpd 54 + 0 0 0 %chan
    inc %l
  }
}

alias clearftpstats {
  .remove $stats
  write $stats [stats]
  write $stats ul=0
  write $stats dl=0
  write $stats uf=0
  write $stats df=0
  if ($dialog(ftpd)) {
    did -r ftpd 64 2
    did -ar ftpd 68 $readini($stats,stats,uf)
    did -ar ftpd 69 $readini($stats,stats,df)
    did -ar ftpd 73 $bytes($readini($stats,stats,ul)).suf
    did -ar ftpd 71 $bytes($readini($stats,stats,dl)).suf  
  }
}

alias newftpacc {
  dialog -m newftpacc newftpacc
}

dialog newftpacc {
  title "New FTP Account"
  size -1 -1 313 334
  option pixels
  tab "Account", 1, 5 75 301 224
  box "Details", 2, 15 101 281 121, tab 1
  box "Permissions", 13, 15 228 281 54, tab 1
  edit "", 9, 98 124 175 23, tab 1 autohs
  edit "", 10, 98 152 175 23, tab 1 autohs
  edit "", 11, 98 181 144 23, tab 1 autohs
  button "...", 12, 245 183 27 20, tab 1
  text "Username:", 3, 41 129 50 16, tab 1
  text "Password:", 4, 41 158 50 16, tab 1
  check "Admin", 16, 25 248 50 20, tab 1
  check "Write", 8, 76 248 48 20, tab 1
  check "Delete", 7, 125 248 50 20, tab 1
  check "Mk Dir", 5, 178 248 48 20, tab 1
  check "Rm Dir", 17, 231 248 52 20
  text "Home Dir:", 6, 41 185 50 16
  button "OK", 14, 232 305 75 22, ok
  button "Cancel", 15, 154 305 75 22, cancel
  icon 18, -2 0 316 64, $scriptdir $+ libraries\icons\newftpaccheader.png, noborder
}

on *:dialog:newftpacc:init:0:{
  did -f $dname 9
  did -b $dname 14
  did -ar $dname 11 $hget(ftpd,homedir)
}

on *:dialog:newftpacc:edit:9:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11)) {
    did -e $dname 14
  }
  else {
    did -b $dname 14
  }
}

on *:dialog:newftpacc:edit:10:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11)) {
    did -e $dname 14
  }
  else {
    did -b $dname 14
  }
}

on *:dialog:newftpacc:edit:11:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11)) {
    did -e $dname 14
  }
  else {
    did -b $dname 14
  }
}

on *:dialog:newftpacc:sclick:12: {
  did -ar $dname 11 $replace($sdir(C:\,Select Directory),\,/)
}

on *:dialog:newftpacc:sclick:14:{
  if ($isuser($did($dname,9))) {
    noop $input(This Username already exists...,ow,Error...)
    did -rf $dname 9
    halt
  }
  else {
    writeini $accounts accounts axx $addtok($readini($accounts,accounts,axx),$did($dname,9),44)
    writeini $accounts $did($dname,9) username $did($dname,9)
    writeini $accounts $did($dname,9) password $did($dname,10)
    writeini $accounts $did($dname,9) homedir $did($dname,11)
    writeini $accounts $did($dname,9) writeperms $did($dname,8).state
    writeini $accounts $did($dname,9) deleteperms $did($dname,7).state
    writeini $accounts $did($dname,9) mkdirperms $did($dname,5).state
    writeini $accounts $did($dname,9) adminperms $did($dname,16).state
    writeini $accounts $did($dname,9) rmdirperms $did($dname,17).state
    did -r ftpd 32
    fillaxx
  }
}

alias editftpacc {
  dialog -m editftpacc editftpacc
  did -ar editftpacc 9 $2
  did -ar editftpacc 10 $readini($accounts,$2,password)
  did -ar editftpacc 11 $readini($accounts,$2,homedir)
  if ($readini($accounts,$2,writeperms)) {
    did -c editftpacc 8
  }
  if ($readini($accounts,$2,deleteperms)) {
    did -c editftpacc 7
  }
  if ($readini($accounts,$2,mkdirperms)) {
    did -c editftpacc 5
  }
  if ($readini($accounts,$2,adminperms)) {
    did -c editftpacc 16
  }
  if ($readini($accounts,$2,rmdirperms)) {
    did -c editftpacc 17
  }
}

dialog editftpacc {
  title "Edit FTP Account"
  size -1 -1 335 330
  option pixels
  tab "Account", 1, 5 72 323 224
  box "Details", 2, 15 98 303 121, tab 1
  box "Permissions", 13, 15 225 303 54, tab 1
  edit "", 9, 98 121 189 23, tab 1 autohs
  edit "", 10, 98 149 189 23, tab 1 autohs
  edit "", 11, 98 178 158 23, tab 1 autohs
  button "...", 12, 259 180 27 20, tab 1
  text "Username:", 3, 45 126 50 16, tab 1
  text "Password:", 4, 45 155 50 16, tab 1
  check "Write", 8, 87 245 48 20, tab 1
  check "Delete", 7, 143 245 50 20, tab 1
  check "Mk Dir", 5, 200 245 51 20, tab 1
  check "Admin", 16, 29 245 52 20
  text "Home Dir:", 6, 47 185 50 16
  button "OK", 14, 254 301 75 22, ok
  button "Cancel", 15, 176 301 75 22, cancel
  check "Rm Dir", 17, 255 245 51 20
  icon 18, -2 0 338 64, $scriptdir $+ libraries\icons\editftpaccheader.png, noborder
}

on *:dialog:editftpacc:init:0:{
  did -f $dname 10
}

on *:dialog:editftpacc:edit:9:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11)) {
    did -e $dname 14
  }
  else {
    did -b $dname 14
  }
}

on *:dialog:editftpacc:edit:10:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11)) {
    did -e $dname 14
  }
  else {
    did -b $dname 14
  }
}

on *:dialog:editftpacc:edit:11:{
  if ($did($dname,9) && $did($dname,10) && $did($dname,11)) {
    did -e $dname 14
  }
  else {
    did -b $dname 14
  }
}

on *:dialog:editftpacc:sclick:12: {
  did -ar $dname 11 $replace($sdir(C:\,Select Directory),\,/)
  if ($did($dname,9) && $did($dname,10)) {
    did -e $dname 14
  }
}

on *:dialog:editftpacc:sclick:14:{
  writeini $accounts accounts axx $addtok($readini($accounts,accounts,axx),$did($dname,9),44)
  writeini $accounts $did($dname,9) username $did($dname,9)
  writeini $accounts $did($dname,9) password $did($dname,10)
  writeini $accounts $did($dname,9) homedir $did($dname,11)
  writeini $accounts $did($dname,9) writeperms $did($dname,8).state
  writeini $accounts $did($dname,9) deleteperms $did($dname,7).state
  writeini $accounts $did($dname,9) mkdirperms $did($dname,5).state
  writeini $accounts $did($dname,9) adminperms $did($dname,16).state
  writeini $accounts $did($dname,9) rmdirperms $did($dname,17).state
  did -r ftpd 32
  fillaxx
}

;---MORE ALIASES---

alias delftpacc {
  did -d ftpd 32 $1
  writeini $accounts accounts axx $iif($remtok($readini($accounts,accounts,axx),$2,44),$ifmatch,$!null)
  remini $accounts $2
}

alias fillstats {
  did -r ftpd 64
  var %l = 1, %users = $readini($stats,stats,users)
  while (%l <= $numtok(%users,44)) {
    var %name = $gettok(%users,%l,44), %ul = $readini($stats,%name,ul), %dl = $readini($stats,%name,dl) 
    did -a ftpd 64 + 0 0 0 %name $+ $chr(9) $+ + 0 0 0 $bytes(%ul).suf $+ $chr(9) $+ + 0 0 0 $bytes(%dl).suf
    inc %l
  }
  did -ar ftpd 68 $readini($stats,stats,uf)
  did -ar ftpd 69 $readini($stats,stats,df)
  did -ar ftpd 73 $bytes($readini($stats,stats,ul)).suf
  did -ar ftpd 71 $bytes($readini($stats,stats,dl)).suf
}

alias fillaxx {
  var %l = 1, %axx = $readini($accounts,accounts,axx), %acc, %pass, %home, %write, %del, %mkdir, %perms
  did -r ftpd 32
  while (%l <= $numtok(%axx,44)) {
    %perms = r
    %acc = $readini($accounts,$gettok(%axx,%l,44),username) 
    %pass = $readini($accounts,$gettok(%axx,%l,44),password) 
    %home = $readini($accounts,$gettok(%axx,%l,44),homedir) 
    %write = $readini($accounts,$gettok(%axx,%l,44),writeperms) 
    %del = $readini($accounts,$gettok(%axx,%l,44),deleteperms) 
    %mkdir = $readini($accounts,$gettok(%axx,%l,44),mkdirperms)
    %admin = $readini($accounts,$gettok(%axx,%l,44),adminperms)
    %rmdir = $readini($accounts,$gettok(%axx,%l,44),rmdirperms)
    if (%admin) {
      %perms = %perms $+ A
    }
    else {
      %perms = %perms $+ -
    }
    if (%write) {
      %perms = %perms $+ W
    }
    else {
      %perms = %perms $+ -
    }
    if (%del) {
      %perms = %perms $+ D
    }
    else {
      %perms = %perms $+ -
    }
    if (%mkdir) {
      %perms = %perms $+ M
    }
    else {
      %perms = %perms $+ -
    }
    if (%rmdir) {
      %perms = %perms $+ R
    }
    else {
      %perms = %perms $+ -
    }
    did -a ftpd 32 + 0 0 0 %acc $+ $chr(9) $+ + 0 0 0 %pass $+ $chr(9) $+ + 0 0 0 %home $+ $chr(9) $+ + 0 0 0 %perms
    inc %l
  }
}

alias newftpban {
  var %ip = $input(Please enter an IP to ban.,equ,Query...,$null)
  hadd ftpd bans $addtok($hget(ftpd,bans),%ip,44)
  did -r ftpd 44
  fillftpbans
}

alias delftpban {
  did -d ftpd 44 $1
  hadd ftpd bans $remtok($hget(ftpd,bans),$2,44)
}

alias newftpchan {
  var %chan = $input(Please enter a Channel to Serve in...,equ,Query...,$null)
  hadd ftpd channels $addtok($hget(ftpd,channels),%chan,44)
  did -r ftpd 54
  fillftpchans
}

alias delftpchan {
  did -d ftpd 54 $1
  hadd ftpd channels $remtok($hget(ftpd,channels),$2,44)
}

;---POPUPS---

alias ftpnewaccpop {
  popups New ftpnewacc 16 16
  popups SetMetrics ftpnewacc iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem ftpnewacc end + Add $cr newftpacc
  popups AddItem ftpnewacc end + Delete $cr delftpacc $1 $2
  popups AddItem ftpnewacc end
  popups AddItem ftpnewacc end + Edit $cr editftpacc $1 $2
  popups AddItem ftpnewacc end
  popups AddItem ftpnewacc end + Refresh $cr fillaxx
  popup ftpnewacc $mouse.dx $mouse.dy
}

alias ftpbanpop {
  popups New ftpbanpop 16 16
  popups SetMetrics ftpbanpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem ftpbanpop end + Add $cr newftpban
  popups AddItem ftpbanpop end + Delete $cr delftpban $1 $2
  popup ftpbanpop $mouse.dx $mouse.dy
}

alias ftpchanpop {
  popups New ftpchanpop 16 16
  popups SetMetrics ftpchanpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem ftpchanpop end + Add $cr newftpchan
  popups AddItem ftpchanpop end + Delete $cr delftpchan $1 $2
  popup ftpchanpop $mouse.dx $mouse.dy
}

alias ftpstatspop {
  popups New ftpstatspop 16 16
  popups SetMetrics ftpstatspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem ftpstatspop end + Refresh $cr fillstats
  popups AddItem ftpstatspop end + Reset $cr clearftpstats
  popup ftpstatspop $mouse.dx $mouse.dy
}

;---STATS & ACTIVITY---

alias ftpdstats {
  say $s.head($me $+ 's FTP Server Stats) $s.sep $s.head(Sent) $s.encleft $+ $s.value($readini($stats,stats,df)) $+ $s.encright $s.head(files totalling) $s.encleft $+ $s.value($bytes($readini($stats,stats,dl)).suf) $+ $s.encright $s.sep $s.head(Received) $s.encleft $+ $s.value($readini($stats,stats,uf)) $+ $s.encright $s.head(files totalling) $s.encleft $+ $s.value($bytes($readini($stats,stats,ul)).suf) $+ $s.encright
}

alias ftpdactivity {
  var %u = 1
  while (%u <= $ftp(0)) {
    var %ctrl.sock = $usertosock($ftp(%u)), %data.sock = $replace(%ctrl.sock,ctrl,data), %xfer = $false
    if ($sock(%data.sock)) {
      %xfer = $true
      if ($hget(%ctrl.sock,COMM) == STOR) {
        say $s.head(FTPd Upload from User) $s.encleft $+ $s.value($ftp(%u)) $+ $s.encright $s.sep $s.head(File) $s.encleft $+ $s.value($nopath(%file. [ $+ [ %data.sock ] ])) $+ $s.encright $s.sep $s.head(Received) $s.encleft $+ $s.value($bytes($sock(%data.sock).rcvd).suf) $+ $s.encright $s.sep $s.head(Speed) $s.encleft $+ $s.value($bytes($calc($sock(%data.sock).rcvd / $sock(%data.sock).to)).suf $+ /Sec) $+ $s.encright
      }
      else if ($hget(%ctrl.sock,COMM) == RETR) {
        say $s.head(FTPd Download by User) $s.encleft $+ $s.value($ftp(%u)) $+ $s.encright $s.sep $s.head(File) $s.encleft $+ $s.value($hget(ftpd,getfile)) $+ $s.encright $s.sep $s.head(Size) $s.encleft $+ $s.value($bytes($hget(%ctrl.sock,size)).suf) $+ $s.encright $s.sep $s.head(Sent) $s.encleft $+ $s.value($bytes($sock(%data.sock).sent).suf) $+ $s.encright $s.sep $s.head(Speed) $s.encleft $+ $s.value($bytes($calc($sock(%data.sock).sent / $sock(%data.sock).to)).suf $+ /Sec) $+ $s.encright $s.sep $s.head(Complete) $s.encleft $+ $s.value($round($calc($sock(%data.sock).sent / $hget(%ctrl.sock,size) * 100),2) $+ %) $+ $s.encright
      }
    }
    inc %u
  }
  if (!%xfer) {
    say $s.head(No FTPd) $s.encleft $+ $s.value(Uploads) $+ $s.encright $s.head(or) $s.encleft $+ $s.value(Downloads) $+ $s.encright $s.head(in progress.)
  }
}

;---TRIGGER EVENT---

on *:text:*:#:{
  if ($1 == $hget(ftpd,trigger)) {
    if ($istok($hget(ftpd,channels),$chan,44)) {
      if ($hget(ftpd,active)) {
        if ($ftp(0) >= $hget(ftpd,maxusers)) {
          .notice $nick Sorry, $me $+ 's FTP is full. Please try again later.
          return
        }
        else {
          if ($isuser($nick)) {
            .notice $nick You already have an account on this server.
            .notice $nick ftp:// $+ $nick $+ : $+ $checkpass($nick) $+ @ $+ $hget(ftpd,address) $+ : $+ $hget(ftpd,ctrlport)
            return
          }
          else {
            if ($hget(ftpd,autocreate)) {
              adduser $nick
            }
            .notice $nick $s.head(Address) $s.encleft $+ $s.value($hget(ftpd,address)) $+ $s.encright
            .notice $nick $s.head(Port) $s.encleft $+ $s.value($hget(ftpd,ctrlport)) $+ $s.encright
            .notice $nick $s.head(Username) $s.encleft $+ $s.value($nick) $+ $s.encright
            .notice $nick $s.head(Password) $s.encleft $+ $s.value($checkpass($nick)) $+ $s.encright
            .notice $nick $s.head(Slots Used) $s.encleft $+ $s.value($ftp(0) $+ / $+ $hget(ftpd,maxusers)) $+ $s.encright
            .notice $nick $s.head(URL) $s.encleft $+ $s.value(ftp:// $+ $nick $+ : $+ $checkpass($nick) $+ @ $+ $hget(ftpd,address) $+ : $+ $hget(ftpd,ctrlport)) $+ $s.encright
            .notice $nick $s.head(Upload) $s.encleft $+ $s.value($hget(ftpd,uploaduser) $+ / $+ $hget(ftpd,uploadpw)) $+ $s.encright
            .notice $nick $s.head(Sent) $s.encleft $+ $s.value($bytes($readini($stats,stats,dl)).suf) $+ $s.encright $s.head(Received) $s.encleft $+ $s.value($bytes($readini($stats,stats,ul)).suf) $+ $s.encright
            .notice $nick $s.head(Notes) $s.encleft $+ $s.value($hget(ftpd,notes)) $+ $s.encright
            return
          }
        }
      }
      else {
        .notice $nick Sorry, $me $+ 's FTP is down. Please try again later.
        return
      }
    }
  }
}

on *:part:#:{
  if ($hget(ftpd,partkick) == 1) && ($nick != $me) {
    if ($istok($hget(ftpd,channels),$chan,44)) {
      if ($isuser($nick)) {
        if ($usertosock($nick)) {
          var %sock = $usertosock($nick)
          theme.text $s.head(Disconnecting user) $s.encleft $+ $s.value($nick) $+ $s.encright $s.head(for leaving $chan $+ .)
          sockclose $replace(%sock,ctrl,data)
          sockwrite -n %sock 426 Connection Closed for leaving $chan $+ .
          sockclose %sock
          delclient %sock $usertosock(%sock)
          deluser $nick
          hdec ftpd numofconns
          update.switchbar
        }
        else {
          deluser $nick
        }
      }
    }
  }
}

on *:quit:{
  if ($hget(ftpd,partkick) == 1) && ($nick != $me) {
    var %l = 1
    while (%l <= $comchan($nick,0)) {
      if ($istok($hget(ftpd,channels),$comchan($nick,%l),44)) {
        if ($isuser($nick)) {
          if ($usertosock($nick)) {
            var %c = 1
            while (%c <= $ftp(0)) {
              if ($ftp(%c) == $nick) {
                var %sock = $usertosock($nick)
                theme.text $s.head(Disconnecting user) $s.encleft $+ $s.value($nick) $+ $s.encright $s.head(for quitting IRC.)
                sockclose $replace(%sock,ctrl,data)
                sockwrite -n %sock 426 Connection Closed for quitting IRC.
                sockclose %sock
                delclient %sock $usertosock(%sock)
                deluser $nick
                hdec ftpd numofconns
                update.switchbar
              }
              inc %c
            }
          }
        }
      }
      inc %l
    }
  }
}

;---FTPd DIALOGS---

alias ftpdialog {
  var %ctrl.sock = $usertosock($1), %data.sock = $replace(%ctrl.sock,ctrl,data)
  if ($sock(%data.sock)) {
    if ($hget(%ctrl.sock,COMM) == STOR) {
      if (!$dialog(ftpul)) {
        dialog -m ftpul ftpul
        .timerupdatedlg 0 1 updateuldlg $1
      }
    }
    else if ($hget(%ctrl.sock,COMM) == RETR) {
      if (!$dialog(ftpdl)) {
        dialog -m ftpdl ftpdl
        .timerupdatedlg 0 1 updatedldlg $1
      }
    }
  }
  else {
    noop
  }
}

alias updatedldlg {
  var %ctrl.sock = $usertosock($1), %data.sock = $replace(%ctrl.sock,ctrl,data)
  if ($sock(%data.sock).sent < $hget(%ctrl.sock,size)) {
    did -a ftpdl 6 Username: $1
    did -a ftpdl 9 $sock(%data.sock).ip
    did -a ftpdl 11 $sock(%data.sock).port
    did -a ftpdl 12 $hget(ftpd,getfile)
    did -a ftpdl 13 $bytes($hget(%ctrl.sock,size)).suf
    did -a ftpdl 4 $sock(%data.sock).sent 0 $hget(%ctrl.sock,size)
    did -a ftpdl 15 Transferred: $bytes($sock(%data.sock).sent).suf at $round($calc($calc($sock(%data.sock).sent / $sock(%data.sock).to) / 1024),2) $+ KB/Sec
  }
  else {
    did -a ftpdl 6 Username: $1
    did -a ftpdl 9 $null
    did -a ftpdl 11 $null
    did -a ftpdl 12 $null
    did -a ftpdl 13 $null
    did -a ftpdl 5 $null
    did -a ftpdl 7 $null
    did -a ftpdl 8 $null
    did -a ftpdl 10 $null
    did -a ftpdl 4 $sock(%data.sock).sent 0 $hget(%ctrl.sock,size)
    did -a ftpdl 15 File Transfer Complete!
    did -b ftpdl 2
    did -a ftpdl 3 Close
    did -a ftpdl 1 stop
    did -a ftpdl 1 seek 0
    .timerupdatedlg off
    if ($hget(ftpd,autoclose)) {
      dialog -x ftpdl
    }
  }  
}

dialog ftpdl {
  title "FTP Download Transfer..."
  size -1 -1 352 246
  option pixels
  button "", 1, 7 8 260 40
  button "Cancel", 2, 217 219 65 22, Cancel
  button "OK", 3, 284 219 65 22, Ok
  text "ProgressBar", 4, 7 77 336 12
  text "IP:", 5, 7 114 52 16
  text "", 6, 7 58 179 16
  text "FileName:", 7, 8 133 51 16
  text "Size:", 8, 8 154 51 16
  text "", 9, 62 114 94 16
  text "Port:", 10, 162 114 26 16
  text "", 11, 192 114 75 16
  text "", 12, 62 133 282 17
  text "", 13, 62 154 282 16
  text "__________________________________________________________", 14, 1 197 351 16, disable
  text "", 15, 8 94 261 16
  check "Close this dialog when download completes", 16, 7 177 283 20
}

on *:dialog:ftpdl:init:0:{
  mdx SetMircVersion $version
  mdx MarkDialog $dname
  mdx SetControlMDX 1 animation transparent > $ctl
  did -a $dname 1 open $scriptdir $+ libraries\icons\filecopy.avi
  did -a $dname 1 play
  mdx SetControlMDX $dname 4 Progressbar > $ctl
  did -b $dname 4
  if ($hget(ftpd,autoclose)) {
    did -c $dname 16
  }
}

on *:dialog:ftpdl:close:0:{
  .timerupdatedlg off
}

on *:dialog:ftpdl:sclick:2:{
  sockclose $usertosock($gettok($did($dname,6),2,32))
}

on *:dialog:ftpdl:sclick:16:{
  hadd ftpd autoclose $did($dname,16).state
}

dialog ftpul {
  title "FTP Upload Transfer..."
  size -1 -1 274 219
  option pixels
  button "", 1, 7 7 260 40
  button "Cancel", 2, 137 191 65 22, Cancel
  button "OK", 3, 204 191 65 22, Ok
  text "IP:", 5, 7 115 52 16
  text "", 6, 7 56 179 16
  text "FileName:", 7, 8 131 51 16
  text "", 9, 62 115 77 16
  text "Port:", 10, 162 115 26 16
  text "", 11, 192 115 75 16
  text "", 12, 62 131 205 16
  text "__________________________________________________________", 14, 1 169 274 16, disable
  text "", 15, 7 94 261 16
}

on *:dialog:ftpul:init:0:{
  mdx SetMircVersion $version
  mdx MarkDialog $dname
  mdx SetControlMDX 1 animation transparent > $ctl
  did -a $dname 1 open $scriptdir $+ libraries\icons\filecopy.avi
  did -a $dname 1 play
}

on *:dialog:ftpul:close:0:{
  .timerupdatedlg off
}

alias updateuldlg {
  var %ctrl.sock = $usertosock($1), %data.sock = $replace(%ctrl.sock,ctrl,data)
  if ($sock(%data.sock)) {
    did -a ftpul 6 Username: $1
    did -a ftpul 9 $sock(%data.sock).ip
    did -a ftpul 11 $sock(%data.sock).port
    did -a ftpul 12 $nopath(%file. [ $+ [ %data.sock ] ])
    did -a ftpul 15 Transferred: $bytes($sock(%data.sock).rcvd).suf at $round($calc($calc($sock(%data.sock).rcvd / $sock(%data.sock).to) / 1024),2) $+ KB/Sec
  }
  else {
    did -a ftpul 6 Username: $1
    did -a ftpul 9 $null
    did -a ftpul 11 $null
    did -a ftpul 12 $null
    did -a ftpul 5 $null
    did -a ftpul 7 $null
    did -a ftpul 10 $null
    did -a ftpul 15 File Transfer Complete!
    did -b ftpul 2
    did -a ftpul 3 Close
    did -a ftpul 1 stop
    did -a ftpul 1 seek 0
    .timerupdatedlg off
  }  
}

;---MESSAGE SENDING---

alias msguser {
  var %sock = $usertosock($1), %msg = $input(Please enter a message to send to $1 $+ ...,eoq,FTP Message...)
  if (%msg) {
    sockwrite -n %sock 214 %msg
    doftplog < 214 %msg
  }
}

alias msgall {
  var %l = 1
  while (%l <= $ftp(0)) {
    var %sock = $usertosock($ftp(%l)), %msg = $input(Please enter a message to send to all connected clients $+ ...,eoq,FTP Message...)
    if (%msg) {
      sockwrite -n %sock 214 %msg
    }
    inc %l
  }
  if (%msg) {
    doftplog < 214 %msg
  }
}

alias ftpchat {
  var %l = 1, %msg = $1-
  while (%l <= $ftp(0)) {
    var %sock = $usertosock($ftp(%l))
    if (%msg) {
      sockwrite -n %sock 214 %msg
    }
    inc %l
  }
  doftplog < 214 %msg
}

;---USER FUNCTIONS---

alias kickuser {
  var %sock = $usertosock($1), %msg = $input(Please enter a kick message to send to $1 $+ ...,eoq,FTP Kick Message...)
  if (%msg) {
    sockwrite -n %sock 214 %msg
  }
  sockclose $replace(%sock,ctrl,data)
  sockclose %sock
  update.switchbar  
}

alias banuser {
  var %sock = $usertosock($1), %ip = $sock(%sock).ip
  hadd ftpd bans $addtok($hget(ftpd,bans),%ip,32)
  var %response = 214 You have been banned from this server!
  doftplog < %response
  sockwrite -n %sock %response
  sockclose $replace(%sock,ctrl,data)
  sockclose %sock
  update.switchbar
}

alias showlog {
  ftpd
  did -f ftpd 62
}
