;---Custom Nicklist by mr.man 2007--

;---VARIOUS ALIASES---

alias nicklist {
  dialog -m colours colours
}

alias -l inifile {
  return $+(",$scriptdir,settings\colours.ini,")
}

alias -l loadsettings {
  var %h = colours
  if ($hget(%h)) { hfree %h }
  hmake %h 10
  hload -i %h $inifile Settings
}

alias -l savesettings {
  hsave -i colours $inifile Settings
}

alias wballoon {
  mtooltips SetTooltipWidth 1000
  mtooltips SpawnTooltip +bsar $mouse.dx $mouse.dy 3000 > Whois $1 $+ : $chr(4) $chr(160) $+ Address: %w.ident $+ @ $+ %w.address $crlf Channels: %w.channels $crlf Server: %w.server $iif(%w.modes,$crlf Modes: %w.modes,$null) $iif(%w.host,$crlf Hostname: %w.host,$null) $iif(%w.ip,$crlf IP: %w.ip,$null)
}

;---DIALOG STUFF---

dialog colours {
  title "Nicklist Setup"
  size -1 -1 288 441
  option pixels
  tab "Settings", 1, 4 75 277 332
  text "Admin (&&):", 6, 42 214 57 16, tab 1 right
  text "Owner (~):", 4, 42 185 57 16, tab 1 right
  text "Operator (@):", 8, 23 242 75 16, tab 1 right
  text "Halfop (%):", 10, 36 270 63 16, tab 1 right
  text "Voice (+):", 12, 36 298 63 16, tab 1 right
  text "Regular:", 14, 36 327 63 16, tab 1 right
  text "Self:", 16, 37 355 63 16, tab 1 right
  box "Nick Colours", 34, 13 155 135 237, tab 1
  icon 11, 103 348 24 24,  $mircexe, 0, tab 1
  icon 13, 103 320 24 24,  $mircexe, 0, tab 1
  icon 15, 103 292 24 24,  $mircexe, 0, tab 1
  icon 9, 103 264 24 24,  $mircexe, 0, tab 1
  icon 7, 103 236 24 24,  $mircexe, 0, tab 1
  icon 5, 103 208 24 24,  $mircexe, 0, tab 1
  icon 3, 103 180 24 24,  $mircexe, 0, tab 1
  box "Font", 38, 13 101 257 50, tab 1
  box "Heading Colours", 33, 157 155 113 237, tab 1
  text "Regular:", 17, 177 340 45 16, tab 1 right
  icon 23, 226 333 24 24,  $mircexe, 0, tab 1
  icon 25, 226 305 24 24,  $mircexe, 0, tab 1
  icon 27, 226 277 24 24,  $mircexe, 0, tab 1
  icon 29, 226 249 24 24,  $mircexe, 0, tab 1
  icon 31, 226 221 24 24,  $mircexe, 0, tab 1
  icon 36, 226 193 24 24,  $mircexe, 0, tab 1
  text "Owner:", 32, 183 198 39 16, tab 1 right
  text "Admin:", 30, 183 227 39 16, tab 1 right
  text "Halfop:", 26, 177 283 45 16, tab 1 right
  text "Voice:", 24, 177 311 45 16, tab 1 right
  text "Operator:", 28, 165 255 57 16, tab 1 right
  edit "", 19, 30 117 189 23, tab 1 read autohs
  button "...", 35, 224 118 26 22, tab 1
  button "OK", 2, 226 412 56 22, ok
  button "Apply", 18, 167 412 56 22, disable
  check "Custom Nicklist Active", 20, 7 413 138 20
  icon 21, -2 0 291 64, $scriptdir $+ libraries\icons\nicklistheader.png, noborder
}

on *:dialog:colours:init:0:{
  var %p = $hget(colours,owner) $+ .bmp
  did -g colours 3 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(colours,admin) $+ .bmp
  did -g colours 5 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(colours,op) $+ .bmp
  did -g colours 7 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(colours,help) $+ .bmp
  did -g colours 9 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(colours,voice) $+ .bmp
  did -g colours 15 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(colours,reg) $+ .bmp
  did -g colours 13 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(colours,self) $+ .bmp
  did -g colours 11 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(colours,howner) $+ .bmp
  did -g colours 36 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(colours,hadmin) $+ .bmp
  did -g colours 31 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(colours,hop) $+ .bmp
  did -g colours 29 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(colours,hhelp) $+ .bmp
  did -g colours 27 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(colours,hvoice) $+ .bmp
  did -g colours 25 $+(",$scriptdir,libraries\icons\,%p,")
  var %p = $hget(colours,hreg) $+ .bmp
  did -g colours 23 $+(",$scriptdir,libraries\icons\,%p,")
  if ($hget(various,nicklist)) {
    did -c $dname 20
  }
  else {
    did -u $dname 20
  }
  did -ar $dname 19 $hget(various,nlfont)
}

on *:dialog:colours:sclick:2:{
  savesettings
  dialog -v cpanel
}

on *:dialog:colours:sclick:18:{
  savesettings
  if (!$hget(various,nicklist)) {
    var %l = $cnick(0)
    while (%l) {
      .cnick -r 1
      dec %l
    }
    .cnick -an $!me $hget(colours,self)
    .cnick * $hget(colours,owner) ~
    .cnick * $hget(colours,owner) .
    .cnick * $hget(colours,admin) &
    .cnick * $hget(colours,admin) !
    .cnick * $hget(colours,op) @
    .cnick * $hget(colours,help) %
    .cnick * $hget(colours,voice) +
    .cnick -n * $hget(colours,reg)
  }
  if ($did($dname,20).state == 1) {
    .enable #nicklist
    hadd various nicklist $true
    hopall
    did -b $dname 18
    halt
  }
  else if ($did($dname,20).state == 0) {
    .disable #nicklist
    hadd various nicklist $false
    closenicklists
    hopall
    did -b $dname 18
    halt
  }  
  if ($hget(various,nicklist)) {
    coldialog
    applycolours
    applyfont
    if ($dialog(coldlg)) {
      dialog -x coldlg
    }
  }
}

on *:dialog:colours:sclick:3:{
  var %p = colours
  hadd various ColSet %p $+ ,owner
  colpick
  did -e $dname 18
}

on *:dialog:colours:sclick:5:{
  var %p = colours
  hadd various ColSet %p $+ ,admin
  colpick
  did -e $dname 18
}

on *:dialog:colours:sclick:7:{
  var %p = colours
  hadd various ColSet %p $+ ,op
  colpick
  did -e $dname 18
}

on *:dialog:colours:sclick:9:{
  var %p = colours
  hadd various ColSet %p $+ ,help
  colpick
  did -e $dname 18
}

on *:dialog:colours:sclick:15:{
  var %p = colours
  hadd various ColSet %p $+ ,voice
  colpick
  did -e $dname 18
}

on *:dialog:colours:sclick:13:{
  var %p = colours
  hadd various ColSet %p $+ ,reg
  colpick
  did -e $dname 18
}

on *:dialog:colours:sclick:11:{
  var %p = colours
  hadd various ColSet %p $+ ,self
  colpick
  did -e $dname 18
}

on *:dialog:colours:sclick:20:{
  hadd various nicklist $did($dname,20).state
  did -e $dname 18
}

on *:dialog:colours:sclick:36:{
  var %p = colours
  hadd various ColSet %p $+ ,howner
  colpick
  did -e $dname 18
}

on *:dialog:colours:sclick:31:{
  var %p = colours
  hadd various ColSet %p $+ ,hadmin
  colpick
  did -e $dname 18
}

on *:dialog:colours:sclick:29:{
  var %p = colours
  hadd various ColSet %p $+ ,hop
  colpick
  did -e $dname 18
}

on *:dialog:colours:sclick:27:{
  var %p = colours
  hadd various ColSet %p $+ ,hhelp
  colpick
  did -e $dname 18
}

on *:dialog:colours:sclick:25:{
  var %p = colours
  hadd various ColSet %p $+ ,hvoice
  colpick
  did -e $dname 18
}

on *:dialog:colours:sclick:23:{
  var %p = colours
  hadd various ColSet %p $+ ,hreg
  colpick
  did -e $dname 18
}

on *:dialog:colours:sclick:35:{
  var %font = $gettok($dcx(FontDialog,ansi),4-,32)
  if (%font) {
    did -ar $dname 19 %font
    hadd various nlfont %font
  }
  did -e $dname 18
}

;---EVENTS STUFF---

on *:start:{
  if ($exists($inifile)) {
    loadsettings
  }
  if ($hget(various,nicklist)) {
    .enable #nicklist
  }
  else {
    .disable #nicklist
  }
}

on *:disconnect:{
  var %c = 1
  while (%c <= $chan(0)) {
    var %dlg = $+(nicklist,.,$activecid,.,$chan(%c))
    if ($dialog(%dlg)) {
      dialog -x %dlg
    }
    inc %c
  }
}

#nicklist off

on *:nick:{
  var %c = $comchan($newnick,0)
  while (%c) {
    var %chan = $comchan($newnick,%c)
    var %dlg = $+(nicklist.,$cid,.,%chan)
    var %nick = $iif(\ isin $nick,$replace($nick,\,*),$nick)
    var %i = $xdid(%dlg,1,$chr(9) %nick $chr(9),W,1).find
    if (%i) {
      xdid -v %dlg 1 %i $chr(9) $newnick
      sortnicks %dlg
    }
    dec %c
  }
}

on *:rawmode:#:{
  var %l = 1, %dlg = $+(nicklist.,$cid,.,$chan), %modes = $remove($1,+,-),
  if (!%joined) {
    while (%l <= $mode(0)) {
      if ($mid(%modes,%l,1) != b) && ($mid(%modes,%l,1) != I) && ($mid(%modes,%l,1) != e) {
        setheadings %dlg $chan
        sortheadings %dlg $chan
        movenick %dlg $chan $mode(%l)
        numbers %dlg $chan
      }
      inc %l
    }
  }
}

on *:active:#:{
  var %dlg = $+(nicklist.,$cid,.,$chan)
  .timer 1 0 xdialog -l %dlg update
}

on *:quit:{
  var %c = $comchan($nick,0)
  while (%c) {
    var %chan = $comchan($nick,%c)
    var %dlg = $+(nicklist.,$cid,.,%chan)
    var %i = $xdid(%dlg,1,$chr(9) $nick $chr(9),W,1).find
    if (%i) {
      xdid -d %dlg 1 %i
    }
    dec %c
    .timer 1 0 onquit %dlg %chan
  }
}

alias onquit {
  numbers $1 $2
  setheadings $1 $2
  xdialog -l $1 update
}

on *:part:#:{
  var %dlg = $+(nicklist.,$cid,.,$chan)
  if ($nick == $me) {
    if ($dialog(%dlg)) {
      dialog -x %dlg
      return
    }
  }
  var %nick = $iif(\ isin $nick,$replace($nick,\,*),$nick)
  var %i = $xdid(%dlg,1,$chr(9) %nick $chr(9),W,1).find
  if (%i) {
    xdid -d %dlg 1 %i
  }
  .timer 1 0 onpart %dlg $chan
}

alias onpart {
  numbers $1 $2
  setheadings $1 $2
  xdialog -l $1 update
}  

on *:kick:#:{
  var %dlg = $+(nicklist.,$cid,.,$chan)
  var %i = $xdid(%dlg,1,$chr(9) $knick $chr(9),W,1).find
  if (%i) {
    xdid -d %dlg 1 %i
  }
  .timer 1 0 numbers %dlg $chan
  .timer 1 0 setheadings %dlg $chan
  .timer 1 0 xdialog -l %dlg update
}

on *:join:#:{
  var %dlg = $+(nicklist.,$cid,.,$chan)
  if ($nick == $me) {
    popdialog
    if ($dialog(%dlg)) {
      dialog -x %dlg
    }
    set -u1 %joined $true
    dialog -m %dlg nicklist_template
  }
  else {
    var %i = $xdid(%dlg,1,$chr(9) Regulars: $+ * $chr(9),W,1).find
    if (!%i) {
      xdid -a %dlg 1 $tab(-1,+ebc 0 0 1 0 0 $color($hget(colours,hreg)) 0 Regulars: $regulars($chan,0))
    }
    xdid -a %dlg 1 $tab(-1 -1,+ec 0 0 2 0 0 $color($hget(colours,reg)) 0 $nick)
    sortnicks %dlg
    numbers %dlg $chan
    setheadings %dlg $chan
    .timer 1 0 xdialog -l %dlg update
  }
}

alias sortheadings {
  var %i = $xdid($1,1,$chr(9) Owners: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) 1Owners:
  }
  var %i = $xdid($1,1,$chr(9) Admins: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) 2Admins:
  }
  var %i = $xdid($1,1,$chr(9) Operators: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) 3Operators:
  }
  var %i = $xdid($1,1,$chr(9) HalfOps: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) 4HalfOps:
  }
  var %i = $xdid($1,1,$chr(9) Voices: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) 5Voices:
  }
  var %i = $xdid($1,1,$chr(9) Regulars: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) 6Regulars:
  }
  xdid -z $1 1 +tab root $chr(9)
  var %i = $xdid($1,1,$chr(9) 1Owners: $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) Owners: $owners($2,0)
  }
  var %i = $xdid($1,1,$chr(9) 2Admins: $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) Admins: $admins($2,0)
  }
  var %i = $xdid($1,1,$chr(9) 3Operators: $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) Operators: $operators($2,0)
  }
  var %i = $xdid($1,1,$chr(9) 4HalfOps: $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) HalfOps: $halfops($2,0)
  }
  var %i = $xdid($1,1,$chr(9) 5Voices: $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) Voices: $voices($2,0)
  }
  var %i = $xdid($1,1,$chr(9) 6Regulars: $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) Regulars: $regulars($2,0)
  }
}

alias movenick {
  var %p = $left($nick($2,$3).pnick,1)
  if (%p isin .~) {
    var %i = $xdid($1,1,$chr(9) $3 $chr(9),W,1).find
    var %j = $xdid($1,1,$chr(9) Owners: $+ * $chr(9),W,1).find
    if (%i) {
      xdid -d $1 1 %i
    }
    xdid -a $1 1 $tab(%j -1,+ec 0 0 2 0 0 $color($hget(colours,owner)) 0 $3)
  }
  else if (%p isin !&) {
    var %i = $xdid($1,1,$chr(9) $3 $chr(9),W,1).find
    var %j = $xdid($1,1,$chr(9) Admins: $+ * $chr(9),W,1).find
    if (%i) {
      xdid -d $1 1 %i
    }
    xdid -a $1 1 $tab(%j -1,+ec 0 0 2 0 0 $color($hget(colours,admin)) 0 $3)
  }
  else if (%p == @) {
    var %i = $xdid($1,1,$chr(9) $3 $chr(9),W,1).find
    var %j = $xdid($1,1,$chr(9) Operators: $+ * $chr(9),W,1).find
    if (%i) {
      xdid -d $1 1 %i
    }
    xdid -a $1 1 $tab(%j -1,+ec 0 0 2 0 0 $color($hget(colours,op)) 0 $3)
  }
  else if (%p == %) {
    var %i = $xdid($1,1,$chr(9) $3 $chr(9),W,1).find
    var %j = $xdid($1,1,$chr(9) HalfOps: $+ * $chr(9),W,1).find
    if (%i) {
      xdid -d $1 1 %i
    }
    xdid -a $1 1 $tab(%j -1,+ec 0 0 2 0 0 $color($hget(colours,help)) 0 $3)
  }
  else if (%p == +) {
    var %i = $xdid($1,1,$chr(9) $3 $chr(9),W,1).find
    var %j = $xdid($1,1,$chr(9) Voices: $+ * $chr(9),W,1).find
    if (%i) {
      xdid -d $1 1 %i
    }
    xdid -a $1 1 $tab(%j -1,+ec 0 0 2 0 0 $color($hget(colours,voice)) 0 $3)
  }
  else {
    var %i = $xdid($1,1,$chr(9) $3 $chr(9),W,1).find
    var %j = $xdid($1,1,$chr(9) Regulars: $+ * $chr(9),W,1).find
    if (%i) {
      xdid -d $1 1 %i
    }
    xdid -a $1 1 $tab(%j -1,+ec 0 0 2 0 0 $color($hget(colours,reg)) 0 $3)
  }
  var %i = $xdid($1,1,$chr(9) $me $chr(9),W,1).find
  if (%i) {
    xdid -Q $1 1 +c $color($hget(colours,self)) %i
  }
  sortnicks $1
}

alias colournicks {
  noop
}

alias sortnicks {
  var %i = $xdid($1,1,$chr(9) Owners: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -z $1 1 +tar %i
  }
  var %i = $xdid($1,1,$chr(9) Admins: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -z $1 1 +tar %i
  }
  var %i = $xdid($1,1,$chr(9) Operators: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -z $1 1 +tar %i
  }
  var %i = $xdid($1,1,$chr(9) HalfOps: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -z $1 1 +tar %i
  }
  var %i = $xdid($1,1,$chr(9) Voices: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -z $1 1 +tar %i
  }
  var %i = $xdid($1,1,$chr(9) Regulars: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -z $1 1 +tar %i
  }
}

dialog nicklist_template {
  title ""
  size -50 -50 40 40
  option pixels
}

on *:dialog:nicklist.*:init:0:{
  dcx Mark $dname nicklist_cb
  xdialog -c $dname 1 treeview 0 0 138 500 haslines nohscroll notooltips
  xdialog -b $dname +s
  xdialog -l $dname root $chr(9) +p 0 0 0 0
  xdialog -l $dname cell root $chr(9) +li 1 10 0 0
  xdid -i $dname 1 +b $color($color(back))
  xdid -i $dname 1 +l $color($hget(various,tvlines))
  xdid -i $dname 1 +t $color($hget(various,tvtext))
  xdid -f $dname 1 +a ansi $hget(various,nlfont)
  var %cid = $gettok($dname,2,46)
  var %chan = $gettok($dname,3-,46)
  .timer 1 0 nicklist_init $dname %cid %chan
}

alias nicklist_init {
  dll $+(",$scriptdir,libraries\nicklist.dll,") clear $chan($3).hwnd
  xdock -n $dialog($1).hwnd +s $chan($3).hwnd
  xdialog -l $1 update
  populate $1 $2 $3
}

alias nicklist_cb {
  var %chan = $gettok($1,3,46)
  if ($2 == rclick) {
    nicklist_popup $xdid($1,1).seltext %chan
    return
  }
  else if ($2 == sclick) {
    set -u3 %silent $true
    set %w.nick $xdid($1,1).seltext
    whois %w.nick
  }
  else if ($2 == dclick) {
    var %s = $xdid($1,1).seltext
    if (Owners: * !iswm %s) && (Admins: * !iswm %s) && (Operators: * !iswm %s) && (Halfops: * !iswm %s) && (Voices: * !iswm %s) && (Regulars: * !iswm %s) {
      query %s
    }
  }
}

raw 311:*:{
  set %w.ident $3
  set %w.address $4
  halt
}

raw 319:*:{
  set %w.channels $3-
  halt
}

raw 312:*:{
  set %w.server $3
  halt
}

raw 379:*:{
  set %w.modes $6
  halt
}

raw 378:*:{
  set %w.host $6
  set %w.ip $7
  halt
}

raw 301:*:{
  halt
}

raw 307:*:{
  halt
}

raw 313:*:{
  halt
}

raw 317:*:{
  halt
}

raw 318:*:{
  if (%silent) {
    wballoon %w.nick
  }
  unset %w.*
  halt
}

alias populate {
  var %e = 1
  scid $2
  if ($owners($3,0) > 0) {
    xdid -a $1 1 $tab(-1,+ebc 0 0 1 0 0 $color($hget(colours,howner)) 0 Owners: $v1)
    var %l = 1
    while (%l <= $owners($3,0)) {
      whilefix
      xdid -a $1 1 $tab(%e -1,+ec 0 0 2 0 0 $color($hget(colours,owner)) 0 $owners($3,%l))
      inc %l
    }
    inc %e
  }
  if ($admins($3,0) > 0) {
    xdid -a $1 1 $tab(-1,+ebc 0 0 1 0 0 $color($hget(colours,hadmin)) 0 Admins: $v1)
    var %l = 1
    while (%l <= $admins($3,0)) {
      whilefix
      xdid -a $1 1 $tab(%e -1,+ec 0 0 2 0 0 $color($hget(colours,admin)) 0 $admins($3,%l))
      inc %l
    }
    inc %e
  }
  if ($operators($3,0) > 0) {
    xdid -a $1 1 $tab(-1,+ebc 0 0 1 0 0 $color($hget(colours,hop)) 0 Operators: $v1)
    var %l = 1
    while (%l <= $operators($3,0)) {
      whilefix
      xdid -a $1 1 $tab(%e -1,+ec 0 0 2 0 0 $color($hget(colours,op)) 0 $operators($3,%l))
      inc %l
    }
    inc %e
  }
  if ($halfops($3,0) > 0) {
    xdid -a $1 1 $tab(-1,+ebc 0 0 1 0 0 $color($hget(colours,hhelp)) 0 HalfOps: $v1)
    var %l = 1
    while (%l <= $halfops($3,0)) {
      whilefix
      xdid -a $1 1 $tab(%e -1,+ec 0 0 2 0 0 $color($hget(colours,help)) 0 $halfops($3,%l))
      inc %l
    }
    inc %e
  }
  if ($voices($3,0) > 0) {
    xdid -a $1 1 $tab(-1,+ebc 0 0 1 0 0 $color($hget(colours,hvoice)) 0 Voices: $v1)
    var %l = 1
    while (%l <= $voices($3,0)) {
      whilefix
      xdid -a $1 1 $tab(%e -1,+ec 0 0 2 0 0 $color($hget(colours,voice)) 0 $voices($3,%l))
      inc %l
    }
    inc %e
  }
  if ($regulars($3,0) > 0) {
    xdid -a $1 1 $tab(-1,+ebc 0 0 1 0 0 $color($hget(colours,hreg)) 0 Regulars: $v1)
    var %l = 1
    while (%l <= $regulars($3,0)) {
      whilefix
      xdid -a $1 1 $tab(%e -1,+ec 0 0 2 0 0 $color($hget(colours,reg)) 0 $regulars($3,%l))
      inc %l
    }
  }
  var %i = $xdid($1,1,$chr(9) $me $chr(9),W,1).find
  if (%i) {
    xdid -Q $1 1 +c $color($hget(colours,self)) %i
  }
  if ($dialog(popdlg)) {
    dialog -x popdlg
  }
}

alias owners {
  var %numof = 0, %owners = $null, %l = 1
  while (%l <= $nick($1,0,a)) {
    if ($left($nick($1,%l,a).pnick,1) isin .~) {
      inc %numof
      %owners = $addtok(%owners,$nick($1,%l,a),32)
    }
    inc %l
  }
  if ($2 == 0) {
    return %numof
  }
  else {
    return $gettok(%owners,$2,32)
  }
}

alias admins {
  var %numof = 0, %admins = $null, %l = 1
  while (%l <= $nick($1,0,a)) {
    if ($left($nick($1,%l,a).pnick,1) isin &!) {
      inc %numof
      %admins = $addtok(%admins,$nick($1,%l,a),32)
    }
    inc %l
  }
  if ($2 == 0) {
    return %numof
  }
  else {
    return $gettok(%admins,$2,32)
  }
}

alias operators {
  var %numof = 0, %operators = $null, %l = 1
  while (%l <= $nick($1,0,o)) {
    if ($left($nick($1,%l,o).pnick,1) == @) {
      inc %numof
      %operators = $addtok(%operators,$nick($1,%l,o),32)
    }
    inc %l
  }
  if ($2 == 0) {
    return %numof
  }
  else {
    return $gettok(%operators,$2,32)
  }
}

alias halfops {
  return $nick($1,$2,h,or)
}

alias voices {
  return $nick($1,$2,v,ohr)
}

alias regulars {
  return $nick($1,$2,r,ohv)
}

alias numbers {
  var %i = $xdid($1,1,$chr(9) Owners: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) Owners: $owners($2,0)
  }
  var %i = $xdid($1,1,$chr(9) Admins: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) Admins: $admins($2,0)
  }
  var %i = $xdid($1,1,$chr(9) Operators: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) Operators: $operators($2,0)
  }
  var %i = $xdid($1,1,$chr(9) Halfops: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) Halfops: $halfops($2,0)
  }
  var %i = $xdid($1,1,$chr(9) Voices: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) Voices: $voices($2,0)
  }
  var %i = $xdid($1,1,$chr(9) Regulars: $+ * $chr(9),W,1).find
  if (%i) {
    xdid -v $1 1 %i $chr(9) Regulars: $regulars($2,0)
  }
}

alias setheadings {
  var %i = $xdid($1,1,$chr(9) Owners: $+ * $chr(9),W,1).find
  if ($owners($2,0) > 0) {
    if (!%i) {
      xdid -a $1 1 $tab(-1,+ebc 0 0 1 0 0 $color($hget(colours,howner)) 0 Owners: $owners($2,0))
    }
  }
  else {
    if (%i) {
      xdid -d $1 1 %i
    }
  }
  var %i = $xdid($1,1,$chr(9) Admins: $+ * $chr(9),W,1).find
  if ($admins($2,0) > 0) {
    if (!%i) {
      xdid -a $1 1 $tab(-1,+ebc 0 0 1 0 0 $color($hget(colours,hadmin)) 0 Admins: $admins($2,0))
    }
  }
  else {
    if (%i) {
      xdid -d $1 1 %i
    }
  }
  var %i = $xdid($1,1,$chr(9) Operators: $+ * $chr(9),W,1).find
  if ($operators($2,0) > 0) {
    if (!%i) {
      xdid -a $1 1 $tab(-1,+ebc 0 0 1 0 0 $color($hget(colours,hop)) 0 Operators: $operators($2,0))
    }
  }
  else {
    if (%i) {
      xdid -d $1 1 %i
    }
  }
  var %i = $xdid($1,1,$chr(9) HalfOps: $+ * $chr(9),W,1).find
  if ($halfops($2,0) > 0) {
    if (!%i) {
      xdid -a $1 1 $tab(-1,+ebc 0 0 1 0 0 $color($hget(colours,hhelp)) 0 HalfOps: $halfops($2,0))
    }
  }
  else {
    if (%i) {
      xdid -d $1 1 %i
    }
  }
  var %i = $xdid($1,1,$chr(9) Voices: $+ * $chr(9),W,1).find
  if ($voices($2,0) > 0) {
    if (!%i) {
      xdid -a $1 1 $tab(-1,+ebc 0 0 1 0 0 $color($hget(colours,hvoice)) 0 Voices: $voices($2,0))
    }
  }
  else {
    if (%i) {
      xdid -d $1 1 %i
    }
  }
  var %i = $xdid($1,1,$chr(9) Regulars: $+ * $chr(9),W,1).find
  if ($regulars($2,0) > 0) {
    if (!%i) {
      xdid -a $1 1 $tab(-1,+ebc 0 0 1 0 0 $color($hget(colours,hreg)) 0 Regulars: $regulars($2,0))
    }
  }
  else {
    if (%i) {
      xdid -d $1 1 %i
    }
  }
}

on *:tabcomp:*:{
  set %e $editbox($active)
  var %p = $numtok(%e,32), %w = $gettok(%e,%p,32), %nt.loop = 0
  set %nt.matches 0
  if (%w == $chr(35)) {
    %e = $deltok(%e,%p,32)
    editbox -a %e $active
    unset %nt.* %e
    halt
  }
  while (%nt.loop <= $nick($active,0)) {
    inc %nt.loop 1
    if (%w isin $nick($chan,%nt.loop)) {
      inc %nt.matches
      set %nt.match. $+ %nt.matches $nick($active,%nt.loop)
    }
  }
  if (%nt.matches == 0) {
    unset %nt.*
    halt
  }
  else if (%nt.matches == 1) {
    var %t = %nt.match.1, %n = $numtok(%e,32)
    %e = $deltok(%e,%n,32)
    editbox -a %e %t
    unset %nt.* %e
    halt
  }
  else {
    dialog -m ntab ntab
    halt
  }
}

dialog ntab {
  title "Select Nick..."
  size -1 -1 200 154
  option pixels
  list 1, 10 10 180 110
  button "Cancel", 2, 65 117 60 26, cancel
  button "Okay", 3, 130 117 60 26, ok
}

on *:dialog:ntab:init:0: {
  var %loop = 1
  inc %nt.matches
  while (%loop < %nt.matches) {
    var %temp = $chr(37) $+ nt.match. $+ %loop
    did -a $dname 1 [ [ %temp ] ] 
    inc %loop
  }
  did -c $dname 1 1
}

on *:dialog:ntab:sclick:2: {
  unset %nt.* %e
}

on *:dialog:ntab:sclick:3: {
  var %t = $did($dname,1).seltext, %n = $numtok(%e,32)
  %e = $deltok(%e,%n,32)
  editbox -a %e %t
  unset %nt.* %e
}

#nicklist end

alias hopall {
  var %c = 1
  while (%c <= $scon(0)) {
    scon %c
    var %i = 1
    while (%i <= $chan(0)) {
      !.hop -c $chan(%i)
      inc %i
    }
    inc %c
  }
}

alias popdialog {
  if (!$dialog(popdlg)) {
    dialog -mo popdlg popdlg
  }
}

dialog popdlg {
  title "Please Wait..."
  size -1 -1 180 20
  option pixels
  text "Populating Nicklist... Please Wait.", 1, 11 17 164 16
}

on *:dialog:popdlg:init:0:{
  dcx Mark $dname popdlg_cb
  xdialog -b $dname +s
}

alias popdlg_cb {
  noop
}

alias listchans {
  var %l = 1, %chans = $null
  while (%l <= 100) {
    if ($scid(%l)) {
      scid %l
      var %c = 1
      while (%c <= $chan(0)) {
        %chans = %chans $+(nicklist,.,%l,.,$chan(%c))
        inc %c
      }
    }
    inc %l
  }
  return %chans
}

alias coldialog {
  if (!$dialog(coldlg)) {
    dialog -mo coldlg coldlg
  }
}

dialog coldlg {
  title "Please Wait..."
  size -1 -1 180 20
  option pixels
  text "Colouring Nicklists... Please Wait.", 1, 11 17 164 16
}

on *:dialog:coldlg:init:0:{
  dcx Mark $dname coldlg_cb
  xdialog -b $dname +s
}

alias coldlg_cb {
  noop
}

alias applycolours {
  var %ch = $listchans, %l = $numtok(%ch,32), %c = 1
  while (%c <= %l) {
    whilefix
    var %cid = $gettok($gettok(%ch,%c,32),2,46), %chan = $gettok($gettok(%ch,%c,32),3,46), %dlg = $gettok(%ch,%c,32)
    scid %cid
    var %n = 1
    while (%n <= $nick(%chan,0)) {
      whilefix
      var %prefix = $left($nick(%chan,%n).pnick,1), %nick = $nick(%chan,%n)
      var %i = $xdid(%dlg,1,$chr(9) %nick $chr(9),W,1).find
      if (%i) {
        if (%prefix isin .~) {
          xdid -Q %dlg 1 +c $color($hget(colours,owner)) %i
        }
        else if (%prefix isin !&) {
          xdid -Q %dlg 1 +c $color($hget(colours,admin)) %i
        }
        else if (%prefix == @) {
          xdid -Q %dlg 1 +c $color($hget(colours,op)) %i
        }
        else if (%prefix == %) {
          xdid -Q %dlg 1 +c $color($hget(colours,help)) %i
        }
        else if (%prefix == +) {
          xdid -Q %dlg 1 +c $color($hget(colours,voice)) %i
        }
        else {
          xdid -Q %dlg 1 +c $color($hget(colours,reg)) %i
        }
      }
      inc %n
    }
    var %i = $xdid(%dlg,1,$chr(9) $me $chr(9),W,1).find
    if (%i) {
      xdid -Q %dlg 1 +c $color($hget(colours,self)) %i
    }
    var %i = $xdid(%dlg,1,$chr(9) Owners: $+ * $chr(9),W,1).find
    if (%i) {
      xdid -Q %dlg 1 +bc $color($hget(colours,howner)) %i
    }
    var %i = $xdid(%dlg,1,$chr(9) Admins: $+ * $chr(9),W,1).find
    if (%i) {
      xdid -Q %dlg 1 +bc $color($hget(colours,hadmin)) %i
    }
    var %i = $xdid(%dlg,1,$chr(9) Operators: $+ * $chr(9),W,1).find
    if (%i) {
      xdid -Q %dlg 1 +bc $color($hget(colours,hop)) %i
    }
    var %i = $xdid(%dlg,1,$chr(9) Halfops: $+ * $chr(9),W,1).find
    if (%i) {
      xdid -Q %dlg 1 +bc $color($hget(colours,hhelp)) %i
    }
    var %i = $xdid(%dlg,1,$chr(9) Voices: $+ * $chr(9),W,1).find
    if (%i) {
      xdid -Q %dlg 1 +bc $color($hget(colours,hvoice)) %i
    }
    var %i = $xdid(%dlg,1,$chr(9) Regulars: $+ * $chr(9),W,1).find
    if (%i) {
      xdid -Q %dlg 1 +bc $color($hget(colours,hreg)) %i
    }
    inc %c
  }
  dialog -x coldlg
}

alias applyfont {
  var %ch = $listchans, %l = $numtok(%ch,32), %c = 1
  while (%c <= %l) {
    whilefix
    var %cid = $gettok($gettok(%ch,%c,32),2,46), %chan = $gettok($gettok(%ch,%c,32),3,46), %dlg = $gettok(%ch,%c,32)
    scid %cid
    xdid -f %dlg 1 +a ansi $hget(various,nlfont)
    xdid -i %dlg 1 +l $color($hget(various,tvlines))
    inc %c
  }
  if ($dialog(coldlg)) {
    dialog -x coldlg
  }
}

alias closenicklists {
  var %ch = $listchans, %l = $numtok(%ch,32), %c = 1
  while (%c <= %l) {
    whilefix
    var %cid = $gettok($gettok(%ch,%c,32),2,46), %chan = $gettok($gettok(%ch,%c,32),3,46), %dlg = $gettok(%ch,%c,32)
    scid %cid
    dialog -x %dlg
    inc %c
  }  
}

alias nicklist_popup {
  nlist clear $chan($active).hwnd
  nlist addnick $chan($active).hwnd $1
  sline -l $active 1
  nlist popup $2
}

;---MENUS---

menu nicklist {
  CTCP
  .Ping:ctcp $1 PING
  .Version:ctcp $1 VERSION
  .Finger:ctcp $1 FINGER
  .Time:ctcp $1 TIME
  UWho:.uwho $1
  Whois:whois $1
  DNS:dns $1
  DCC
  .Send:dcc send $1
  .Chat:dcc chat $1
  .DCCAllow:dccallow + $+ $1
  P/M:pm $1 $$?="Enter Message..."
  Query:query $1
  Modes
  .mode +q:mode $active +q $1
  .mode -q:mode $active -q $1
  .mode +a:mode $active +a $1
  .mode -a:mode $active -a $1
  .mode +o:mode $active +o $1
  .mode -o:mode $active -o $1
  .mode +h:mode $active +h $1
  .mode -h:mode $active -h $1
  .mode +v:mode $active +v $1
  .mode -v:mode $active -v $1
  .kick user:k $1 $?="Enter Kick Message..."
  .ban user:b $1 $?="Enter Ban Length..."
  .k+b user:{
    b $1 $?="Enter Ban Length..."
    k $1 $?="Enter Kick Message..."
  }
  .random kick:k $1 $read($scriptdir $+ kicks.dat)
}
