;---Protections System by mr.man (c) 2004 (Part of NeXtGenIRC)

;---VARIOUS ALIASES---

alias protection {
  dialog -m prot prot
}

alias -l protini {
  return $+(",$scriptdir,settings\prot.ini,")
}

alias -l antispamini {
  return $+(",$scriptdir,settings\antispam.ini,")
}

alias -l savesettings {
  if (!%restart) {
    hsave -i prot $protini Settings
    hsave -i antispam $antispamini Settings
  }
}

alias -l loadsettings {
  var %t = prot
  if ($hget(%t)) { hfree %t }
  hmake %t 10
  hload -i %t $protini Settings
  var %t = antispam
  if ($hget(%t)) { hfree %t }
  hmake %t 10
  hload -i %t $antispamini Settings
}

alias -l setdefsettings {
  var %t = antispam
  if ($hget(%t)) { hfree %t }
  hmake %t 10
  hadd %t Active 1
  hadd %t Onjoin 5
  hadd %t Ignore 60
  hadd %t Filter *sex*www*,*webcam*
}

;---DIALOG STUFF---

dialog prot {
  title "Protection"
  size -1 -1 327 366
  option pixels
  tab "Personal", 1, 4 73 317 260
  box "CTCP", 7, 16 155 294 51, tab 1
  box "DCC/Msg/Query", 15, 16 99 294 51, tab 1
  text "On", 16, 38 176 20 16, tab 1
  edit "", 17, 61 172 35 23, tab 1
  text "in", 18, 98 176 16 16, tab 1 center
  edit "", 19, 119 172 35 23, tab 1
  text "Ignore for", 20, 159 177 54 16, tab 1
  edit "", 21, 217 172 35 23, tab 1
  check "", 22, 265 173 20 20, tab 1
  box "Notice", 23, 16 210 294 51, tab 1
  text "On", 24, 39 231 20 16, tab 1
  edit "", 25, 62 227 35 23, tab 1
  text "in", 26, 99 231 16 16, tab 1 center
  edit "", 27, 120 227 35 23, tab 1
  text "Ignore for", 28, 160 232 54 16, tab 1
  edit "", 29, 218 227 35 23, tab 1
  check "", 30, 266 228 20 20, tab 1
  box "Invite", 31, 16 265 294 51, tab 1
  text "On", 32, 38 286 20 16, tab 1
  edit "", 33, 61 282 35 23, tab 1
  text "in", 34, 98 286 16 16, tab 1 center
  edit "", 35, 119 282 35 23, tab 1
  text "Ignore for", 36, 159 287 54 16, tab 1
  edit "", 37, 217 282 35 23, tab 1
  check "", 38, 265 283 20 20, tab 1
  text "On", 14, 38 120 20 16, tab 1
  edit "", 8, 61 116 35 23, tab 1
  text "in", 9, 98 120 16 16, tab 1 center
  edit "", 10, 119 116 35 23, tab 1
  text "Ignore for", 11, 159 121 54 16, tab 1
  edit "", 12, 217 116 35 23, tab 1
  check "", 13, 265 117 20 20, tab 1
  tab "Channel", 5
  box "Channels to Protect", 64, 13 99 153 133, tab 5
  list 65, 23 117 131 103, tab 5 size
  box "Actions", 68, 174 99 136 162, tab 5
  check "Join/Part", 69, 189 118 73 20, tab 5
  check "CAPS", 72, 189 184 73 20, tab 5
  check "Flooding", 71, 189 162 73 20, tab 5
  check "Swearing", 70, 189 139 73 20, tab 5
  check "Adverts", 74, 189 226 73 20, tab 5
  check "Colours", 75, 189 205 73 20, tab 5
  button "...", 76, 266 118 28 19, tab 5
  box "Consequences", 83, 13 236 153 82, tab 5
  check "Kick Offender", 84, 23 257 100 20, tab 5
  check "Ban for", 85, 23 282 55 20, tab 5
  edit "", 86, 79 279 42 23, tab 5
  text "Secs", 87, 125 285 29 16, tab 5
  button "...", 80, 266 228 28 19, tab 5
  button "...", 81, 266 206 28 19, tab 5
  button "...", 79, 266 184 28 19, tab 5
  button "...", 78, 266 162 28 19, tab 5
  button "...", 77, 266 140 28 19, tab 5
  check "Enable Channel Protection", 40, 5 338 151 20, tab 5
  box "Exempt Modes", 41, 174 264 136 54, tab 5
  edit "", 49, 185 282 84 23, tab 5
  button "...", 50, 270 285 28 19, tab 5
  tab "Bans", 6
  box "Ban Type", 43, 13 99 297 51, tab 6
  combo 44, 71 117 183 146, tab 6 size drop
  box "Ban Protection", 45, 13 151 297 169, tab 6
  check "When Banned, Automatically Unban if Op", 46, 53 171 219 20, tab 6
  check "Take Revenge on User who Banned You", 47, 53 192 225 20, tab 6
  list 48, 53 216 215 91, tab 6 size
  tab "Kicks", 2
  box "Kick Messages", 4, 16 99 294 216, tab 2
  list 42, 26 117 273 186, tab 2 size
  tab "Anti Spam", 39
  box "Join/Part Settings", 52, 16 99 295 85, tab 39
  check "Enable Anti Spam System", 53, 5 338 141 20, tab 39
  text "Ignore on Join for", 54, 62 125 88 16, tab 39
  edit "", 55, 151 120 46 23, tab 39
  text "seconds", 56, 199 125 50 16, tab 39
  box "Filter Words", 60, 16 188 143 129, tab 39
  text "Ignore on Part for", 57, 62 151 88 16, tab 39
  edit "", 58, 151 146 46 23, tab 39
  text "seconds", 59, 199 151 50 16, tab 39
  list 61, 27 207 119 97, tab 39 size
  box "Exempt Users", 63, 168 188 143 129, tab 39
  list 62, 179 207 119 97, tab 39 size
  button "OK", 3, 247 338 75 22, ok
  icon 51, -2 0 330 64, $scriptdir $+ libraries\icons\protheader.png, noborder
}

on *:dialog:prot:init:0:{
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 42 listview single sortascending rowselect showsel report noheader > $views
  did -i $dname 42 1 headerdims 250:1
  did -i $dname 42 1 headertext 0 Kick Messages
  mdx SetControlMDX 48 listview single sortascending rowselect showsel report noheader > $views
  did -i $dname 48 1 headerdims 185:1
  did -i $dname 48 1 headertext 0 Channels
  mdx SetControlMDX 61 listview single sortascending rowselect showsel report noheader > $views
  did -i $dname 61 1 headerdims 95:1
  did -i $dname 61 1 headertext 0 Filter Words
  mdx SetControlMDX 62 listview single sortascending rowselect showsel report noheader > $views
  did -i $dname 62 1 headerdims 95:1
  did -i $dname 62 1 headertext 0 Exempt Users
  mdx SetControlMDX 65 listview single sortascending rowselect showsel report noheader > $views
  did -i $dname 65 1 headerdims 105:1
  did -i $dname 65 1 headertext 0 Channels
  var %m = *!user@host *!*user@host *!*@host *!*user@*.host *!*@*.host nick!user@host nick!*user@host nick!*@host nick!*user@*.host nick!*@*.host
  didtok prot 44 32 %m
  did -c $dname 44 $hget(prot,bantype)
  var %i = 1
  var %k = $+(",$scriptdir,settings\kicks.dat,")
  while (%i <= $lines(%k)) {
    did -a $dname 42 $read(%k,%i)
    inc %i
  }
  did -ra $dname 8 $hget(prot,msglimit)
  did -ra $dname 10 $hget(prot,msgsecs)
  did -ra $dname 12 $hget(prot,msgign)
  if ($hget(prot,msg) == 1) { did -c $dname 13 }
  else { did -u $dname 13 }
  did -ra $dname 17 $hget(prot,ctcplimit)
  did -ra $dname 19 $hget(prot,ctcpsecs)
  did -ra $dname 21 $hget(prot,ctcpign)
  if ($hget(prot,ctcp) == 1) { did -c $dname 22 }
  else { did -u $dname 22 }
  did -ra $dname 25 $hget(prot,noticelimit)
  did -ra $dname 27 $hget(prot,noticesecs)
  did -ra $dname 29 $hget(prot,noticeign)
  if ($hget(prot,notice) == 1) { did -c $dname 30 }
  else { did -u $dname 30 }
  did -ra $dname 33 $hget(prot,invitelimit)
  did -ra $dname 35 $hget(prot,invitesecs)
  did -ra $dname 37 $hget(prot,inviteign)
  if ($hget(prot,invite) == 1) { did -c $dname 38 }
  else { did -u $dname 38 }
  if ($hget(prot,unban) == 1) { did -c $dname 46 }
  else { did -u $dname 46 }
  if ($hget(prot,revenge) == 1) { did -c $dname 47 }
  else { did -u $dname 47 }
  didtok -ra $dname 48 32 $hget(prot,bpchans)
  if ($hget(antispam,active)) { did -c $dname 53 }
  else { did -u $dname 53 }
  did -ra $dname 55 $hget(antispam,onjoin)
  did -ra $dname 58 $hget(antispam,ignore)
  didtok $dname 61 96 $hget(antispam,filter)
  didtok $dname 62 32 $hget(antispam,exempt)
  if ($hget(prot,chanprot) ) {
    did -c $dname 40
  }
  didtok $dname 65 32 $hget(prot,protchans)
  if ($hget(prot,jpprotect)) {
    did -c $dname 69
  }
  if ($hget(prot,coloursprotect)) {
    did -c $dname 75
  }
  if ($hget(prot,floodprotect)) {
    did -c $dname 71
  }
  if ($hget(prot,swearprotect)) {
    did -c $dname 70
  }
  if ($hget(prot,capsprotect)) {
    did -c $dname 72
  }
  if ($hget(prot,advertprotect)) {
    did -c $dname 74
  }
  if ($hget(prot,kickoffender)) {
    did -c $dname 84
  }
  if ($hget(prot,banoffender)) {
    did -c $dname 85
  }
  did -ar $dname 49 $hget(prot,exmodes)
  did -ar $dname 86 $hget(prot,bansecs)
}

on *:dialog:prot:sclick:3:{
  hadd prot msg $did(prot,13).state
  hadd prot msglimit $did(prot,8)
  hadd prot msgsecs $did(prot,10)
  hadd prot msgign $did(prot,12)
  hadd prot ctcp $did(prot,22).state
  hadd prot ctcplimit $did(prot,17)
  hadd prot ctcpsecs $did(prot,19)
  hadd prot ctcpign $did(prot,21)
  hadd prot notice $did(prot,30).state
  hadd prot noticelimit $did(prot,25)
  hadd prot noticesecs $did(prot,27)
  hadd prot noticeign $did(prot,29)
  hadd prot invite $did(prot,38).state
  hadd prot invitelimit $did(prot,33)
  hadd prot invitesecs $did(prot,35)
  hadd prot inviteign $did(prot,37)
  hadd prot bantype $did(prot,44).sel
  hadd prot unban $did(prot,46).state
  hadd prot revenge $did(prot,47).state
  hadd prot bansecs $did(prot,86)
  hadd antispam onjoin $did(prot,55)
  hadd antispam ignore $did(prot,58)
  dialog -v cpanel
}

on *:dialog:prot:sclick:40:{
  hadd prot chanprot $did($dname,40).state
}

on *:dialog:prot:sclick:41:{
  var %f = $+(",$scriptdir,kicks.dat,")
  did -d prot 42 $did(prot,42).sel
  write -c %f
  var %i = 1
  while (%i <= $did(prot,42).lines) {
    write %f $did(prot,42,%i).text
    inc %i
  }
}

on *:dialog:prot:sclick:42:{
  if ($gettok($did($dname,42,1),1,32) == rclick) {
    kickmsgspop $did(42).sel $gettok($gettok($did(42).seltext,6,32),1,9)
  }
}

on *:dialog:prot:sclick:48:{
  if ($gettok($did($dname,48,1),1,32) == rclick) {
    bpchanspop $did(48).sel $gettok($gettok($did(48).seltext,6,32),1,9)
  }
}

on *:dialog:prot:sclick:65:{
  if ($gettok($did($dname,65,1),1,32) == rclick) {
    chanprotpop $did(65).sel $gettok($gettok($did(65).seltext,6,32),1,9)
  }
}

on *:dialog:prot:sclick:61:{
  if ($gettok($did($dname,61,1),1,32) == rclick) {
    filterwordspop $did(61).sel $gettok($gettok($did(61).seltext,6,32),1,9)
  }
}

on *:dialog:prot:sclick:62:{
  if ($gettok($did($dname,62,1),1,32) == rclick) {
    exemptuserspop $did(62).sel $gettok($gettok($did(62).seltext,6,32),1,9)
  }
}

on *:dialog:prot:sclick:49: {
  var %c = $input(Please enter a new Channel name.,equ,Query...,$null)
  if (%c) {
    if ($left(%c,1) != $chr(35)) {
      %c = $chr(35) $+ %c
    }
    hadd prot bpchans $addtok($hget(prot,BPChans),%c,32)
    didtok -ra prot 48 32 $hget(prot,BPChans)
  }
}

on *:dialog:prot:sclick:50: {
  exmodes
}

on *:dialog:prot:sclick:62: {
  var %c = $input(Please Enter a word or phrase to Filter.,equ,Query...,$null)
  did -a $dname 61 %c
  hadd antispam Filter $didtok($dname,61,44)
}

on *:dialog:prot:sclick:63: {
  did -d $dname 61 $did($dname,61).sel
  hadd antispam Filter $didtok($dname,11,44)
}

on *:dialog:prot:sclick:71:{
  hadd prot floodprotect $did($dname,71).state
}

on *:dialog:prot:sclick:78: {
  floodprot
}

on *:dialog:prot:sclick:72:{
  hadd prot capsprotect $did($dname,72).state
}

on *:dialog:prot:sclick:79: {
  capsprot
}

on *:dialog:prot:sclick:69:{
  hadd prot jpprotect $did($dname,69).state
}

on *:dialog:prot:sclick:76: {
  jpprot
}

on *:dialog:prot:sclick:70:{
  hadd prot swearprotect $did($dname,70).state
}

on *:dialog:prot:sclick:77: {
  swearprot
}

on *:dialog:prot:sclick:75:{
  hadd prot coloursprotect $did($dname,75).state
}

on *:dialog:prot:sclick:81: {
  coloursprot
}

on *:dialog:prot:sclick:74:{
  hadd prot advertprotect $did($dname,74).state
}

on *:dialog:prot:sclick:80: {
  advertprot
}

on *:dialog:prot:sclick:84:{
  hadd prot kickoffender $did($dname,84).state
}

on *:dialog:prot:sclick:85:{
  hadd prot banoffender $did($dname,85).state
}

;---EVENTS STUFF---

on *:start:{
  loadsettings
}

on *:exit:{
  savesettings
}

on *:join:#:{
  if ($hget(antispam,Active)) {
    .ignore -pntiu $+ $hget(antispam,Onjoin) $nick
    set -u10 % $+ [ [ as.b. $+ [ [ $+($network,$chan,$nick) ] ] ] ] 1
    if ($hget(prot,chanprot)) {
      set -u $+ $hget(prot,jpsecs) % $+ [ [ prot. $+ [ [ $+($network,$chan,$nick) ] ] ] ] 1
    }
  }
}

on *:part:#:{
  if ($hget(antispam,Active)) {
    var %match = % $+ as.b. $+ [ [ $+($network,$chan,$nick) ] ]
    if ($(%match,2) == 1) {
      .ignore -pcntiu $+ $hget(antispam,Ignore) $nick
      theme.text $chan $s.head(Possible Spammer - Ignoring) $s.encleft $+ $s.value($nick) $+ $s.encright $s.head(for) $s.encleft $+ $s.value($hget(antispam,Ignore)) $+ $s.encright $s.head(Seconds.)
    }
    if ($hget(prot,chanprot) && ($me isop $chan)) {
      if ($hget(prot,jpprotect)) {
        var %user = % $+ prot. $+ [ [ $+($network,$chan,$nick) ] ]
        if ($(%user,2) == 1) {
          if ($hget(prot,banoffender)) {
            ban -u $+ $hget(prot,bansecs) $chan $nick $hget(prot,bantype)
          }
          if ($hget(prot,kickoffender)) {
            kick $chan $nick $hget(prot,jpkickmsg) [Kick $chr(35) $+ $hget(various,kicks) $+ ]
            hinc various kicks
          }
        }
      }        
    }
  }
}

on *:text:*:#:{
  if ($me !isop $chan) {
    halt
  }
  var %m = $left($nick($chan,$nick).pnick,1), %mode
  if (%m == ~) {
    %mode = q
  }
  if (%m == &) {
    %mode = a
  }
  if (%m == @) {
    %mode = o
  }
  if (%m == %) {
    %mode = h
  }
  if (%m == +) {
    %mode = v
  }
  if (%mode isin $hget(prot,exmodes)) {
    halt
  }
  if ($hget(prot,chanprot)) {
    inc -u [ $+ [ $hget(prot,secs) ] ] %flood [ $+ [ $nick ] ] 1
    if (%flood [ $+ [ $nick ] ] > $hget(prot,lines)) {
      if ($hget(prot,floodprotect)) {
        if ($istok($hget(prot,protchans),$chan,32)) {
          if ($hget(prot,banoffender)) {
            ban -u $+ $hget(prot,bansecs) $chan $nick $hget(prot,bantype)
          }
          if ($hget(prot,kickoffender)) {
            kick $chan $nick $hget(prot,floodkickmsg) [Kick $chr(35) $+ $hget(various,kicks) $+ ]
            hinc various kicks
          } 
        }
      }
      unset %flood [ $+ [ $nick ] ]
    }
    if ($hget(prot,capsprotect)) {
      if ($istok($hget(prot,protchans),$chan,32)) {
        if ($upper($1-) === $1-) {
          if ($0 > $hget(prot,capswords)) {
            if ($hget(prot,banoffender)) {
              ban -u $+ $hget(prot,bansecs) $chan $nick $hget(prot,bantype)
            }
            if ($hget(prot,kickoffender)) {
              kick $chan $nick $hget(prot,capskickmsg) [Kick $chr(35) $+ $hget(various,kicks) $+ ]
              hinc various kicks
            } 
          }
        }
      }
    }
    if ($hget(prot,swearprotect)) {
      if ($istok($hget(prot,protchans),$chan,32)) {
        var %l = 1
        while (%l <= $0) {
          if ($($ $+ %l,2) isin $hget(prot,swearwords)) {
            if ($hget(prot,banoffender)) {
              ban -u $+ $hget(prot,bansecs) $chan $nick $hget(prot,bantype)
            }
            if ($hget(prot,kickoffender)) {
              kick $chan $nick $hget(prot,swearkickmsg) [Kick $chr(35) $+ $hget(various,kicks) $+ ]
              hinc various kicks
            }
          }
          inc %l
        }
      }
    }           
    if ($hget(prot,coloursprotect)) {
      if ($istok($hget(prot,protchans),$chan,32)) {
        if ($strip($1-) !=== $1-) {
          if ($hget(prot,banoffender)) {
            ban -u $+ $hget(prot,bansecs) $chan $nick $hget(prot,bantype)
          }
          if ($hget(prot,kickoffender)) {
            kick $chan $nick $hget(prot,colourskickmsg) [Kick $chr(35) $+ $hget(various,kicks) $+ ]
            hinc various kicks
          }
        }
      }
    }
    if ($hget(prot,advertprotect)) {
      if ($istok($hget(prot,protchans),$chan,32)) {
        if ($isad($1-)) {
          if ($hget(prot,banoffender)) {
            ban -u $+ $hget(prot,bansecs) $chan $nick $hget(prot,bantype)
          }
          if ($hget(prot,kickoffender)) {
            kick $chan $nick $hget(prot,advertkickmsg) [Kick $chr(35) $+ $hget(various,kicks) $+ ]
            hinc various kicks
          }
        }  
      }
    }
  }
}

on *:text:*:?:{
  if ($hget(antispam,Active)) {
    if (!$istok($hget(antispam,exempt),$nick,32)) {
      var %loop = 1
      while (%loop <= $numtok($hget(antispam,Filter),44)) {
        if ($gettok($hget(antispam,Filter),%loop,44) iswm $1-) {
          close -m $nick
          theme.text $s.head(Blocked Spam from) $s.encleft $+ $s.value($nick) $+ $s.encright $s.sep $s.head(Ignoring for) $s.encleft $+ $s.value($hget(antispam,Ignore)) $+ $s.encright $s.head(Seconds.)
          write $+(",$scriptdir,settings\antispam.log,") $nick $+ : $1-
          .ignore -pcntiu $+ $hget(antispam,Ignore) $nick
        }
        inc %loop
      }
    }
  }
}

ctcp *:*:?:{
  if ($hget(prot,CTCP) == 1) {
    hinc $+(-u,$hget(prot,CTCPSecs)) prot CTCPTime
    if ($hget(prot,CTCPTime) >= $hget(prot,CTCPLimit)) {
      .ignore $+(-tu,$hget(prot,CTCPIgn)) *!*@*
      theme.text $s.head(CTCP Flood detected. Ignoring) $s.encleft $+ $s.value($nick) $+ $s.encright $s.head(and all CTCP Requests for) $s.encleft $+ $s.value($hget(prot,CTCPIgn)) $+ $s.encright $s.head(Seconds.)
    }
  }
}

on *:open:?:{
  if ($hget(prot,Msg) == 1) {
    hinc $+(-u,$hget(prot,MsgSecs)) prot MsgTime
    if ($hget(prot,MsgTime) >= $hget(prot,MsgLimit)) {
      .ignore $+(-pu,$hget(prot,MsgIgn)) *!*@*
      theme.text $s.head(Msg/DCC/Query Flood detected. Ignoring) $s.encleft $+ $s.value($nick) $+ $s.encright $s.head(and all Msg/DCC/Queries for) $s.encleft $+ $s.value($hget(prot,MsgIgn)) $+ $s.encright $s.head(Seconds.)
    }
  }
}

on *:notice:*:?: {
  if ($hget(prot,Notice) == 1) {
    if (ChanServ !isin $nick) && (NickServ !isin $nick) && (MemoServ !isin $nick) && (Global !isin $nick) {
      hinc $+(-u,$hget(prot,NoticeSecs)) prot NoticeTime
      if ($hget(prot,NoticeTime) >= $hget(prot,NoticeLimit)) {
        .ignore $+(-nu,$hget(prot,NoticeIgn)) *!*@*
        theme.text $s.head(Notice Flood detected. Ignoring) $s.encleft $+ $s.value($nick) $+ $s.encright $s.head(and all Notices for) $s.encleft $+ $s.value($hget(prot,NoticeIgn)) $+ $s.encright $s.head(Seconds.)
      }
    }
  }
}

on *:notice:*:#: {
  if ($hget(prot,Notice) == 1) {
    if ($nick !isop #) && ($nick !isvo #) && (ChanServ !isin $nick) && (NickServ !isin $nick) && (MemoServ !isin $nick) && (Global !isin $nick) {
      hinc $+(-u,$hget(prot,NoticeSecs)) prot CNoticeTime
      if ($hget(prot,CNoticeTime) >= $hget(prot,NoticeLimit)) {
        .ignore $+(-nu,$hget(prot,NoticeIgn)) *!*@*
        theme.text $s.head(Notice Flood detected. Ignoring) $s.encleft $+ $s.value($nick) $+ $s.encright $s.head(and all Notices for) $s.encleft $+ $s.value($hget(prot,NoticeIgn)) $+ $s.encright $s.head(Seconds.)
      }
    }
  }
}

on *:invite:#:{
  if (ChanServ !isin $nick) && (NickServ !isin $nick) && (MemoServ !isin $nick) {
    hinc $+(-u,$hget(prot,InviteSecs)) prot InviteTime
    if ($hget(prot,InviteTime) >= $hget(prot,InviteLimit)) {
      .ignore $+(-iu,$hget(prot,InviteIgn)) *!*@*
      theme.text $s.head(Invite Flood detected. Ignoring) $s.encleft $+ $s.value($nick) $+ $s.encright $s.head(and all Invites for) $s.encleft $+ $s.value($hget(prot,InviteIgn)) $+ $s.encright $s.head(Seconds.)
    }
  }
}

on *:ban:#:{
  hadd prot latestban $banmask
  var %l = 0, %ban = $false
  if (($me isop $chan) && ($hget(prot,Unban)) && ($istok($hget(prot,bpchans),$chan,32))) {
    while (%l <= 9) {
      if ($banmask iswm $address($me,%l)) {
        %ban = $true
      }
      inc %l
    }
    if (%ban) {
      chanserv unban $chan $me
      .timer 3 1 { j $chan }
      theme.text $s.head(You have been Unbanned from) $s.encleft $+ $s.value($chan) $+ $s.encright
      if ($hget(prot,Revenge) && ($nick != $me)) {
        kickban $nick $chan Bye Bye! [Kick $chr(35) $+ $hget(various,kicks) $+ ]
      }
    }
  }
}

alias isad {
  if (FTP isin $1-) && (Online isin $1-) { return $true }
  else if (FTP isin $1-) && (Address isin $1-) { return $true }
  else if (F:T:P isin $1-) && (Online isin $1-) { return $true }
  else if (F-T-P isin $1-) && (Online isin $1-) { return $true }
  else if (File Server isin $1-) && (Online isin $1-) { return $true }
  else if (TDCC isin $1-) && (Online isin $1-) { return $true }
  else if (Online isin $1-) && (Sends isin $1-) && (Queues isin $1-) { return $true }
  else if (IP isin $1-) && (Port isin $1-) && (Login isin $1-) && (Password isin $1-) { return $true }
  else { return $false }
}

alias unban {
  if ($hget(prot,latestban)) {
    ban -r $ifmatch
  }
}

alias kickban {
  ban $2 $1 $hget(prot,BanType)
  hinc various bans
  kick $chan $1 $3-
  hinc various kicks
}

;---POPUPS---

alias bpchanspop {
  popups New bpchanspop 16 16
  popups SetMetrics bpchanspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem bpchanspop end + Add $cr addbpchan
  popups AddItem bpchanspop end + Delete $cr delbpchan $1 $2
  popup bpchanspop $mouse.dx $mouse.dy
}

alias addbpchan {
  var %c = $input(Please enter a new channel to protect you in.,equ,Query...,$null)
  if (%c) {
    hadd prot bpchans $addtok($hget(prot,bpchans),%c,32)
    did -a prot 48 + 0 0 0 %c
    savesettings
  }
}

alias delbpchan {
  did -d prot 48 $1
  hadd prot bpchans $remtok($hget(prot,bpchans),$2,32)
  savesettings
}

alias exemptuserspop {
  popups New exemptuserspop 16 16
  popups SetMetrics exemptuserspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem exemptuserspop end + Add $cr addexemptuser
  popups AddItem exemptuserspop end + Delete $cr delexemptuser $1 $2
  popup exemptuserspop $mouse.dx $mouse.dy
}

alias addexemptuser {
  var %n = $input(Please enter a new nickname to add to the exempt list.,equ,Query...,$null)
  if (%n) {
    hadd antispam exempt $addtok($hget(antispam,exempt),%n,32)
    did -a prot 62 + 0 0 0 %n
    savesettings
  }
}

alias delexemptuser {
  did -d prot 62 $1
  hadd antispam exempt $remtok($hget(antispam,exempt),$2,32)
  savesettings
}

alias filterwordspop {
  popups New filterwordspop 16 16
  popups SetMetrics filterwordspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem filterwordspop end + Add $cr addfilterword
  popups AddItem filterwordspop end + Delete $cr delfilterword $1 $2
  popup filterwordspop $mouse.dx $mouse.dy
}

alias addfilterword {
  var %w = $input(Please enter a new word/phrase to filter.,equ,Query...,$null)
  if (%w) {
    hadd antispam filter $addtok($hget(antispam,filter),%w,96)
    did -a prot 61 + 0 0 0 %w
    savesettings
  }
}

alias delfilterword {
  did -d prot 61 $1
  hadd antispam filter $remtok($hget(antispam,filter),$2,96)
  savesettings
}

alias kickmsgspop {
  popups New kickmsgspop 16 16
  popups SetMetrics kickmsgspop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem kickmsgspop end + Add $cr addkickmsg
  popups AddItem kickmsgspop end + Delete $cr delkickmsg $1 $2
  popup kickmsgspop $mouse.dx $mouse.dy
}

alias addkickmsg {
  var %k = $input(Please enter a new kick message.,equ,Query...,$null)
  var %m = $+(",$scriptdir,settings\kicks.dat,")
  if (%k) {
    write %m %k
    did -r prot 42
    var %i = 1
    while (%i <= $lines(%m)) {
      did -a prot 42 $read(%m,%i)
      inc %i
    }
  }
}

alias delkickmsg {
  var %m = $+(",$scriptdir,settings\kicks.dat,")
  write -d $+ $calc($1 - 1) %m
  did -r prot 42
  var %i = 1
  while (%i <= $lines(%m)) {
    did -a prot 42 $read(%m,%i)
    inc %i
  }
}

alias chanprotpop {
  popups New chanprotpop 16 16
  popups SetMetrics chanprotpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem chanprotpop end + Add $cr addchanprot
  popups AddItem chanprotpop end + Delete $cr delchanprot $1 $2
  popup chanprotpop $mouse.dx $mouse.dy
}

alias addchanprot {
  var %chan = $input(Please Enter a Channel to Protect.,equ,Query...,$null)
  if (%chan) {
    hadd prot protchans $addtok($hget(prot,protchans),%chan,32)
    savesettings
    did -a prot 65 + 0 0 0 %chan
  }
}

alias delchanprot {
  did -d prot 65 $1
  hadd prot protchans $remtok($hget(prot,protchans),$2,32)
  savesettings
}

;---MORE DIALOGS---

alias floodprot {
  dialog -m floodprot floodprot
}

dialog floodprot {
  title "Channel Flood Protection Settings..."
  size -1 -1 379 254
  option pixels
  tab "Settings", 1, 5 73 367 148
  box "Flood Settings", 2, 14 99 349 108, tab 1
  text "Trigger Flood Protection:", 3, 30 131 124 16, tab 1
  edit "", 4, 155 127 48 23, tab 1 center
  edit "", 6, 253 127 48 23, tab 1 center
  text "lines in", 5, 208 131 41 16, tab 1 center
  text "seconds", 7, 305 131 41 16, tab 1 center
  text "Kick Message:", 8, 30 163 69 16
  edit "", 9, 102 159 245 23, autohs
  button "Ok", 10, 298 226 75 22, ok
  icon 11, -2 0 382 64, $scriptdir $+ libraries\icons\floodprotheader.png, noborder
}

on *:dialog:floodprot:init:0: {
  did -ar $dname 4 $hget(prot,lines)
  did -ar $dname 6 $hget(prot,secs)
  did -ar $dname 9 $hget(prot,floodkickmsg)
}

on *:dialog:floodprot:sclick:10: {
  hadd prot lines $did($dname,4)
  hadd prot secs $did($dname,6)
  hadd prot floodkickmsg $did($dname,9)
}

alias capsprot {
  dialog -m capsprot capsprot
}

dialog capsprot {
  title "Channel CAPS Protection Settings..."
  size -1 -1 353 254
  option pixels
  tab "Settings", 1, 5 73 341 148
  box "CAPS Settings", 2, 14 101 323 105, tab 1
  text "Trigger CAPS Protection when more than ", 3, 30 131 201 16, tab 1
  edit "", 6, 233 127 48 23, tab 1 center
  text "words", 7, 285 131 32 16, tab 1 center
  text "Kick Message:", 8, 30 163 69 16
  edit "", 9, 102 159 219 23, autohs
  button "Ok", 10, 272 226 75 22, ok
  icon 4, -2 0 356 64, $scriptdir $+ libraries\icons\capsprotheader.png, noborder
}

on *:dialog:capsprot:init:0: {
  did -ar $dname 6 $hget(prot,capswords)
  did -ar $dname 9 $hget(prot,capskickmsg)
}

on *:dialog:capsprot:sclick:10: {
  hadd prot capswords $did($dname,6)
  hadd prot capskickmsg $did($dname,9)
}

alias jpprot {
  dialog -m jpprot jpprot
}

dialog jpprot {
  title "Channel Join/Part Protection Settings..."
  size -1 -1 352 242
  option pixels
  tab "Settings", 1, 5 73 341 136
  box "Join/Part Settings", 2, 14 99 323 95, tab 1
  text "Trigger Protection when Join/Part is within", 3, 26 125 205 16, tab 1
  edit "", 6, 233 121 44 23, tab 1 center
  text "seconds", 7, 279 125 46 16, tab 1 center
  button "Ok", 10, 272 214 75 22, ok
  text "Kick Message:", 4, 26 156 71 16
  edit "", 5, 99 152 225 23, autohs
  icon 8, -2 0 355 64, $scriptdir $+ libraries\icons\jpprotheader.png, noborder
}

on *:dialog:jpprot:init:0: {
  did -ar $dname 5 $hget(prot,jpkickmsg)
  did -ar $dname 6 $hget(prot,jpsecs)
}

on *:dialog:jpprot:sclick:10: {
  hadd prot jpkickmsg $did($dname,5)
  hadd prot jpsecs $did($dname,6)
}

alias swearprot {
  dialog -m swearprot swearprot
}

dialog swearprot {
  title "Channel Swearing Protection Settings..."
  size -1 -1 309 303
  option pixels
  tab "Settings", 1, 5 74 296 195
  box "Swearing Settings", 2, 14 100 278 154, tab 1
  list 3, 26 117 254 88, tab 1 size
  text "Kick Message:", 4, 26 220 71 16
  edit "", 5, 99 216 181 23
  button "Ok", 8, 227 274 75 22, ok
  icon 6, -2 0 312 64, $scriptdir $+ libraries\icons\swearprotheader.png, noborder
}

on *:dialog:swearprot:init:0: {
  mdx MarkDialog $dname
  mdx SetMircVersion $version
  mdx SetControlMDX 3 listview single rowselect showsel alignleft report > $views
  did -i $dname 3 1 headerdims 230:1
  did -i $dname 3 1 headertext 0 Swear Words
  didtok $dname 3 32 $hget(prot,swearwords)
  did -ar $dname 5 $hget(prot,swearkickmsg)
}

on *:dialog:swearprot:sclick:3: {
  if ($gettok($did($dname,3,1),1,32) == rclick) {
    swearpop $did(3).sel $gettok($gettok($did(3).seltext,6,32),1,9)
  }
}

on *:dialog:swearprot:sclick:8: {
  hadd prot swearkickmsg $did($dname,5)
}

alias swearpop {
  popups New swearpop 16 16
  popups SetMetrics swearpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem swearpop end + Add $cr newswear
  popups AddItem swearpop end + Delete $cr delswear $1 $2
  popup swearpop $mouse.dx $mouse.dy
}

alias newswear {
  var %p = $input(Please enter a Swear Word.,equ,Query...,$null)
  did -a swearprot 3 %p
  getswearwords
}

alias delswear {
  var %t = $did(swearprot,3).sel
  if (%t) {
    did -d swearprot 3 %t
    getswearwords
  }
}

alias getswearwords {
  var %lines = $did(swearprot,3).lines, %l = 2, %swear, %swears
  while (%l <= %lines) {
    %swear = $gettok($gettok($did(swearprot,3,%l),1,9),6-,32)
    if (%swear) {
      %swears = %swears %swear
    }
    inc %l
  }
  hadd prot swearwords %swears
}

alias coloursprot {
  dialog -m coloursprot coloursprot
}

dialog coloursprot {
  title "Channel Colours Protection Settings..."
  size -1 -1 309 207
  option pixels
  tab "Settings", 1, 5 74 297 101
  box "Colours Settings", 2, 14 99 279 61, tab 1
  button "Ok", 10, 228 179 75 22, ok
  text "Kick Message:", 4, 26 124 71 16
  edit "", 5, 99 120 181 23, autohs
  icon 3, -2 0 312 64, $scriptdir $+ libraries\icons\coloursprotheader.png, noborder
}

on *:dialog:coloursprot:init:0: {
  did -ar $dname 5 $hget(prot,colourskickmsg)
}

on *:dialog:coloursprot:sclick:10: {
  hadd prot colourskickmsg $did($dname,5)
}

alias advertprot {
  dialog -m advertprot advertprot
}

dialog advertprot {
  title "Channel Advert Protection Settings..."
  size -1 -1 309 205
  option pixels
  tab "Settings", 1, 5 72 297 101
  box "Advert Settings", 2, 14 98 279 60, tab 1
  button "Ok", 10, 228 177 75 22, ok
  text "Kick Message:", 4, 26 122 71 16
  edit "", 5, 99 118 181 23, autohs
  icon 3, -2 0 312 64, $scriptdir $+ libraries\icons\advertprotheader.png, noborder
}

on *:dialog:advertprot:init:0: {
  did -ar $dname 5 $hget(prot,advertkickmsg)
}

on *:dialog:advertprot:sclick:10: {
  hadd prot advertkickmsg $did($dname,5)
}

alias exmodes {
  dialog -m exmodes exmodes
}

dialog exmodes {
  title "Select Modes"
  size -1 -1 191 295
  option pixels
  tab "Modes", 1, 6 74 178 188
  check "q - (Owner)", 2, 54 124 100 20, tab 1
  check "a - (Admin)", 3, 54 145 100 20
  check "o - (Operator)", 4, 54 168 100 20
  check "h - (HalfOp)", 7, 54 189 100 20
  check "v - (Voiced)", 6, 54 211 100 20
  box "Select Modes", 5, 16 99 158 149
  button "OK", 8, 110 267 75 22, ok
  icon 9, -2 0 194 64, $scriptdir $+ libraries\icons\exmodesheader.png, noborder
}

on *:dialog:exmodes:init:0: {
  if (q isin $hget(prot,exmodes)) {
    did -c $dname 2
  }
  if (a isin $hget(prot,exmodes)) {
    did -c $dname 3
  }
  if (o isin $hget(prot,exmodes)) {
    did -c $dname 4
  }
  if (h isin $hget(prot,exmodes)) {
    did -c $dname 7
  }
  if (v isin $hget(prot,exmodes)) {
    did -c $dname 6
  }
}

on *:dialog:exmodes:sclick:8: {
  var %modes
  if ($did($dname,2).state == 1) {
    %modes = %modes $+ q
  }
  if ($did($dname,3).state == 1) {
    %modes = %modes $+ a
  }
  if ($did($dname,4).state == 1) {
    %modes = %modes $+ o
  }
  if ($did($dname,7).state == 1) {
    %modes = %modes $+ h
  }
  if ($did($dname,6).state == 1) {
    %modes = %modes $+ v
  }
  hadd prot exmodes %modes
  did -ar prot 49 %modes
}
