;---DCC SEND MANAGER by mr.man (c) 2006 (Part of NeXtGenIRC)---

;---VARIOUS ALIASES---

alias sm {
  dccman
}

alias dccman {
  if ($active ischan) {
    dialog -m dccman dccman
  }
}

alias -l queuefile {
  return $+(",$scriptdir,settings\queue.txt,")
}

;---DIALOG STUFF---

dialog dccman {
  title "DCC Send Manager"
  size -1 -1 318 431
  option pixels
  tab "DCC Send Manager", 1, 4 71 308 325
  text "Send Files To:", 5, 37 120 73 16, tab 1
  combo 6, 119 117 160 225, tab 1 sort size drop
  box "Send to User", 7, 14 97 288 55, tab 1
  box "Files To Send", 8, 14 155 288 226, tab 1
  list 9, 24 172 268 168, tab 1 size
  button "Add File(s)", 10, 25 347 95 22, tab 1
  button "Delete", 11, 125 347 81 22, tab 1
  button "Clear", 12, 210 347 80 22, tab 1
  button "Send", 2, 260 402 53 22
  button "OK", 3, 204 402 53 22, ok
  button "Cancel", 13, 148 402 54 22, cancel
  icon 4, -2 0 321 64, $scriptdir $+ libraries\icons\dccmheader.png, noborder
}

on *:dialog:dccman:init:0: {
  if ($exists($queuefile)) {
    var %l = 1
    while (%l <= $lines($queuefile)) {
      did -a $dname 9 $read($queuefile,%l)
      inc %l
    }
  }
  var %l = 1
  while (%l <= $nick($active,0)) {
    did -a $dname 6 $nick($active,%l)
    inc %l
  }
  did -c $dname 6 1
  did -f $dname 6
}

on *:dialog:dccman:sclick:2: {
  if ($exists($queuefile)) && ($lines($queuefile) > 0) {
    var %f = $read($queuefile,1)
    var %n = $did($dname,6).seltext
    theme.text $s.head(Sending file) $s.encleft $+ $s.value(%f) $s.encright $s.head(to) $s.encleft $+ $s.value(%n) $+ $s.encright
    dialog -x dccman
    dcc send %n %f
  }  
}

on *:dialog:dccman:sclick:10: {
  var %f = $msfile(C:\,Select Files to Send...,OK)
  if (%f) {
    write -c $queuefile
    var %l = 1
    while (%l <= %f) {
      did -a $dname 9 $msfile(%l)
      inc %l
    }
    var %l = 1
    while (%l <= $did($dname,9).lines) {
      write $queuefile $did($dname,9,%l)
      inc %l
    }
  }
}

on *:dialog:dccman:sclick:11: {
  var %t = $did($dname,9).sel
  if (%t) {
    did -d $dname 9 %t
    write -c $queuefile
    var %l = 1
    while (%l <= $did($dname,9).lines) {
      write $queuefile $did($dname,9,%l)
      inc %l
    }
  }
}

on *:dialog:dccman:sclick:12: {
  did -r $dname 9
  write -c $queuefile
}

;---EVENTS STUFF---

on *:filesent:*: {
  .timer 1 1 { theme.text $s.head(Successfully Sent file) $s.encleft $+ $s.value($nopath($filename)) $+ $s.encright $s.head(to) $s.encleft $+ $s.value($nick) $+ $s.encright $s.head(at) $s.encleft $+ $s.value($send($nick).cps $+ Cps) $+ $s.encright }
  var %f = $read($queuefile,1)
  hadd various uploaded $calc($hget(various,uploaded) + $send(-1).size)
  hinc various uploads
  if (%f == $filename) {
    write -dl1 $queuefile
  }
  if ($lines($queuefile) > 0) {
    var %f = $read($queuefile,1)
    var %n = $nick
    theme.text $s.head(Sending file) $s.encleft $+ $s.value(%f) $+ $s.encright $s.head(to) $s.encleft $+ $s.value(%n) $+ $s.encright
    dcc send %n %f
  }  
}

on *:filercvd:*.*: { 
  .timer 1 1 { theme.text $s.head(Successfully Received file) $s.encleft $+ $s.value($nopath($filename)) $+ $s.encright $s.head(from) $s.encleft $+ $s.value($nick) $+ $s.encright $s.head(size) $s.encleft $+ $s.value($bytes($get(-1).size,3).suf) $+ $s.encright $s.head(at) $s.encleft $+ $s.value($get($nick).cps $+ Cps) $+ $s.encright $s.head(Press Ctrl F12 to run.) }
  hadd various downloaded $calc($hget(various,downloaded) + $get(-1).size)
  hinc various downloads
  hadd various cf12 $filename
}

ctcp ^*:*:*: { 
  if ($1 == DCC) && ($2 == Send) && ($nick != $me) {
    theme.text $s.encleft $+ $s.value($nick) $+ $s.encright $s.head(at) $s.encleft $+ $s.value($address) $+ $s.encright $s.head(is trying to send you) $s.encleft $+ $s.value($gettok($1-,3- $calc($numtok($1-,32) - 3),32) $+ $s.encright $s.head(size) $s.encleft $+ $s.value($bytes($gettok($1-,$numtok($1-,32),32),3).suf)) $+ $s.encright $s.head(on port) $s.encleft $+ $s.value($gettok($1-,$calc($numtok($1-,32) - 1),32)) $+ $s.encright
  }
}
