;---NXG Wizards by mr.man (c) 2006 (Part of NeXtGenIRC)---

alias wizards {
  dialog -m wz_launcher wz_launcher
}

dialog wz_launcher {
  title "Wizard Launcher"
  size -1 -1 263 261
  option pixels
  tab "Wizards", 1, 4 73 253 155
  button "Add New Network Wizard...", 2, 35 123 183 25, tab 1
  button "Transfer Settings Wizard...", 4, 35 163 183 25, tab 1
  button "OK", 3, 183 233 75 22, ok
  icon 5, -2 0 266 64, $scriptdir $+ libraries\icons\wizardsheader.png, noborder
}

on *:dialog:wz_launcher:sclick:2: {
  wz_newnet
  dialog -x wz_launcher
}

on *:dialog:wz_launcher:sclick:4: {
  wz_transfer
  dialog -x wz_launcher
}

on *:dialog:wz_launcher:sclick:3: {
  dialog -v cpanel
}

;---NEW NETWORK WIZARD---

alias -l profileini {
  return $+(",$scriptdir,settings\profile.ini,")
}

alias wz_newnet {
  dialog -m wz_newnet wz_newnet
}

dialog wz_newnet {
  title "Add New Network Wizard"
  size -1 -1 374 303
  option pixels
  icon 1, 0 0 373 62, $shortfn($scriptdir $+ libraries\icons\logo.png)
  button "<< Back", 3, 244 271 60 22, disable
  button "Next >>", 4, 308 271 60 22, disable
  button "Cancel", 5, 180 271 60 22, cancel
  text "______________________________________________________________________", 2, 1 247 375 16, disable
  text "The nickname you enter will be used to generate your [a], [d] and [ad] nicknames. You can edit these later by going into the Control Panel, choose Profiles, and select the network name.", 6, 30 177 323 47, hide
  text "Please enter your Nickname:", 7, 45 125 144 16, hide
  edit "", 8, 192 120 136 23, hide
  text "The Network Name associates a Profile with a Network. If you are unsure about what your Network Name is, click the ? button and it will suggest the current Network Name you are connected to.", 9, 30 177 324 56, hide
  text "Please enter the Network Name:", 10, 19 125 158 16, hide
  edit "", 11, 180 120 144 23, hide
  button "?", 12, 329 121 22 21, hide
  text "Please enter a Server Address:", 13, 19 125 158 16, hide
  edit "", 14, 180 120 144 23, hide
  button "?", 15, 329 121 22 21, hide
  text "You must enter a Server Address (irc.dalnet.net for example). If you don't know what Server Address to enter, click the ? button and it will suggest the current server you're connected to.", 16, 30 177 321 56, hide
  text "Please enter your Nickserv Password:", 17, 21 141 187 16, hide
  edit "", 18, 211 136 144 23, pass, hide
  text "If the Network you are currently using has NickServ Services then check Yes above. Also please enter your Nickserv Password so you can be automatically identified on connection to the Network.", 19, 30 177 321 49, hide
  radio "Yes:", 20, 213 93 39 20, left, hide
  radio "No:", 21, 267 93 35 20, left, hide
  text "Network has NickServ Services...", 22, 41 96 166 16, hide
}

on *:dialog:wz_newnet:init:0: {
  wz_nn_network_show
  hadd various wz_newnet 1
  did -c $dname 20
  did -f $dname 11
}

on *:dialog:wz_newnet:sclick:3: {
  ;---BACK BUTTON---
  if ($hget(various,wz_newnet) == 3) {
    hdec various wz_newnet
    wz_nn_server_hide
    wz_nn_network_show
    did -b $dname 3
    if ($did($dname,11).text) {
      did -e $dname 4
    }
    else {
      did -b $dname 4
    }
  }
  if ($hget(various,wz_newnet) == 4) {
    hdec various wz_newnet
    wz_nn_nick_hide
    wz_nn_server_show
    did -e $dname 3
    if ($did($dname,14).text) {
      did -e $dname 4
    }
    else {
      did -b $dname 4
    }  
  }
  if ($hget(various,wz_newnet) == 5) {
    hdec various wz_newnet
    did -ar $dname 4 Next >>
    wz_nn_nickserv_hide
    wz_nn_nick_show
    did -e $dname 3
    if ($did($dname,8).text) {
      did -e $dname 4
    }
    else {
      did -b $dname 4
    }  
  }
}

on *:dialog:wz_newnet:sclick:4: {
  ;---NEXT BUTTON---
  if ($hget(various,wz_newnet) == 1) {
    if ($hget($did($dname,11).text)) {
      var %e = $input(Sorry... A Profile of this name already exists.,owu,Warning!,$null)
      did -b $dname 4
      did -r $dname 11
    }
    else {
      hmake $did($dname,11).text
      hadd various newprofile $did($dname,11).text
      hinc various wz_newnet
      wz_nn_network_hide
      wz_nn_server_show
      did -e $dname 3
      if (!$did($dname,14).text) {
        did -b $dname 4 
      }
    }
  }
  if ($hget(various,wz_newnet) == 2) {
    hinc various wz_newnet
    wz_nn_network_hide
    wz_nn_server_show
    did -e $dname 3
  }
  else if ($hget(various,wz_newnet) == 3) {
    hinc various wz_newnet
    wz_nn_server_hide
    wz_nn_nick_show
    did -ar $dname 4 Next >>
    if ($did($dname,8).text) {
      did -e $dname 4
    }
    else {
      did -b $dname 4
    }
    did -e $dname 3
  }
  else if ($hget(various,wz_newnet) == 4) {
    if ($did($dname,8).text) {
      did -b $dname 4
    }
    else {
      did -e $dname 4
    }
    did -e $dname 3
    hinc various wz_newnet
    wz_nn_nick_hide
    wz_nn_nickserv_show
    did -ar $dname 4 Finish
  }
  else if ($hget(various,wz_newnet) == 5) {
    var %p = $readini($profileini,Settings,Profiles), %np = $did($dname,11).text
    %p = $addtok(%p,%np,44)
    writeini $profileini Settings Profiles %p
    var %f = $+(",$scriptdir,profiles\,%np,.ini,"))
    hadd %np Nick $did($dname,8).text
    if ($did($dname,20).state == 1) {
      hadd %np NickServCommand /NickServ IDENTIFY <pass>
    }
    hadd %np NickServPass $did($dname,18).text
    hadd %np AwayNick $did($dname,8).text $+ $chr(91) $+ a $+ $chr(93)
    hadd %np DownNick $did($dname,8).text $+ $chr(91) $+ d $+ $chr(93)
    hadd %np AwayDownNick $did($dname,8).text $+ $chr(91) $+ ad $+ $chr(93)
    hadd %np BusyNick $did($dname,8).text $+ $chr(91) $+ <a> $+ $chr(93)
    hadd %np PreferredServer $did($dname,14).text
    hadd %np UsePreferred 1
    hadd %np AutoConnect 1
    hadd %np Serverlist $did($dname,14).text
    hadd %np PriCol 4
    hadd %np SecCol 14
    hsave -i %np %f
    dialog -x wz_newnet
  }
}

on *:dialog:wz_newnet:sclick:5: {
  ;---CANCEL BUTTON---
  if ($hget($hget(various,newprofile))) {
    hfree $hget(various,newprofile)
  }
}

on *:dialog:wz_newnet:edit:8: {
  if ($did($dname,8).text) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:wz_newnet:edit:11: {
  if ($did($dname,11).text) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:wz_newnet:sclick:12: {
  did -ar $dname 11 $network
  did -e $dname 4
}

on *:dialog:wz_newnet:edit:14: {
  if ($did($dname,14).text) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:wz_newnet:sclick:15: {
  did -ar $dname 14 $server
  did -e $dname 4
}

on *:dialog:wz_newnet:edit:18: {
  if ($did($dname,20).state == 1) {
    if ($did($dname,18).text) {
      did -e $dname 4
    }
    else {
      did -b $dname 4
    }
  }
  else {
    did -e $dname 4
  }
}

on *:dialog:wz_newnet:sclick:20: {
  if ($did($dname,20).state == 1) {
    if ($did($dname,18).text) {
      did -e $dname 4
    }
    else {
      did -b $dname 4
    }
  }
}

on *:dialog:wz_newnet:sclick:21: {
  if ($did($dname,21).state == 1) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

;---SHOW/HIDE ALIASES---

alias wz_nn_nick_show {
  did -v wz_newnet 6,7,8
}

alias wz_nn_nick_hide {
  did -h wz_newnet 6,7,8
}

alias wz_nn_network_show {
  did -v wz_newnet 9,10,11,12
}

alias wz_nn_network_hide {
  did -h wz_newnet 9,10,11,12
}

alias wz_nn_server_show {
  did -v wz_newnet 13,14,15,16
}

alias wz_nn_server_hide {
  did -h wz_newnet 13,14,15,16
}

alias wz_nn_nickserv_show {
  did -v wz_newnet 17,18,19,20,21,22
}

alias wz_nn_nickserv_hide {
  did -h wz_newnet 17,18,19,20,21,22
}

;---FIRST TIME USE WIZARD---

alias -l profileini {
  return $+(",$scriptdir,settings\profile.ini,")
}

alias wz_first {
  dialog -m wz_first wz_first
}

dialog wz_first {
  title "New User Wizard"
  size -1 -1 374 303
  option pixels
  icon 1, 0 0 373 62, $shortfn($scriptdir $+ libraries\icons\logo.png)
  button "<< Back", 3, 244 271 60 22, disable
  button "Next >>", 4, 308 271 60 22, disable
  button "Cancel", 5, 180 271 60 22, cancel
  text "______________________________________________________________________", 2, 1 247 375 16, disable
  text "The nickname you enter will be used to generate your [a], [d] and [ad] nicknames. You can edit these later by going into the Control Panel, choose Profiles, and select the network name.", 6, 29 174 323 47, hide
  text "Please enter your Nickname:", 7, 45 120 144 16, hide
  edit "", 8, 192 115 136 23, hide
  text "Welcome to NeXtGenIRC, a fully featured Script for mIRC. This wizard will guide you through the main things you need to set up before use. It will create a profile for the network you choose. You just need to personalize it with this wizard. Please be sure to complete the wizard or you will find things not as you would like.", 9, 9 71 357 87, hide
  text "Please enter your Nickserv Password:", 17, 21 141 187 16, hide
  edit "", 18, 211 136 144 23, pass, hide
  text "If the Network you are currently using has NickServ Services then check Yes above. Also please enter your Nickserv Password so you can be automatically identified on connection to the Network.", 19, 31 182 321 49, hide
  radio "Yes:", 20, 213 93 39 20, left, group, hide
  radio "No:", 21, 267 93 35 20, left, hide
  text "Network has NickServ Services...", 22, 41 96 166 16, hide
  text "You have successfully completed the Basic Setup... For other options please press f2 or select Control Panel from the popup menu. Here you will find many customizable settings, such as Themes, Sysinfo, Nick Completer and much more. To connect to a network, open the Profiles Setup, choose a Network and click 'Connect'. You need to set up a profile for each network you connect to. Thankyou and please enjoy the Script.", 23, 31 111 321 110, hide  
  edit "", 10, 88 171 216 25, hide
  edit "", 11, 88 206 216 25, hide
  text "Network:", 12, 35 176 50 16, hide
  text "Server:", 13, 35 209 50 16, hide
  button "...", 14, 308 171 29 23, hide
  button "...", 15, 308 206 29 23, hide
}

on *:dialog:wz_first:init:0: {
  wz_ft_welcome_show
  hadd various wz_first 1
  did -c $dname 20
  did -b $dname 4
}

on *:dialog:wz_first:sclick:3: {
  ;---BACK BUTTON---
  if ($hget(various,wz_first) == 2) {
    hdec various wz_first
    wz_ft_nick_hide
    wz_ft_welcome_show
    did -b $dname 3
    did -e $dname 4
  }
  if ($hget(various,wz_first) == 3) {
    hdec various wz_first
    wz_ft_nickserv_hide
    wz_ft_nick_show
    did -e $dname 3
    if ($did($dname,8).text) {
      did -e $dname 4
    }
    else {
      did -b $dname 4
    }  
  }
  if ($hget(various,wz_first) == 4) {
    hdec various wz_first
    wz_ft_info_hide
    wz_ft_nickserv_show
    did -ar $dname 4 Next >>
    if ($did($dname,18).text) {
      did -e $dname 4
    }
    else {
      did -b $dname 4
    }
  }
}

on *:dialog:wz_first:sclick:4: {
  ;---NEXT BUTTON---
  if ($hget(various,wz_first) == 1) {
    hinc various wz_first
    wz_ft_welcome_hide
    wz_ft_nick_show
    did -e $dname 3
    if ($did($dname,8).text) {
      did -e $dname 4
    }
    else {
      did -b $dname 4
    }
  }
  else if ($hget(various,wz_first) == 2) {
    hinc various wz_first
    wz_ft_nick_hide
    wz_ft_nickserv_show
    if ($did($dname,18).text) {
      did -e $dname 4
    }
    else {
      did -b $dname 4
    }
  }
  else if ($hget(various,wz_first) == 3) {
    hinc various wz_first
    wz_ft_nickserv_hide
    wz_ft_info_show
    did -ar $dname 4 Finish 
  }
  else if ($hget(various,wz_first) == 4) {
    var %np = $did($dname,10).text, %f = $+(",$scriptdir,profiles\,%np,.ini,"))
    if (!$hget(%np)) { hmake %np 10 }
    hadd %np Serverlist $did($dname,11).text
    hadd %np NickServPass $did($dname,18).text
    hadd %np NickServCommand /NickServ IDENTIFY <pass>
    hadd %np Nick $did($dname,8).text
    hadd %np AwayNick $did($dname,8).text $+ $chr(91) $+ a $+ $chr(93)
    hadd %np DownNick $did($dname,8).text $+ $chr(91) $+ d $+ $chr(93)
    hadd %np AwayDownNick $did($dname,8).text $+ $chr(91) $+ ad $+ $chr(93)
    hadd %np BusyNick $did($dname,8).text $+ $chr(91) $+ <a> $+ $chr(93)
    hadd %np PriCol 4
    hadd %np SecCol 14
    hsave -i %np %f Profile
    var %p = $readini($profileini,Settings,Profiles) $+ , $+ %np
    writeini $profileini Settings Profiles %p
    nick $did($dname,8).text
    var %s = $did($dname,11).text
    dialog -x wz_first
    server %s
  }
}

on *:dialog:wz_first:edit:8: {
  if ($did($dname,8).text) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:wz_first:edit:11: {
  if ($did($dname,11).text) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:wz_first:sclick:14: {
  select_network
  did -b $dname 14
}

on *:dialog:wz_first:sclick:15: {
  if ($did($dname,10) == $null) {
    noop $input(Sorry... You must Select a Network first.,owu,Warning!,$null)
    halt
  }
  else {
    select_server
    did -b $dname 15
  }
}

on *:dialog:wz_first:edit:18: {
  if ($did($dname,18).text) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:wz_first:sclick:20: {
  if ($did($dname,20).state == 1) {
    if ($did($dname,18).text) {
      did -e $dname 4
    }
    else {
      did -b $dname 4
    }
  }
}

on *:dialog:wz_first:sclick:21: {
  if ($did($dname,21).state == 1) {
    did -e $dname 4
  }
  else {
    did -b $dname 4
  }
}

;---SHOW/HIDE ALIASES---

alias wz_ft_welcome_show {
  did -v wz_first 9,10,11,12,13,14,15
  did -e $dname 4
}

alias wz_ft_welcome_hide {
  did -h wz_first 9,10,11,12,13,14,15
}

alias wz_ft_nick_show {
  did -v wz_first 6,7,8
}

alias wz_ft_nick_hide {
  did -h wz_first 6,7,8
}

alias wz_ft_nickserv_show {
  did -v wz_first 17,18,19,20,21,22
}

alias wz_ft_nickserv_hide {
  did -h wz_first 17,18,19,20,21,22
}

alias wz_ft_info_show {
  did -v wz_first 23
}

alias wz_ft_info_hide {
  did -h wz_first 23
}

;---SELECT NETWORK---

alias select_network {
  dialog -m select_network select_network 
}

dialog select_network {
  title "Select Network..."
  size -1 -1 152 157
  option pixels
  list 1, 9 7 135 113, size
  button "OK", 2, 66 127 75 22, ok
}

on *:dialog:select_network:init:0: {
  window -lh @list
  window -lhs @networks
  loadbuf -tservers @list servers.ini
  var %l = 1
  while (%l <= $line(@list,0)) {
    var %s = $gettok($gettok($line(@list,%l),1,58),2,61)
    if (!$fline(@networks,%s)) {
      aline @networks %s
    }
    inc %l
  }
  var %l = 1
  while (%l <= $line(@networks,0)) {
    did -a $dname 1 $line(@networks,%l)
    inc %l
  }
  window -c @networks
  window -c @list
}

on *:dialog:select_network:sclick:2: {
  did -ar wz_first 10 $did($dname,1).seltext
  did -e wz_first 14
}

;---SELECT SERVER---

alias select_server {
  dialog -m select_server select_server
}

dialog select_server {
  title "Select Server..."
  size -1 -1 240 157
  option pixels
  list 1, 7 7 229 113, size
  button "OK", 2, 158 127 75 22, ok
}

on *:dialog:select_server:init:0: {
  window -lh @list
  window -lhs @servers
  loadbuf -tservers @list servers.ini
  var %l = 1
  while (%l <= $line(@list,0)) {
    var %n = $gettok($gettok($line(@list,%l),1,58),2,61)
    if (%n == $did(wz_first,10)) {
      var %s = $gettok($line(@list,%l),3,58)
      aline @servers %s
    }
    inc %l
  }
  var %l = 1
  while (%l <= $line(@servers,0)) {
    did -a $dname 1 $line(@servers,%l)
    inc %l
  }
  window -c @servers
  window -c @list
}

on *:dialog:select_server:sclick:2: {
  did -ar wz_first 11 $did($dname,1).seltext
  did -e wz_first 15
  if ($did(wz_first,10) && $did(wz_first,11)) {
    did -e wz_first 4
  }
}

;---TRANSFER SETTINGS WIZARD---

alias wz_transfer {
  dialog -m wz_transfer wz_transfer
}

dialog wz_transfer {
  title "Transfer Settings Wizard"
  size -1 -1 374 303
  option pixels
  icon 1, 0 0 373 62, $shortfn($scriptdir $+ libraries\icons\logo.png), 0
  button "<< Back", 3, 244 271 60 22, disable
  button "Next >>", 4, 308 271 60 22, disable
  button "Cancel", 5, 180 271 60 22, cancel
  text "______________________________________________________________________", 2, 1 247 375 16, disable
  text "This wizard will transfer all your settings from an old version of NXG over to this new installation. This should ease the transition from an old version to a new version. ", 6, 22 175 328 47, hide
  text "Please enter your old installation Dir:", 7, 10 125 176 16, hide
  edit "", 8, 189 120 146 23, hide
  button "...", 12, 340 120 22 23, hide
  text "", 9, 36 124 300 16, hide
  text "Please wait while your settings are transferred...", 10, 36 100 261 16, hide
}

on *:dialog:wz_transfer:init:0: {
  mdx MarkDialog $dname
  mdx SetControlMDX $dname 9 Progressbar > $ctl
  wz_dir_show
  did -f $dname 8
}

on *:dialog:wz_transfer:sclick:4: {
  if (!$hget(various,transferred)) {
    if ($check_dir) {
      hadd various transferred 0
      wz_dir_hide
      wz_transfer_show
      did -b wz_transfer 4
      do_transfer
      did -ar $dname 10 Settings Transferred Successfuly
      did -ar $dname 4 Finish
      did -e $dname 4
      did -b $dname 5
    } 
    else {
      var %e = $input(This is not an mIRC directory.,owu,Warning!,$null)
      did -b $dname 4
      did -r $dname 8
      did -f $dname 8
    }
  }
  else {
    dialog -x $dname
    hadd various transferred 0
    var %f = $+(",$mircdir,welcome.txt,")
    var %m = $input(You need to restart NXG for your settings to take effect. $crlf Do you want to restart now?,iuy,Information,$null)
    .remove %f
    if (%m) {
      set %restart $true
      exit -rn
    }
  }
}

on *:dialog:wz_transfer:edit:8: {
  if ($isdir($did($dname,8).text)) {
    did -e $dname 4
    hadd various wz_transfer $did($dname,8).text
  }
  else {
    did -b $dname 4
  }
}

on *:dialog:wz_transfer:sclick:12: {
  var %f = $sdir(C:,Select Old NXG Directory)
  if (%f) {
    did -ar $dname 8 %f
  }
  if ($isdir(%f)) {
    hadd various wz_transfer %f
    did -e $dname 4
  }
}

;---SHOW/HIDE ALIASES---

alias wz_dir_hide {
  did -h wz_transfer 6,7,8,12
}

alias wz_dir_show {
  did -v wz_transfer 6,7,8,12
}

alias wz_transfer_hide {
  did -h wz_transfer 9,10
}

alias wz_transfer_show {
  did -v wz_transfer 9,10
}

;---TRANSFER FUNCTIONS---

alias -l check_dir {
  if ($hget(various,wz_transfer)) {
    if ($isfile($+(",$hget(various,wz_transfer),\,mirc.ini,"))) {
      return $true
    }
  } 
}

alias -l do_transfer {
  did -a wz_transfer 9 0 0 100
  var %t = $hget(various,wz_transfer)
  if ($isdir($+(",%t,\system\profiles,"))) {
    dll $+(",$mircdir,system\libraries\ftpd.dll,") copyfolder %t $+ \system\profiles $+ > $+ $scriptdir
    did -a wz_transfer 9 33
  }
  if ($isdir($+(",%t,\system\settings,"))) {
    dll $+(",$mircdir,system\libraries\ftpd.dll,") copyfolder %t $+ \system\settings $+ > $+ $scriptdir
    did -a wz_transfer 9 66
  }
  if ($isdir($+(",%t,\system\themes,"))) {
    dll $+(",$mircdir,system\libraries\ftpd.dll,") copyfolder %t $+ \system\themes $+ > $+ $scriptdir
    did -a wz_transfer 9 100
  }
  hadd various transferred 1
  set %f $readini($+(",$scriptdir,settings\mts.ini,"),Settings,theme_file)
  set %s $readini($+(",$scriptdir,settings\mts.ini,"),Settings,scheme)
  if (%s == Nil) { set %s 0 }
  theme.load $nopath(%f) %s
}
