;---XDCC Viewer by mr.man (c)2005 (Part of NeXtGenIRC)---;

;---MENU---

menu nicklist {
  XDCC List: { .msg $$1 xdcc list }
}

;---DIALOG STUFF---

dialog xdccget {
  title "XDCC Get..."
  size -1 -1 184 52
  option pixels
  text "Issuing CTCP Command to Bot...", 1, 12 19 170 16
}

on *:dialog:xdccget:init:0:{
  .timer 1 3 dialog -x xdccget
}

dialog xdccv {
  title "XDCC Viewer"
  size -1 -1 547 384
  option pixels
  tab "XDCC Servers", 2, 4 72 537 277
  box "Bots/Servers", 6, 13 223 152 112, tab 2
  box "Networks", 5, 13 97 152 122, tab 2
  list 1, 24 115 129 92, tab 2 size extsel
  box "Packs", 7, 174 97 358 238, tab 2
  list 3, 186 115 334 207, tab 2 size extsel
  list 4, 23 240 130 82, tab 2 size extsel
  tab "Search", 10
  box "Search", 11, 13 97 519 238, tab 10
  edit "", 12, 26 118 415 23, tab 10
  button "Search", 13, 447 119 70 21, tab 10
  list 14, 26 151 492 172, tab 10 size
  button "OK", 8, 467 355 75 22, ok
  icon 9, -2 0 550 64, $scriptdir $+ libraries\icons\xdccvheader.png, noborder
}

on *:dialog:xdccv:init:0:{
  mdx MarkDialog $dname
  mdx SetControlMDX 1 listview single rowselect showsel alignleft report noheader > $views
  did -i $dname 1 1 headerdims 120:1
  did -i $dname 1 1 headertext 0 Networks
  mdx SetControlMDX $dname 3 ListView report rowselect infotip single > $views
  did -i $dname 3 1 headerdims 40 210 60
  did -i $dname 3 1 headertext Pack $chr(9) Filename $chr(9) Size
  mdx SetControlMDX $dname 14 ListView report rowselect infotip single > $views
  did -i $dname 14 1 headerdims 60 60 50 240 60
  did -i $dname 14 1 headertext Network $chr(9) Bot $chr(9) Pack $chr(9) Filename $chr(9) Size
  var %total = $ini($+(",$scriptdir,xdccn.dat,"),1,0), %l = 1
  while (%l <= %total) {
    did -a $dname 1 + $readini($xdccn,Networks,%l)
    var %file = $readini($xdccn,Networks,%l) $+ .dat
    var %network = $readini($xdccn,Networks,%l)
    inc %l
  }
}

on *:dialog:xdccv:sclick:1:{
  if ($gettok($did($dname,1,1),1,32) == sclick) {
    var %w = @bots
    window -lhs %w
    did -r $dname 4
    var %network = $gettok($gettok($did(1).seltext,6,32),1,9)
    if (!%network) { halt }
    var %l = 1, %total = $hget(xdccv,0).item
    while (%l <= %total) {
      if (%network $+ * iswm $hget(xdccv,%l).item) {
        var %count = $numtok($hget(xdccv,%l).item,95) - 1
        var %name = $gettok($hget(xdccv,%l).item,2 - %count,95)
        if (!$didwm($dname,4,* $+ %name $+ *,1)) {
          aline -n %w %name
        }
      }
      inc %l
    }
    var %l = 1, %t = $line(%w,0)
    while (%l <= %t) {
      did -a $dname 4 $line(%w,%l)
      inc %l
    }
    window -c %w
  }
  if ($gettok($did($dname,1,1),1,32) == rclick) {
    xdccnetpop $did(1).sel $gettok($gettok($did(1).seltext,6,32),1,9)
  }
}

on *:dialog:xdccv:sclick:4:{
  did -r $dname 3
  var %network = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %bot = $did(xdccv,4).seltext
  var %l = 1, %total = $hget(xdccv,0).item, %y = 1
  while (%l <= %total) {
    if ($+(%network,_,%bot) $+ * iswm $hget(xdccv,%l).item) {
      var %name = $hget(xdccv,$+(%network,_,%bot,_,%y))
      did -a $dname 3 0 0 0 0 %y $chr(9) %name
      inc %y
    }
    inc %l
  }
}

on *:dialog:xdccv:dclick:3:{
  var %network = $gettok($gettok($did(1).seltext,6,32),1,9)
  var %bot = $did(xdccv,4).seltext
  var %l = 1
  while (%l <= $scon(0)) {
    if ($scon(%l).network == %network) {
      var %cid = %l
      break
    }
    inc %l
  }
  scon %cid .ctcp %bot xdcc send # $+ $calc($did($dname,3).sel - 1)
  dialog -m xdccget xdccget
}

on *:dialog:xdccv:sclick:13:{
  did -r $dname 14
  var %l = 1
  while ($hget(xdccv,%l).item) {
    var %item = $ifmatch, %value = $hget(xdccv,%item), %pack = $gettok(%item,$numtok(%item,95),95), %name = $gettok(%item,1- $+ $calc($numtok(%item,95) -1),95)
    if (* $+ $replace($did($dname,12),$chr(32),*) $+ * iswm %value) {
      did -a $dname 14 $gettok(%name,1,95) $chr(9) $gettok(%name,2,95) $chr(9) $gettok(%item,3,95) $chr(9) %value
    }
    inc %l
  }
}

on *:dialog:xdccv:dclick:14:{
  var %network = $gettok($gettok($did(xdccv,14).seltext,1,9),6,32)
  var %bot = $gettok($gettok($did(xdccv,14).seltext,2,9),5,32)
  var %pack = $gettok($gettok($did(xdccv,14).seltext,3,9),5,32)
  var %l = 1
  while (%l <= $scon(0)) {
    if ($scon(%l).network == %network) {
      var %cid = %l
      break
    }
    inc %l
  }
  scon %cid .ctcp %bot xdcc send # $+ %pack
  dialog -m xdccget xdccget
}

;---POPUPS---

alias xdccnetpop {
  popups New xdccnetpop 16 16
  popups SetMetrics xdccnetpop iconpad 0 0 contentpad 0 0 spacing 1 0
  popups AddItem xdccnetpop end + Flush $2 $cr flushthis $1 $2
  popups AddItem xdccnetpop end + Flush All $cr flushall
  popup xdccnetpop $mouse.dx $mouse.dy
}

alias flushthis {
  hdel -w xdccv $+($2,_,*,_*)
  remini $+(",$scriptdir,settings\xdccn.dat,") Networks $2-
  did -r xdccv 1,3,4
  var %total = $calc($ini($xdccn,1,0) + 1), %l = 1
  while (%l <= %total) {
    did -a xdccv 1 + $ini($xdccn,Networks,%l)
    inc %l
  }
}

alias flushall {
  write -c $xdccd
  write -c $xdccn
  hfree xdccv
  hmake xdccv 64
  did -r xdccv 1,3,4
}

;---ALIASES---

alias xdcc_refresh {
  if ($dialog(xdccv)) {
    var %cdid = $did(xdccv,1).sel
    did -r xdccv 1
    var %total = $ini($xdccn,1,0)
    var %l = 1
    while (%l <= %total) {
      did -a xdccv 1 $ini($xdccn,Networks,%l)
      var %file = $ini($xdccn,Networks,%l) $+ .dat
      var %network = $ini($xdccn,Networks,%l)
      inc %l
    }
    did -c xdccv 1 %cdid
  }
}

alias addpack {
  if (pack.* iswm $2) {
    hadd xdccv $+($network,_,$1,_,$gettok($2,2,46)) $3-
  }
  else {
    hadd xdccv $+($network,_,$1,_,$2) $3-
  }
  writeini -n $xdccn Networks $network 1
  xdcc_refresh
}

alias parsepack {
  tokenize 32 $strip($1-)
  var %format = .?* [*?*] *
  if (%format iswm $1-) {
    var %pack = $regex($1,^(.|)[0-9]+$), %file = $gettok($1-,2-,93), %size = $gettok($gettok($1-,1,93),2,91)
    if (%pack) {
      %pack = $remove($1,$chr(35))
      addpack $nick $+(pack.,%pack) $+(%file,$chr(9),$remove(%size,[,]))
    }
  }
  var %format = #?* [*?*] *
  if (%format iswm $1-) {
    var %pack = $regex($1,^(#|)[0-9]+$), %file = $gettok($1-,2-,93), %size = $gettok($gettok($1-,1,93),2,91)
    if (%pack) {
      %pack = $remove($1,$chr(35))
      addpack $nick $+(pack.,%pack) $+(%file,$chr(9),$remove(%size,[,]))
    }
  }
  var %format = #?* *?* *
  if (%format iswm $1-) {
    var %pack = $remove($1,$chr(35))
    if ($0 < 5) {
      var %file = $3
    }
    else {
      var %count = $numtok($3-,32) - 2, %file = $gettok($3-,$+(1-,%count),32)
    }
    var %size = $gettok($gettok($2,1,187),1,171)
    if (%pack) {
      addpack $nick $+(pack.,%pack) $+(%file,$chr(9),$remove(%size,[,]))
    }
  }
  var %format = [#*] (*x|*b) - *
  if (%format iswm $1-) {
    var %pack = $regex($1,^\[(#|)[0-9]+\]$)
    if (%pack) {
      %pack = $remove($1,[,],$chr(35))
      addpack $nick $+(pack.,%pack) $+($4-,$chr(9),$remove($gettok($2,2,124),$chr(41)))
    }
  }
}

alias xdccd {
  return $+(",$scriptdir,settings\xdccd.dat,")
}

alias xdccn {
  return $+(",$scriptdir,settings\xdccn.dat,")
}

; ---EVENTS---

on *:start: {
  hmake xdccv 64
  write -c $xdccd
  write -c $xdccn
  .timerxdcc 0 60 xdcc_refresh
}

on *:text:*:*: {
  noop $parsepack($1-)
}

on *:notice:*:*: { 
  noop $parsepack($1-)
}

on *:unload: {
  hfree xdccv
}

on *:disconnect: {
  if ($readini($xdccn,Networks,$network) == 1) {
    remini $xdccn Network $network
  }
}

on *:quit: {
  if ($hfind(xdccv,$+(*_,$nick,_*),1,w)) {
    hdel -w xdccv $+(*_,$nick,_*)
  }
}

on *:nick: {
  if ($hfind(xdccv,$+(*_,$nick,_*),1,w)) {
    hdel -w xdccv $+(*_,$nick,_*)
  }
}
